(* Copyright (c) 1994-2001, Enigon Software
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list
  of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this
  list of conditions and the following disclaimer in the documentation and/or
  other materials provided with the distribution.
- Neither the name of Enigon Software nor the names of its contributors may be
  used to endorse or promote products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-- end of licence --
Author: tfrey@enigon.com
Compiled version of Raily 2.0 can be found at http://www.enigon.com/museum *)
unit AboutDLG;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TAboutBox = class(TForm)
    Panel1: TPanel;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    OKButton: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Image1: TImage;
    Timer1: TTimer;
    Panel2: TPanel;
    PaintBox1: TPaintBox;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Shape1: TShape;
    Shape2: TShape;
    Image5: TImage;
    Image6: TImage;
    Label5: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { private declarations }
    MyBitMap: TBitmap;
    XPos:integer;
    Strs:TStringList;
    Actual:integer;
    procedure PrepareString(S:string);
    procedure NextString;
  public
    { public declarations }
  end;

var
  AboutBox: TAboutBox;

implementation

{$R *.DFM}

procedure TAboutBox.PrepareString(S:string);
var Nessie:boolean;
    Add:integer;
begin
  Nessie:=FALSE;
  MyBitMap.Canvas.Brush.Color:=clSilver;
  MyBitMap.Canvas.Pen.Color:=clSilver;
  MyBitMap.Canvas.Font.Name:='Arial';
  MyBitMap.Canvas.Font.Style:=[fsbold];
  MyBitMap.Canvas.Font.Height:=20;
  S:=TrimRight(S);
  if Length(S)>0 then begin
    Nessie:=S[Length(S)]='@'; if Nessie then Delete(S, Length(S), 1);
    case S[1] of
      '!': begin Delete(S, 1, 1); MyBitMap.Canvas.Font.Color:=clRed; end;
      '*': begin Delete(S, 1, 1); MyBitMap.Canvas.Font.Color:=clYellow; end;
      '%': begin Delete(S, 1, 1); MyBitMap.Canvas.Font.Color:=clBlue; end;
      '&': begin Delete(S, 1, 1); MyBitMap.Canvas.Font.Color:=clGreen; end;
    else MyBitMap.Canvas.Font.Color:=clBlack end;
  end else MyBitMap.Canvas.Font.Color:=clBlack;
  Add:=0; if Nessie then Add:=Image3.Width;
  MyBitMap.Width:=Image2.Width+10+MyBitMap.Canvas.TextWidth(S)+Add+10;
  MyBitMap.Canvas.Rectangle(0,0, MyBitMap.Width, MyBitMap.Height);
  MyBitMap.Canvas.TextOut(Image2.Width+10,(25-MyBitMap.Canvas.TextHeight(S)) DIV 2,S);
  MyBitMap.Canvas.Draw(0,0, Image2.Picture.Graphic);
  if Nessie then MyBitMap.Canvas.Draw(MyBitMap.Width-Add-10, 0, Image3.Picture.Graphic);
  XPos:=PaintBox1.Width;
end;

procedure TAboutBox.NextString;
begin
  if Actual<Strs.Count-1 then INC(Actual) else Actual:=0;
  if (Actual>=0) and (Actual<Strs.Count) then PrepareString(Strs[Actual])
                                         else PrepareString('**** Hello World ***');
end;

procedure TAboutBox.Timer1Timer(Sender: TObject);
begin
  Dec(XPos, 2);
  PaintBox1.Canvas.Draw(XPos,0, MyBitMap);
  if XPos<-MyBitMap.Width then NextString;
end;

procedure TAboutBox.Image1DblClick(Sender: TObject);
begin
  Actual:=Strs.Count;
  NextString;
  Timer1.Enabled:=TRUE;
end;

procedure TAboutBox.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Timer1.Enabled:=FALSE;
end;

procedure TAboutBox.FormCreate(Sender: TObject);
begin
  MyBitMap:=TBitmap.Create;
  MyBitMap.Height:=25;
  Strs:=TStringList.Create;
  try
    Strs.LoadFromFile('Cast.dat');
  except end;
end;


procedure TAboutBox.FormActivate(Sender: TObject);
begin
   Image6.Visible:=GetDeviceCaps(Canvas.Handle, COLORRES)<=8;
end;


end.




