(* Copyright (c) 1994-2001, Enigon Software
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list
  of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this
  list of conditions and the following disclaimer in the documentation and/or
  other materials provided with the distribution.
- Neither the name of Enigon Software nor the names of its contributors may be
  used to endorse or promote products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-- end of licence --
Author: tfrey@enigon.com
Compiled version of Raily 2.0 can be found at http://www.enigon.com/museum *)
unit DArcProperty;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Globals, RailyTypes, Math;

type
  TArcPropertyDLG = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Bevel1: TBevel;
    XL: TLabel;
    YL: TLabel;
    AL: TLabel;
    DL: TLabel;
    Bevel2: TBevel;
    RL: TLabel;
    XEdit: TEdit;
    YEdit: TEdit;
    AEdit: TEdit;
    DAEdit: TEdit;
    REdit: TEdit;
    TrackCBX: TCheckBox;
    XCurBTN: TBitBtn;
    YCurBTN: TBitBtn;
    ACurBTN: TBitBtn;
    Label1: TLabel;
    AddAngleEdit: TEdit;
    CenterRBT: TRadioButton;
    FirstRBT: TRadioButton;
    SecondRBT: TRadioButton;
    SpeedButton1: TSpeedButton;
    procedure XCurBTNClick(Sender: TObject);
    procedure YCurBTNClick(Sender: TObject);
    procedure ACurBTNClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { private-Deklarationen }
  public
    XCur:Double;
    YCur:Double;
    ACur:Double;

    P1, P2: TDoublePoint;
    W1, W2: Double;
    { public-Deklarationen }
  end;

var
  ArcPropertyDLG: TArcPropertyDLG;

implementation


{$R *.DFM}

procedure TArcPropertyDLG.XCurBTNClick(Sender: TObject);
begin
  XEdit.Text:=CommonMakeString(XCur);
end;

procedure TArcPropertyDLG.YCurBTNClick(Sender: TObject);
begin
  YEdit.Text:=CommonMakeString(-YCur);
end;

procedure TArcPropertyDLG.ACurBTNClick(Sender: TObject);
begin
  AEdit.Text:=CommonMakeString(ACur/Pi*180);
end;

procedure TArcPropertyDLG.SpeedButton1Click(Sender: TObject);
var A, B, C, D, R: TDoublePoint;
    Dist, si, co : Extended;
    Omega: Double;
const SehrWeit=1.0E12;
begin
  SinCos(W1+Pi/2, si, co); // uses only one Instruction -->2002: WOW!
  A.x:=P1.x+co*SehrWeit;
  A.y:=P1.y+si*SehrWeit;
  B.x:=P1.x-co*SehrWeit;
  B.y:=P1.y-si*SehrWeit;
  SinCos(W2+Pi/2, si, co);
  C.x:=P2.x+co*SehrWeit;
  C.y:=P2.y+si*SehrWeit;
  D.x:=P2.x-co*SehrWeit;
  D.y:=P2.y-si*SehrWeit;
  if EchtSchnitt(A, B, C, D, R) then begin
    try
      Dist:=Hypot(P2.x-R.x, P2.y-R.y);
      Omega:=Angle(A, B, C, D);
      if Omega>Pi/2 then Omega:=Pi-Omega;
      REdit.Text:=CommonMakeString(Dist);
      DAEdit.Text:=CommonMakeString(RadToDeg(FixedAngle(Omega)));
    except
    end;
  end else begin
    // No intersection
  end;
end;

end.
