(* Copyright (c) 1994-2001, Enigon Software
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list
  of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this
  list of conditions and the following disclaimer in the documentation and/or
  other materials provided with the distribution.
- Neither the name of Enigon Software nor the names of its contributors may be
  used to endorse or promote products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-- end of licence --
Author: tfrey@enigon.com
Compiled version of Raily 2.0 can be found at http://www.enigon.com/museum *)
unit DLineProperty;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, ColorGrd, Globals;

type
  TLinePropertyDLG = class(TForm)
    Bevel1: TBevel;
    TrackCBX: TCheckBox;
    XEdit: TEdit;
    XL: TLabel;
    YL: TLabel;
    YEdit: TEdit;
    AL: TLabel;
    AngleEdit: TEdit;
    LL: TLabel;
    LengthEdit: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    MiddleOrientCBX: TCheckBox;
    Bevel2: TBevel;
    XCurBTN: TBitBtn;
    YCurBTN: TBitBtn;
    ACurBTN: TBitBtn;
    Label1: TLabel;
    AddAngleEdit: TEdit;
    procedure XCurBTNClick(Sender: TObject);
    procedure YCurBTNClick(Sender: TObject);
    procedure ACurBTNClick(Sender: TObject);
  private
    { private declarations }
  public
    XCur:Double;
    YCur:Double;
    ACur:Double;
    { public declarations }
  end;

var
  LinePropertyDLG: TLinePropertyDLG;

implementation

{$R *.DFM}

procedure TLinePropertyDLG.XCurBTNClick(Sender: TObject);
begin
  XEdit.Text:=CommonMakeString(XCur);
end;

procedure TLinePropertyDLG.YCurBTNClick(Sender: TObject);
begin
  YEdit.Text:=CommonMakeString(-YCur);
end;

procedure TLinePropertyDLG.ACurBTNClick(Sender: TObject);
begin
  AngleEdit.Text:=CommonMakeString(-ACur/Pi*180);
end;

end.
