(* Copyright (c) 1994-2001, Enigon Software
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list
  of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this
  list of conditions and the following disclaimer in the documentation and/or
  other materials provided with the distribution.
- Neither the name of Enigon Software nor the names of its contributors may be
  used to endorse or promote products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-- end of licence --
Author: tfrey@enigon.com
Compiled version of Raily 2.0 can be found at http://www.enigon.com/museum *)
unit Elementeditor;

// 13.10.1997 Added Scale-Paste (Ctrl/Alt/Shift - Paste Button or Ctrl+V+(Alt/Shift) or menu)


interface
                          
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Buttons, ExtCtrls, Elemente, Menus,
  GeneralConstants, StdCtrls, Clipbrd, RailyTypes, Globals, ImportTypes, Modules,
  PrintPreview, Math, ImgList;

// Edit states
const   InitialState   =  0;
        SelectElState  =  1;
        RectSelState   =  10;
        MovEdPointState=  20;
        SelectPtState  =  2;
        DragState      =  3;
        RotateState    =  4;

type
  TElEd = class(TForm)
    Panel1: TPanel;
    ElTree: TTreeView;
    Planscroll: TScrollBox;
    Plan: TPaintBox;
    ZoomInBTN: TSpeedButton;
    ZoomOutBtn: TSpeedButton;
    ShowAllBtn: TSpeedButton;
    StatusBar1: TStatusBar;
    TrashBtn: TSpeedButton;
    ElEdPlanPopUp: TPopupMenu;
    ElDeleteM: TMenuItem;
    ElPropertyM: TMenuItem;
    ElEdNewM: TMenuItem;
    ElEdTreePop: TPopupMenu;
    ElLockM: TMenuItem;
    ElGroupM: TMenuItem;
    ElUngroupM: TMenuItem;
    ElEdNewCircM: TMenuItem;
    ElEdNewLineM: TMenuItem;
    N1: TMenuItem;
    ElEdEditM: TMenuItem;
    ElEdCutM: TMenuItem;
    ElEdPasteM: TMenuItem;
    ElEdCopyM: TMenuItem;
    ElEdCopyAtomBTN: TSpeedButton;
    ElEdPasteAtomBTN: TSpeedButton;
    ElEdCutAtomBTN: TSpeedButton;
    NewLineAtomBTN: TSpeedButton;
    NewCSegAtomBTN: TSpeedButton;
    CheckBox1: TCheckBox;
    ToolbarXMover: TPanel;
    ToolbarYMover: TPanel;
    HauptPanel: TPanel;
    DummyTree: TTreeView;
    TabControl: TPageControl;
    VisualTab: TTabSheet;
    DataTab: TTabSheet;
    NameEdit: TEdit;
    EditmoduleInfo1: TMenuItem;
    ExportModule1: TMenuItem;
    XMASSaveDLG: TSaveDialog;
    Label1: TLabel;
    RemarkEdit: TEdit;
    Label2: TLabel;
    ModNameEdit: TEdit;
    Bevel1: TBevel;
    Label3: TLabel;
    ConnectNrEdit: TEdit;
    GroupBox1: TGroupBox;
    GeradeRBT: TRadioButton;
    KurveRBT: TRadioButton;
    WeicheRBT: TRadioButton;
    KreuzungRBT: TRadioButton;
    KreuzweicheRBT: TRadioButton;
    SpecialRBT: TRadioButton;
    TransElementRBT: TRadioButton;
    TransToCombo: TComboBox;
    NewElement1: TMenuItem;
    DeleteElement1: TMenuItem;
    NewCnctAtomBTN: TSpeedButton;
    Connector1: TMenuItem;
    Savemodule1: TMenuItem;
    NewModule1: TMenuItem;
    RemarkLabel: TLabel;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    LengthEdit: TEdit;
    AngleEdit: TEdit;
    RadiusEdit: TEdit;
    ElEdOptions: TSpeedButton;
    UndoBTN: TSpeedButton;
    UndoTextBTN: TSpeedButton;
    PrintBTN: TSpeedButton;
    FlexElementRBT: TRadioButton;
    LFlexRBT: TRadioButton;
    ConvertModule: TSpeedButton;
    OpenConvert: TOpenDialog;
    ImageList1: TImageList;
    MirrorXBTN: TSpeedButton;
    MirrorYBTN: TSpeedButton;
    RotateBTN: TSpeedButton;
    DeltaAngleEdit: TEdit;
    PolygonBTN: TSpeedButton;
    PolyAddVertex: TSpeedButton;
    PolyDelVertex: TSpeedButton;
    PolyBorderCol: TSpeedButton;
    BorderColDLG: TColorDialog;
    PolyContentCol: TSpeedButton;
    MoveDownBTN: TSpeedButton;
    MoveUpBTN: TSpeedButton;
    Marmor: TImage;
    Stretchpaste1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure PlanPaint(Sender: TObject);
    procedure ZoomInBTNClick(Sender: TObject);
    procedure ZoomOutBtnClick(Sender: TObject);
    procedure PlanMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure ShowAllBtnClick(Sender: TObject);
    procedure TrashBtnClick(Sender: TObject);
    procedure PlanMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure PlanMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: integer);
    procedure ElTreeChange(Sender: TObject; Node: TTreeNode);
    procedure ElEdPlanPopUpPopup(Sender: TObject);
    procedure ElLockMClick(Sender: TObject);
    procedure ElGroupMClick(Sender: TObject);
    procedure ElUngroupMClick(Sender: TObject);
    procedure ElEdCopyAtomBTNClick(Sender: TObject);
    procedure ElEdCutAtomBTNClick(Sender: TObject);
    procedure NewLineAtomBTNClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ToolbarXMoverMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure ToolbarXMoverMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: integer);
    procedure ToolbarXMoverMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure ToolbarYMoverMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure ToolbarYMoverMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: integer);
    procedure ToolbarYMoverMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure ElTreeExpanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: boolean);
    procedure ElPropertyMClick(Sender: TObject);
    procedure ExportModule1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure TransElementRBExit(Sender: TObject);
    procedure NewCSegAtomBTNClick(Sender: TObject);
    procedure RemarkEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure NewElement1Click(Sender: TObject);
    procedure ElEdTreePopPopup(Sender: TObject);
    procedure DeleteElement1Click(Sender: TObject);
    procedure NewCnctAtomBTNClick(Sender: TObject);
    procedure Savemodule1Click(Sender: TObject);
    procedure NewModule1Click(Sender: TObject);
    procedure ElEdOptionsClick(Sender: TObject);
    procedure UndoBTNClick(Sender: TObject);
    procedure UndoTextBTNClick(Sender: TObject);
    procedure PrintBTNClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure EditmoduleInfo1Click(Sender: TObject);
    procedure ConvertModuleClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ElTreeKeyPress(Sender: TObject; var Key: Char);
    procedure MirrorXBTNClick(Sender: TObject);
    procedure MirrorYBTNClick(Sender: TObject);
    procedure RotateBTNClick(Sender: TObject);
    procedure PolygonBTNClick(Sender: TObject);
    procedure PolyDelVertexClick(Sender: TObject);
    procedure PolyAddVertexClick(Sender: TObject);
    procedure PolyBorderColClick(Sender: TObject);
    procedure PolyContentColClick(Sender: TObject);
    procedure MoveDownBTNClick(Sender: TObject);
    procedure MoveUpBTNClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure ElTreeEdited(Sender: TObject; Node: TTreeNode;
      var S: string);
    procedure ElTreeEditing(Sender: TObject; Node: TTreeNode;
      var AllowEdit: boolean);
    procedure ElEdPasteAtomBTNMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: integer);
    procedure ElEdPasteMClick(Sender: TObject);
    procedure Stretchpaste1Click(Sender: TObject);
  private
    IsSaved         : boolean;
    EditingModule   : string;
    EditingElement  : string;
    EditingNode     : TTreeNode;

    EditState       : integer;
    PosKey1, PosKey2: TDoublePoint;  // if the User presses "1" or "2" the position
    AngKey1, AngKey2: Double;        // of the cursor is saved for later use

    UndoList        : TList;
    EditPoints      : TList;
    SelEdPoint      : integer;

    FixPoints,
    ObjectPoints    : TList;
    DragingPoint    : TDoublePoint;

    XSpace, YSpace  : Double;
    Zoomfactor      : Double;
    Element         : TElement;
    PA, PB          : TDoublePoint;

    Selected        : TBits;
    FirstPoint,
    SecondPoint     : TPoint;
    MouseStartPos   : TDoublePoint;

    CursorPos       : TDoublePoint;
    CursorAngle     : Double;

    CopyStream      : TMemoryStream;
    CopyScale       : Double; // 2.01 conains Scale of source module

    ToolbarXResizing: boolean;
    ToolbarYResizing: boolean;
    DrawInfo        : TDrawInfo;

    ManufacturerNodes: TStringList; // To Speedup Creation of the Tree

    procedure Undo;
    procedure SaveContext;
    procedure ClearUndoList;
    function CanUndo:boolean;

    function ShowAllFactor:Double;
    procedure EnableButtons(X:boolean);
    { private-Deklarationen }
  public
    procedure CenterToPos(P:TDoublePoint);
    function GetCenterPos:TDoublePoint;
    procedure DrawElements;
    procedure DrawCursor;
    function CountSelected:longint;
    procedure ClearSelection;
    procedure CopySelection;
    procedure PasteSelection(f:Double); //2.01 Added factor f
    procedure DeleteSelection;
    procedure FillTreeWithModules;
    procedure FillInModule(ModName:string);
    procedure FillTreeWithRailsFrom(ModName:string);
    procedure Rearrange;
    procedure ActualizeData;
    procedure SetDrawInfo;
    procedure NewLine;
    procedure NewArc;
    procedure NewConnector;
    procedure ActualizeEditIcons;
    function CanClose:boolean;
    procedure AdjustTreeImage(XTemp:TTreeNode; M:TModule);
    procedure SaveModule(Name:string);
    procedure ShowAll;
    procedure PlanGetBounds(var UL, DR: TDoublePoint);
    procedure PlanDruckerAusgabe(X:TCanvas; xs, ys, xf, yf:Double; BW:boolean);
    function FindTreeEntry(N:string; X:TTreeNode; var Where:TTreeNode):boolean;
    procedure LiteModule(N:string);
// New
    procedure SilentUpdate;
    procedure ElementSelected;
    procedure ClearTPointList(var X:TList);
    function CheckDragablePoints(X, Y:integer; Points:TList; var Nr:integer):boolean;
    procedure DrawDragablePoints(Points:TList; Selected:integer);
    function ToPlanCoordinates(X, Y:integer):TDoublePoint;
    procedure AdjustElement(TouchedNr:integer; Shift:TShiftState);
    procedure XORDrawSelected;
    function PointToGridPoint(X:TDoublePoint):TDoublePoint;
    procedure GetRectAroundSelection(var A, B:TDoublePoint);
    procedure AddInterestingPoints(Points:TList; Invert:boolean);
    function MapToPointList(Points:TList; Point:TDoublePoint; Tol:Double; Always:boolean):TDoublePoint;
    procedure AddAllCuts(PL:TList);
    procedure GetVisibleRect(var TL, DR:TDoublePoint);
    procedure DrawGrid;
    procedure ImplementChange(Node: TTreeNode; Force:boolean);
    procedure PasteNormal; //2.01
    procedure StretchPaste;//2.01


   { public-Deklarationen }
  end;

var
  ElEd: TElEd;

implementation

uses DLineProperty, DArcProperty, ElementNameDialog, DCnctProperty,
  NewModuleDialog, MainUnit, OptionsDialog, QueryDoubleDLG;

const ManufacturerLevel=0;
      ObjectLevel=1;
      ElementLevel=2;

      InActiveIMG=1;
      ActiveIMG=2;
      InActiveSelectedIMG=3;
      ActiveSelectedIMG=4;

      GeradeIMG=5;
      KurveIMG=6;
      WeicheIMG=7;
      KreuzungIMG=8;
      KreuzWeichIMG=9;
      SpecialIMG=10;
      TransIMG=11;
      OtherIMG=12;
const PointRectSize=5;


{$R *.DFM}

procedure TElEd.FormCreate(Sender: TObject);
begin
  Element:=TElement.Create;
  Plan.Width:=Planscroll.Width-2;
  Plan.Height:=Planscroll.Height-2;
  Selected:=TBits.Create;
  Selected.Size:=Element.BasicElements.Count;
  CopyStream:=TMemoryStream.Create;
  TrashBtn.Enabled:=False;
  ElEdCopyAtomBTN.Enabled:=False;
  ElEdCutAtomBTN.Enabled:=False;
  ToolbarXResizing:=False;
  ToolbarYResizing:=False;
  //Create A cache To improve speed of the TTreeView-Creation
  ManufacturerNodes:=TStringList.Create;
  ManufacturerNodes.Sorted:=True;
  ManufacturerNodes.Duplicates:=DupIgnore;
  Zoomfactor:=1;
  FillTreeWithModules;
  IsSaved:=True;
  EditingNode:=NIL;
  UndoList:=TList.Create;
  EditPoints:=TList.Create;
  FixPoints:=TList.Create;
  ObjectPoints:=TList.Create;
  TabControl.Hide;
  EnableButtons(False);
end;

procedure TElEd.FormDestroy(Sender: TObject);
begin
  Element.Free;
  Selected.Free;
  CopyStream.Free;
  ManufacturerNodes.Free;
  ClearUndoList;
  UndoList.Free;
end;

procedure TElEd.Undo;
var TempStream:TStream;
    TempInfo:TElementInfo;
begin
  if CanUndo  and Assigned(UndoList.Items[UndoList.Count-1])then begin
    TempInfo:=Element.Info;
    Element.Free;
    Element:=TElement.Create;
    Element.Info:=TempInfo;
    TempStream:=UndoList.Items[UndoList.Count-1];
    Element.GraphicsFromStream(TempStream);
    TempStream.Free;
    UndoList.Delete(UndoList.Count-1);
    UndoList.Pack;
    Selected.Size:=Element.BasicElements.Count;
    ClearSelection;
    ElementSelected;
  end;
  UndoBTN.Enabled:=CanUndo;
end;

procedure TElEd.SaveContext;
var TempStream:TStream;
begin
  IsSaved:=False;
  TempStream:=TMemoryStream.Create;
  Element.GraphicsToStream(TempStream);
  TempStream.Seek(0, 0); // Rewind
  while (UndoList.Count>=GlobalElEdMaxUndo) and (CanUndo) do begin
    if Assigned(UndoList.Items[0]) then TStream(UndoList.Items[0]).Free;
    UndoList.Delete(0);
    UndoList.Pack;
  end;
  UndoList.Add(TempStream);

  UndoBTN.Enabled:=CanUndo;
end;

procedure TElEd.ClearUndoList;
begin
  while CanUndo do begin
    if Assigned(UndoList.Items[0]) then TStream(UndoList.Items[0]).Free;
    UndoList.Delete(0);
  end;
  UndoList.Pack;
  UndoBTN.Enabled:=CanUndo;
end;

// function CanUndo makes the code easier To read
function TElEd.CanUndo:boolean;
begin
  Result:=UndoList.Count>0;
end;

procedure TElEd.Rearrange;
begin
// Rearrange Info-Sheet
  ModNameEdit.Width:=TabControl.Width-100;
  NameEdit.Width:=TabControl.Width-100;
  RemarkEdit.Width:=TabControl.Width-100;
end;

procedure TElEd.ActualizeData;
var S:string;
begin
  ModNameEdit.Text:=EditingModule;
  NameEdit.Text:=EditingElement;
  RemarkEdit.Text:=StrPas(Element.Info.Remark);
  ConnectNrEdit.Text:=IntToStr(Element.GetNrOfConnectors);
  TransToCombo.Text := '';
  case Element.Info.TheType of
     Gerade                 : GeradeRBT.Checked := True;
     Kurve                  : KurveRBT.Checked := True;
     Weiche                 : WeicheRBT.Checked := True;
     Kreuzung               : KreuzungRBT.Checked := True;
     Kreuzungsweiche        : KreuzweicheRBT.Checked := True;
     Spezialelement         : SpecialRBT.Checked := True;
     FlexElement            : FlexElementRBT.Checked := True;
     LengthFlex             : LFlexRBT.Checked := True;
     UebergangsStueck       : begin
                                TransElementRBT.Checked := True;
                                TransToCombo.Text := StrPas(Element.Info.Uebergang);
                              end;
  end;
  Str(Element.Info.TheRadius:1:2, S);RadiusEdit.Text:=S;
  Str(Element.Info.TheLength:1:2, S);LengthEdit.Text:=S;
  Str(Element.Info.TheAngle:1:2, S);AngleEdit.Text:=S;
end;


procedure TElEd.FormResize(Sender: TObject);
begin
  if Plan.Width<Planscroll.Width-2 then Plan.Width:=Planscroll.Width-2;
  if Plan.Height<Planscroll.Height-2 then Plan.Height:=Planscroll.Height-2;
  Rearrange;
end;

procedure TElEd.DrawElements;
var i:longint;
begin
  for i:=0 To Element.BasicElements.Count-1 do begin
    DrawInfo.Selected:=Selected[i];
    if Selected[i] then Element.SingleDraw(Plan.Canvas, XSpace, YSpace, 0, Zoomfactor, Zoomfactor, clRed, i, @DrawInfo)
                   else Element.SingleDraw(Plan.Canvas, XSpace, YSpace, 0, Zoomfactor, Zoomfactor, clBlack, i, @DrawInfo)
  end;
end;

procedure TElEd.DrawCursor;
var OldMode  : TPenMode;
    OldBS    : TBrushStyle;
    P        : TPoint;
    OldC     : TColor;
begin

  OldC:=Plan.Canvas.Pen.Color;
  Plan.Canvas.Pen.Color:=clGreen;

  P.X:=Round((CursorPos.X+XSpace)*Zoomfactor);
  P.Y:=Round((CursorPos.Y+YSpace)*Zoomfactor);
  OldMode:=Plan.Canvas.Pen.Mode;
  Plan.Canvas.Pen.Mode:=pmNotxor;
  OldBS:=Plan.Canvas.Brush.Style;
  Plan.Canvas.Brush.Style:=bsClear;
  Plan.Canvas.Ellipse(P.X-5, P.Y-5, P.X+5, P.Y+5);

  Plan.Canvas.MoveTo(P.X, P.Y);
  Plan.Canvas.LineTo(Round(P.X+5*Cos(CursorAngle)), Round(P.Y+5*Sin(CursorAngle)));

//  Plan.Canvas.Rectangle(P.X-2, P.Y-2, P.X+2, P.Y+2);

  Plan.Canvas.Brush.Style:=OldBS;
  Plan.Canvas.Pen.Mode:=OldMode;
  Plan.Canvas.Pen.Color:=OldC;
end;

procedure TElEd.PlanPaint(Sender: TObject);
begin
  if GlobalElEdGridShow then DrawGrid;
  if ElEdChanged then begin SetDrawInfo; Plan.Invalidate; ElEdChanged:=False end;
  DrawElements;
  DrawCursor;
  DrawDragablePoints(EditPoints, SelEdPoint);
end;

procedure TElEd.CenterToPos(P:TDoublePoint);
begin
  Planscroll.HorzScrollBar.position:=Round((P.X+XSpace)*Zoomfactor)-(Planscroll.Width DIV 2);
  Planscroll.VertScrollBar.position:=Round((P.Y+YSpace)*Zoomfactor)-(Planscroll.Height DIV 2);
  Plan.Invalidate;
end;

function TElEd.GetCenterPos:TDoublePoint;
begin
  Result.X:=(Planscroll.HorzScrollBar.position+Planscroll.Width DIV 2)/Zoomfactor-XSpace;
  Result.Y:=(Planscroll.VertScrollBar.position+Planscroll.Height DIV 2)/Zoomfactor-YSpace;
end;

function TElEd.CountSelected:longint;
var i:longint;
begin
  Result:=0;
  for i:=Element.BasicElements.Count-1 downto 0 do Inc(Result, Ord(Selected[i]));
end;

procedure TElEd.ZoomInBTNClick(Sender: TObject);
var P:TDoublePoint;
begin
  P:=GetCenterPos;
  if Zoomfactor<10E4 then Zoomfactor:=Zoomfactor*1.1;
  XSpace:=-PA.X+(((ABS(PB.X-PA.X)*Zoomfactor)+2*Planscroll.Width)/Zoomfactor-(PB.X-PA.X))/2;
  YSpace:=-PA.Y+(((ABS(PB.Y-PA.Y)*Zoomfactor)+2*Planscroll.Height)/Zoomfactor-(PB.Y-PA.Y))/2;
  Plan.Width:=Round(ABS(PB.X-PA.X)*Zoomfactor)+2*Planscroll.Width;
  Plan.Height:=Round(ABS(PB.Y-PA.Y)*Zoomfactor)+2*Planscroll.Height;
  CenterToPos(P);
end;

procedure TElEd.ZoomOutBtnClick(Sender: TObject);
var P:TDoublePoint;
begin
  P:=GetCenterPos;
  if Zoomfactor>10E-5 then Zoomfactor:=Zoomfactor*0.9;
  XSpace:=-PA.X+(((ABS(PB.X-PA.X)*Zoomfactor)+2*Planscroll.Width)/Zoomfactor-(PB.X-PA.X))/2;
  YSpace:=-PA.Y+(((ABS(PB.Y-PA.Y)*Zoomfactor)+2*Planscroll.Height)/Zoomfactor-(PB.Y-PA.Y))/2;
  Plan.Width:=Round(ABS(PB.X-PA.X)*Zoomfactor)+2*Planscroll.Width;
  Plan.Height:=Round(ABS(PB.Y-PA.Y)*Zoomfactor)+2*Planscroll.Height;
  CenterToPos(P);
end;

function TElEd.ShowAllFactor:Double;
var xs,ys:Double;
begin
  xs:=1; ys:=1;
  Element.GetRectAround0(PA, PB);
  if (Planscroll.Width>25) and (ABS(PB.X-PA.X)>0) then xs:=(Planscroll.Width-25)/ABS(PB.X-PA.X);
  if (Planscroll.Height>25) and (ABS(PB.Y-PA.Y)>0) then ys:=(Planscroll.Height-25)/ABS(PB.Y-PA.Y);
  if xs<ys then Result:=xs else Result:=ys;
end;

procedure TElEd.ShowAll;
begin
  Zoomfactor:=ShowAllFactor;
  XSpace:=10/Zoomfactor-PA.X+((Planscroll.Width-25-(PB.X-PA.X)*Zoomfactor)/2)/Zoomfactor;
  YSpace:=10/Zoomfactor-PA.Y+((Planscroll.Height-25-(PB.Y-PA.Y)*Zoomfactor)/2)/Zoomfactor;
  Plan.Width:=Planscroll.Width-5;
  Plan.Height:=Planscroll.Height-5;
  Plan.Invalidate;
end;

procedure TElEd.ShowAllBtnClick(Sender: TObject);
begin
  ShowAll;
end;

procedure TElEd.PlanMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
var Hit : boolean;
    i, j : integer;
    R:longint;
    Finished:boolean;
    OldMode  : TPenMode;

begin
  DrawCursor;
  CursorPos.X:=X/Zoomfactor-XSpace;
  CursorPos.Y:=Y/Zoomfactor-YSpace;
  if not (ssShift in Shift) then Element.UseGravity(CursorPos, CursorAngle, GlobalElEdGRange);
  DrawCursor;

  if Button=mbLeft then begin
    Finished:=False;
    repeat
      case EditState of
        InitialState:
          begin
            if CheckDragablePoints(X, Y, EditPoints, SelEdPoint) then begin
              EditState:=MovEdPointState;
            end else begin
              // is an Element Hit ?
              Hit:=Element.ElementHit(X, Y, XSpace, YSpace, 0, Zoomfactor, Zoomfactor, R, @DrawInfo);
              // Ctrl is not pressed. unselect all elements;
              if not (ssCtrl in Shift) then ClearSelection;
              if Hit then begin
                // if Ctrl is down Invert selection else set To True. Following line dows this.
                Selected[R]:=not Selected[R];
                DrawDragablePoints(EditPoints, SelEdPoint);
                ElementSelected;
                DrawDragablePoints(EditPoints, SelEdPoint);
                SilentUpdate; // Hack
                if (TBasicAtom(Element.BasicElements.Items[R]).EditState and CAtomEdLk = 0) then
                  EditState:=SelectElState;
                Finished:=True; // nothing more To do
              end else EditState:=RectSelState;
              SilentUpdate;
            end;
          end;
        MovEdPointState:
          begin
            SaveContext;
            Plan.Invalidate;
            XORDrawSelected;
            Finished:=True;
          end;
        RectSelState  :
          begin // Clicked into empty space --> Draw A Rectangle
            FirstPoint.X:=X;
            FirstPoint.Y:=Y;
            SecondPoint:=FirstPoint;

            DrawDragablePoints(EditPoints, SelEdPoint);
            ClearTPointList(EditPoints);

            Finished:=True;
          end;
        SelectElState :
          begin
            if CheckDragablePoints(X, Y, EditPoints, SelEdPoint) then begin
              EditState:=MovEdPointState;
              Finished:=False;
            end else begin
              if not (ssCtrl in Shift) then begin
                // Check whether an already Hit Element is Hit again
                Hit:=False;
                for j:=0 To Element.BasicElements.Count-1 do Hit:=Hit or (Selected[j]
                       and Element.IsHitElementNr(X, Y, XSpace, YSpace, 0, Zoomfactor, Zoomfactor, j, @DrawInfo));
                if Hit then begin
                  EditState:=DragState;
                  DrawDragablePoints(EditPoints, SelEdPoint);
                  ClearTPointList(EditPoints);
                 end
                 else EditState:=InitialState;  // not Finished
              end else EditState:=InitialState;
            end;
          end;
        RotateState:
          begin
            Finished:=True;
          end;
        DragState   :
          begin
            FirstPoint.X:=X;
            FirstPoint.Y:=Y;

            SecondPoint:=FirstPoint;
            Finished:=True;
            SaveContext;

            ClearTPointList(FixPoints);
            AddInterestingPoints(FixPoints, True);

//*******
            ClearTPointList(ObjectPoints);
            AddInterestingPoints(ObjectPoints, False);
            DragingPoint.X:=X/Zoomfactor-XSpace;
            DragingPoint.Y:=Y/Zoomfactor-YSpace;
            if not (ssShift in Shift) then
            DragingPoint:=MapToPointList(ObjectPoints, DragingPoint, 0, True);
//*******

            // First XOR the elements
            OldMode:=Plan.Canvas.Pen.Mode;
            Plan.Canvas.Pen.Mode:=pmNotxor;
            for i:=Element.BasicElements.Count-1 downto 0 do
              if Selected[i] then  Element.SingleDraw(Plan.Canvas, XSpace, YSpace, 0, Zoomfactor, Zoomfactor, clRed, i, @DrawInfo);
            Plan.Canvas.Pen.Mode:=OldMode;
          end;
      else EditState:=InitialState; end;
    until Finished;
  end;
end;

procedure TElEd.PlanMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
var OldMode  : TPenMode;
    OldStyle : TPenStyle;
    NewPos   : TDoublePoint;
    dx, dy   : Double;
    i        : longint;
//    Finished : boolean;
        A, B: TDoublePoint;

begin
      case EditState of
        InitialState:
          begin
          end;
        MovEdPointState:
          begin
            if SelEdPoint>=0 then begin
              DrawDragablePoints(EditPoints, SelEdPoint);
              XORDrawSelected;
              TPointObject(EditPoints[SelEdPoint]).P:=ToPlanCoordinates(X, Y);
              AdjustElement(SelEdPoint, Shift);
              XORDrawSelected;
              DrawDragablePoints(EditPoints, SelEdPoint);
            end;
          end;
        RectSelState  :
          begin // Clicked into empty space --> Draw A Rectangle
            WITH Plan.Canvas do begin
              Brush.Style:=bsClear;
              OldMode:=Pen.Mode;
              OldStyle:=Pen.Style;
              Pen.Style:=psDot;
              Pen.Mode:=pmNotxor;
              Rectangle(FirstPoint.X, FirstPoint.Y, SecondPoint.X, SecondPoint.Y);
              SecondPoint.X:=X; SecondPoint.Y:=Y;
              Rectangle(FirstPoint.X, FirstPoint.Y, SecondPoint.X, SecondPoint.Y);
              Pen.Mode:=OldMode;
              Pen.Style:=OldStyle;
            end;
            if not (ssCtrl in Shift) then ClearSelection;
            if FirstPoint.X < SecondPoint.X then begin
               A.X:=(FirstPoint.X)/Zoomfactor-XSpace; B.X:=(SecondPoint.X)/Zoomfactor-XSpace;
            end else begin
               B.X:=(FirstPoint.X)/Zoomfactor-XSpace; A.X:=(SecondPoint.X)/Zoomfactor-XSpace;
            end;
            if FirstPoint.Y < SecondPoint.Y then begin
              A.Y:=(FirstPoint.Y)/Zoomfactor-YSpace; B.Y:=(SecondPoint.Y)/Zoomfactor-YSpace;
            end else begin
              B.Y:=(FirstPoint.Y)/Zoomfactor-YSpace; A.Y:=(SecondPoint.Y)/Zoomfactor-YSpace;
            end;

            for i:=Element.BasicElements.Count-1 downto 0 do begin
              if TBasicAtom(Element.BasicElements.Items[i]).IsCompletelyInRect(A, B)
                 then Selected[i]:=True;
            end;
            SilentUpdate;
          end;
        SelectElState :
          begin
          end;
        RotateState :
          begin          ;
          end;
        DragState   :
          begin
            NewPos.X:=X/Zoomfactor-XSpace;
            NewPos.Y:=Y/Zoomfactor-YSpace;

            if not (ssShift in Shift) then NewPos:=MapToPointList(FixPoints, NewPos, GlobalElEdGRange, False);

            dx:=NewPos.X-DragingPoint.X;
            dy:=NewPos.Y-DragingPoint.Y;

            WITH Plan.Canvas do begin
              OldMode:=Plan.Canvas.Pen.Mode;
              Plan.Canvas.Pen.Mode:=pmNotxor;
              for i:=Element.BasicElements.Count-1 downto 0 do begin
                if Selected[i] then begin
              //Hide elements
                  Element.SingleDraw(Plan.Canvas, XSpace, YSpace, 0, Zoomfactor, Zoomfactor, clRed, i, @DrawInfo);
              // move Element relative
                  TBasicAtom(Element.BasicElements.Items[i]).MoveRel(dx, dy);
              // show Element at the New position
                  Element.SingleDraw(Plan.Canvas, XSpace, YSpace, 0, Zoomfactor, Zoomfactor, clRed, i, @DrawInfo);
                end;
              end;
             // if GlobalElEdIntrsDrag then ElementSelected;
              DragingPoint:=NewPos;

              // restore old Pen Mode
              Plan.Canvas.Pen.Mode:=OldMode;
              // set MouseStartPos To the current position because we are dealing WITH A relative movement
              MouseStartPos:=NewPos;
            end;
          end;
   else EditState:=InitialState; end;
end;

procedure TElEd.PlanMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
var OldMode:TPenMode;
    OldStyle: TPenStyle;
begin
  if Button = mbLeft then begin
      case EditState of
        InitialState:
          begin
          end;
        MovEdPointState:
          begin
            //SelEdPoint:=-1;
            EditState:=InitialState;
            Plan.Invalidate;
          end;
        RectSelState  :
          begin // Clicked into empty space --> Draw A Rectangle
            if (FirstPoint.X<>SecondPoint.X) or (FirstPoint.Y<>SecondPoint.Y) then begin
              WITH Plan.Canvas do begin
                Brush.Style:=bsClear;
                OldMode:=Pen.Mode;
                OldStyle:=Pen.Style;
                Pen.Style:=psDot;
                Pen.Mode:=pmNotxor;
                Rectangle(FirstPoint.X, FirstPoint.Y, SecondPoint.X, SecondPoint.Y);
                Pen.Mode:=OldMode;
                Pen.Style:=OldStyle;
              end;
            end;
            ElementSelected;
            SilentUpdate; //Hack for beauty
            DrawDragablePoints(EditPoints, SelEdPoint);
            EditState:=SelectElState;;
          end;
        SelectElState :
          begin
          end;
        DragState   :
          begin
            Plan.Invalidate;
            EditState:=SelectElState;
            ElementSelected;
            DrawDragablePoints(EditPoints, SelEdPoint);
          end;
        RotateState:
          begin
            EditState:=SelectElState;
          end;
    else EditState:=InitialState;    end;
    end;
  ActualizeEditIcons;
end;

procedure TElEd.EnableButtons(X:boolean);
begin
  TrashBtn.Enabled:=X;
  ElEdCopyAtomBTN.Enabled:=X;
  ElEdCutAtomBTN.Enabled:=X;
  MirrorXBTN.Enabled:=X;
  MirrorYBTN.Enabled:=X;
  RotateBTN.Enabled:=X;
  MoveUpBTN.Enabled:=X;
  MoveDownBTN.Enabled:=X;
  PolyBorderCol.Enabled:=X;
  PolyContentCol.Enabled:=X;
  PolyAddVertex.Enabled:=X;
  PolyDelVertex.Enabled:=X;
  NewLineAtomBTN.Enabled:=X;
  NewCSegAtomBTN.Enabled:=X;
  NewCnctAtomBTN.Enabled:=X;
  ElEdPasteAtomBTN.Enabled:=X;
  ZoomInBTN.Enabled:=X;
  ZoomOutBtn.Enabled:=X;
  ShowAllBtn.Enabled:=X;
  PrintBTN.Enabled:=X;
  PolygonBTN.Enabled:=X;
end;

procedure TElEd.ActualizeEditIcons;
var C, i:longint;
    PS:boolean;
begin
  C:=CountSelected;
  TrashBtn.Enabled:=C>0;
  ElEdCopyAtomBTN.Enabled:=C>0;
  ElEdCutAtomBTN.Enabled:=C>0;
  MirrorXBTN.Enabled:=C>0;
  MirrorYBTN.Enabled:=C>0;
  RotateBTN.Enabled:=C>0;
  MoveUpBTN.Enabled:=C>0;
  MoveDownBTN.Enabled:=C>0;

  PS:=C>0;
  if PS then begin
    PS:=False;
    for i:=Element.BasicElements.Count-1 downto 0 do
      if Selected[i] then begin
        if TBasicAtom(Element.BasicElements.Items[i]) is TPolyLineAtom then begin
          PS:=True;
          Break;
        end;
      end;
  end;
  PolyBorderCol.Enabled:=PS;
  PolyContentCol.Enabled:=PS;
  PolyAddVertex.Enabled:=PS;
  PolyDelVertex.Enabled:=PS;
end;

procedure TElEd.TrashBtnClick(Sender: TObject);
begin
  DeleteSelection;
  Plan.Invalidate;
end;

procedure TElEd.ElEdPlanPopUpPopup(Sender: TObject);
var i:longint;
    C:longint;
begin
  C:=CountSelected;
  ElLockM.Enabled:=(C=1);
  ElDeleteM.Enabled:=(C>0);
  ElEdCopyM.Enabled:=(C>0);
  ElEdCutM.Enabled:=(C>0);

  ElPropertyM.Enabled:=(C=1);
// if C=1 it is not sure the Selected atom is A group -> we cannot for sure
// ungroup it --> we decide in the loop below --> Initialize WITH False
  ElUngroupM.Enabled:=False;
  ElGroupM.Enabled:=(C>1);

  if C=1 then begin
    for i:=Element.BasicElements.Count-1 downto 0 do begin
      if Selected[i] then begin
// it is only possible To ungroup A group
        if TBasicAtom(Element.BasicElements.Items[i]) is TGroupAtom then ElUngroupM.Enabled:=True;

        ElLockM.Checked:=(TBasicAtom(Element.BasicElements.Items[i]).EditState
                          and CAtomEdLk >0);
        Break;
      end;
    end;
  end
end;

procedure TElEd.ElLockMClick(Sender: TObject);
var i:longint;
begin
  IsSaved:=False;  SaveContext;
  ElLockM.Checked:=not ElLockM.Checked;
  for i:=Element.BasicElements.Count-1 downto 0 do begin
    if Selected[i] then begin
       TBasicAtom(Element.BasicElements.Items[i]).EditState:=
       (TBasicAtom(Element.BasicElements.Items[i]).EditState and (not CAtomEdLk))
        or Ord(ElLockM.Checked)*CAtomEdLk;
      Break;
    end;
  end;
end;

procedure TElEd.CopySelection;
var i          : integer;
    E          : TGroupAtom;
    Meta       : TMetafile;
    MetaCanvas : TCanvas;
    LocalXSp,
    LocalYSp   : Double;
    ZF         : Double;
    M          : TModule;
begin
  if CountSelected >=1 then begin

// begin of change 2.01
    if GlobalModules.GetModule(EditingModule, M) then
      CopyScale:=M.Info.Spurweite
    else
      CopyScale:=1;
// end of change 2.01

    E:=TGroupAtom.Create;
    if Assigned(CopyStream) then begin
      CopyStream.Free;
      CopyStream:=TMemoryStream.Create;
    end;
    for i:=Element.BasicElements.Count-1 downto 0 do begin
      if Selected[i] then begin
         E.Members.BasicElements.Add(Element.BasicElements.Items[i]);
      end;
    end;
    E.Members.ToStream(TStream(CopyStream));

    try
      Meta:=TMetafile.Create;
      Meta.Height:=Planscroll.Height;
      Meta.Width:=Planscroll.Width;

      MetaCanvas:=TMetaFileCanvas.Create(Meta, 0);

      ZF:=ShowAllFactor;
      LocalXSp:=10/ZF-PA.X;
      LocalYSp:=10/ZF-PA.Y;
      for i:=Element.BasicElements.Count-1 downto 0 do begin
        if Selected[i] then begin
           Element.SingleDraw(MetaCanvas, LocalXSp, LocalYSp, 0, ZF, ZF, clBlack, i, @DrawInfo);
        end;
      end;
      MetaCanvas.Free;
      Clipboard.Assign(Meta);
      Meta.Free;
    except
      // Picture is not in Clipboard, who cares...
    end;

    WITH E.Members.BasicElements do for i:=Count-1 downto 0 do Delete(i);
    E.Free;
  end;
end;

procedure TElEd.DeleteSelection;
var i:longint;
    Ok:boolean;
begin
  Ok:=True;
  for i:=Element.BasicElements.Count-1 downto 0 do
    if Selected[i] then
      if TBasicAtom(Element.BasicElements.Items[i]).EditState and CAtomEdLk > 0
        then Ok:=False;

  if not Ok then
     if Confirm(TransStr('[cant Delete locked Element. Continue?]')) then exit;

  IsSaved:=False;  SaveContext;
  for i:=Element.BasicElements.Count-1 downto 0 do begin
    if Selected[i] then begin
      if TBasicAtom(Element.BasicElements.Items[i]).EditState and CAtomEdLk = 0
      then begin
        TBasicAtom(Element.BasicElements.Items[i]).Free;
        Element.BasicElements.Delete(i);
      end;
    end;
  end;
  Element.BasicElements.Pack;
  Selected.Size:=Element.BasicElements.Count+1;
  ClearSelection;
  ElementSelected;
  ActualizeEditIcons;
end;

procedure TElEd.ClearSelection;
var i:integer;
begin
  for i:=0 To Selected.Size-1 do Selected[i]:=False;
end;

procedure TElEd.PasteSelection(f:Double);
var E:TGroupAtom;
    j, Nr:longint;
    SU, SD, Mid:TDoublePoint;
    dx, dy:Double;

  procedure HandleLine(X: TLineAtom);
  begin
    X.A.X:=X.A.X*f;
    X.A.Y:=X.A.Y*f;
    X.B.X:=X.B.X*f;
    X.B.Y:=X.B.Y*f;
    X.RectCheckIn;
  end;

  procedure HandlePoly(X: TPolyLineAtom);
  var j:integer;
  begin
    for j:=0 To X.Points.Count-1 do begin
      TPointObject(X.Points[j]).P.X:=TPointObject(X.Points[j]).P.X*f;
      TPointObject(X.Points[j]).P.Y:=TPointObject(X.Points[j]).P.Y*f;
    end;
    X.RectCheckIn;
  end;

  procedure HandleArc(X: TCSegAtom);
  begin
    X.Center.X:=X.Center.X*f;
    X.Center.Y:=X.Center.Y*f;
    X.R:=X.R*f;
    X.RectCheckIn;
  end;

  procedure HandleCnct(X: TCnctAtom);
  begin
    X.P.X:=X.P.X*f;
    X.P.Y:=X.P.Y*f;
    X.RectCheckIn;
  end;


begin
  if Assigned(CopyStream) and (CopyStream.Size>0) then begin
    ClearSelection;
    IsSaved:=False;  SaveContext;
    CopyStream.Seek(0, 0);
    E:=TGroupAtom.Create;
    E.Members.FromStream(TStream(CopyStream));
    Selected.Size:=Element.BasicElements.Count+E.Members.BasicElements.Count;
    for j:=E.Members.BasicElements.Count-1 downto 0 do begin
      Nr:=Element.BasicElements.Add(E.Members.BasicElements.Items[j]);
      if TBasicAtom(Element.BasicElements.Items[Nr]) is TLineAtom then HandleLine(Element.BasicElements.Items[Nr]);
      if TBasicAtom(Element.BasicElements.Items[Nr]) is TCSegAtom then HandleArc(Element.BasicElements.Items[Nr]);
      if TBasicAtom(Element.BasicElements.Items[Nr]) is TCnctAtom then HandleCnct(Element.BasicElements.Items[Nr]);
      if TBasicAtom(Element.BasicElements.Items[Nr]) is TPolyLineAtom then HandlePoly(Element.BasicElements.Items[Nr]);
      Selected[Nr]:=True;
      E.Members.BasicElements.Delete(j);
    end;
    GetRectAroundSelection(SU, SD);
    Mid:=Middle(SU, SD);
    dx:=Mid.X-PointToGridPoint(GetCenterPos).X;
    dy:=Mid.Y-PointToGridPoint(GetCenterPos).Y;
    for j:=Element.BasicElements.Count-1 downto 0 do begin
      if Selected[j] then TBasicAtom(Element.BasicElements[j]).MoveRel(-dx, -dy);
    end;

    E.Free;
  end;
  ActualizeEditIcons;
end;

procedure TElEd.ElGroupMClick(Sender: TObject);
var i:longint;
    E:TGroupAtom;
begin
  if CountSelected >1 then begin
    IsSaved:=False;  SaveContext;
    E:=TGroupAtom.Create;
    for i:=Element.BasicElements.Count-1 downto 0 do begin
      if Selected[i] then begin
         E.Members.BasicElements.Add(Element.BasicElements.Items[i]);
         Element.BasicElements.Delete(i);
      end;
    end;
    Element.BasicElements.Pack;
    E.CheckIn;
    ClearSelection;
    Selected[Element.BasicElements.Add(E)]:=True;
    Plan.Invalidate;
  end;
end;

procedure TElEd.ElUngroupMClick(Sender: TObject);
var i, j:longint;
    E: TGroupAtom;
begin
  if CountSelected =1 then begin
    IsSaved:=False;  SaveContext;
    Element.BasicElements.Pack;
    for i:=Element.BasicElements.Count-1 downto 0 do begin
      if Selected[i] then
       if TBasicAtom(Element.BasicElements.Items[i]) is TGroupAtom then begin
         ClearSelection;
         E:=Element.BasicElements.Items[i];
         for j:=E.Members.BasicElements.Count-1 downto 0 do begin
           Selected[Element.BasicElements.Add(E.Members.BasicElements.Items[j])-1]:=True;
           E.Members.BasicElements.Delete(j);
         end;
         E.Free;
         Element.BasicElements.Delete(i);
         Break;
      end;
    end;
    Element.BasicElements.Pack;
    Plan.Invalidate;
  end;
end;

procedure TElEd.ElEdCopyAtomBTNClick(Sender: TObject);
begin
  CopySelection;
end;

procedure TElEd.PasteNormal;
begin
  PasteSelection(1);
end;

procedure TElEd.StretchPaste;
var factor : Double;
    M      : TModule;
begin
  if GlobalModules.GetModule(EditingModule, M) then
    factor:=M.Info.Spurweite
  else
    factor:=1;
  factor:=factor/CopyScale;
  if ABS(factor - 1)<0.000001 then begin
    QueryDouble.Value:=1;
    QueryDouble.QLabel.Caption:=TransStr('[Enter factor]');
    QueryDouble.Caption:=TransStr('[Scale]');
    if QueryDouble.ShowModal=mrOK then PasteSelection(QueryDouble.Value);
  end else PasteSelection(factor);
  Plan.Invalidate;
end;

procedure TElEd.ElEdCutAtomBTNClick(Sender: TObject);
begin
  CopySelection;
  DeleteSelection;
  Plan.Invalidate;
end;

procedure TElEd.NewLineAtomBTNClick(Sender: TObject);
begin
  NewLine;
end;

procedure TElEd.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then begin
    Panel1.Align:=alRight;
    ToolbarXMover.Align:=alLeft;
  end else begin
    Panel1.Align:=alLeft;
    ToolbarXMover.Align:=alRight;
  end;
end;

procedure TElEd.ToolbarXMoverMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if Button=mbLeft then begin
    ToolbarXResizing:=True;
  end;
end;

procedure TElEd.ToolbarXMoverMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: integer);
begin
  if ToolbarXResizing then begin
    if Panel1.Align=alLeft then begin
      if (Panel1.Left+ToolbarXMover.Left+X+2<ElEd.Width-150)
        and (Panel1.Left+ToolbarXMover.Left+X+2>10) then
          Panel1.Width:=Panel1.Left+ToolbarXMover.Left+X+2;
    end else begin
     if (Panel1.Width-X+1<ElEd.Width-150)
       and (Panel1.Width-X+1>10) then
        Panel1.Width:=Panel1.Width-X+1;
    end;
    Rearrange;
  end;
end;

procedure TElEd.ToolbarXMoverMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
begin
  if Button=mbLeft then begin
    if ToolbarXResizing then begin
      if Panel1.Align=alLeft then begin
        if (Panel1.Left+ToolbarXMover.Left+X+2<ElEd.Width-150)
          and (Panel1.Left+ToolbarXMover.Left+X+2>10) then
            Panel1.Width:=Panel1.Left+ToolbarXMover.Left+X+2;
      end else begin
        if (Panel1.Width-X+1<ElEd.Width-150)
          and (Panel1.Width-X+1>10) then
           Panel1.Width:=Panel1.Width-X+1;
      end;
      Rearrange;
    end;
    ToolbarXResizing:=False;
  end;
end;

procedure TElEd.ToolbarYMoverMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if Button=mbLeft then begin
    ToolbarYResizing:=True;
  end;
end;

procedure TElEd.ToolbarYMoverMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: integer);
begin
  if ToolbarYResizing then
    if ToolbarYMover.Top+Y-1<ElEd.Height-50 then
      ElTree.Height:=ToolbarYMover.Top+Y-1;
end;

procedure TElEd.ToolbarYMoverMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
begin
  if Button=mbLeft then begin
    if ToolbarYResizing then
      if ToolbarYMover.Top+Y-1<ElEd.Height-50 then
        ElTree.Height:=ToolbarYMover.Top+Y-1;
    ToolbarYResizing:=False;
  end;
end;

procedure TElEd.NewLine;
var XLine:TLineAtom;
begin
  LinePropertyDLG.XCur:=CursorPos.X;
  LinePropertyDLG.YCur:=CursorPos.Y;
  LinePropertyDLG.ACur:=FixedAngle(CursorAngle);
  LinePropertyDLG.MiddleOrientCBX.Checked:=False;

  LinePropertyDLG.XEdit.Text:=CommonMakeString(CursorPos.X);
  LinePropertyDLG.YEdit.Text:=CommonMakeString(-CursorPos.Y);
  LinePropertyDLG.AngleEdit.Text:=CommonMakeString(-FixedAngle(CursorAngle)/Pi*180);
  LinePropertyDLG.AddAngleEdit.Text:=CommonMakeString(0);

  LinePropertyDLG.LengthEdit.Text:=CommonMakeString(10);
  LinePropertyDLG.TrackCBX.Checked:=True;

  if LinePropertyDLG.ShowModal=mrOK then begin
    XLine:=TLineAtom.Create;
    IsSaved:=False;  SaveContext;
    XLine.w:=FixedAngle(-CommonMakeDouble(LinePropertyDLG.AngleEdit.Text)/180*Pi-CommonMakeDouble(LinePropertyDLG.AddAngleEdit.Text)/180*Pi);
    XLine.A.X:=CommonMakeDouble(LinePropertyDLG.XEdit.Text);
    XLine.A.Y:=-CommonMakeDouble(LinePropertyDLG.YEdit.Text);
    if LinePropertyDLG.MiddleOrientCBX.Checked then begin
      XLine.B.X:=XLine.A.X+Cos(XLine.w)*CommonMakeDouble(LinePropertyDLG.LengthEdit.Text)/2;
      XLine.B.Y:=XLine.A.Y+Sin(XLine.w)*CommonMakeDouble(LinePropertyDLG.LengthEdit.Text)/2;
      XLine.A.X:=XLine.A.X+Cos(XLine.w+Pi)*CommonMakeDouble(LinePropertyDLG.LengthEdit.Text)/2;
      XLine.A.Y:=XLine.A.Y+Sin(XLine.w+Pi)*CommonMakeDouble(LinePropertyDLG.LengthEdit.Text)/2;
    end else begin
      XLine.B.X:=XLine.A.X+Cos(XLine.w)*CommonMakeDouble(LinePropertyDLG.LengthEdit.Text);
      XLine.B.Y:=XLine.A.Y+Sin(XLine.w)*CommonMakeDouble(LinePropertyDLG.LengthEdit.Text);
    end;
    if LinePropertyDLG.TrackCBX.Checked then
      XLine.EditState:= CAtomTrack or CAtomEdLk
    else
      XLine.EditState:=0;
    XLine.RectCheckIn;
    Selected.Size:=Element.BasicElements.Count+1;
    ClearSelection;
    Selected[Element.BasicElements.Add(XLine)]:=True;
    Plan.Invalidate;
  end;
  ActualizeEditIcons;
end;

procedure TElEd.NewConnector;
var XCnct:TCnctAtom;
begin
  CnctPropertyDLG.XCur:=CursorPos.X;
  CnctPropertyDLG.YCur:=CursorPos.Y;
  CnctPropertyDLG.ACur:=FixedAngle(CursorAngle);

  CnctPropertyDLG.IDNrSpin.Value:=Element.GetNextCnctID;

  CnctPropertyDLG.XEdit.Text:=CommonMakeString(CursorPos.X);
  CnctPropertyDLG.YEdit.Text:=CommonMakeString(-CursorPos.Y);
  CnctPropertyDLG.AngleEdit.Text:=CommonMakeString(-FixedAngle(CursorAngle)/Pi*180);
  CnctPropertyDLG.AddAngleEdit.Text:=CommonMakeString(0);

  if CnctPropertyDLG.ShowModal=mrOK then begin
    XCnct:=TCnctAtom.Create;
    IsSaved:=False;  SaveContext;
    XCnct.w:=FixedAngle(-CommonMakeDouble(CnctPropertyDLG.AngleEdit.Text)/180*Pi-CommonMakeDouble(CnctPropertyDLG.AddAngleEdit.Text)/180*Pi);
    XCnct.P.X:=CommonMakeDouble(CnctPropertyDLG.XEdit.Text);
    XCnct.P.Y:=-CommonMakeDouble(CnctPropertyDLG.YEdit.Text);
    XCnct.EditState:= CAtomEdLk;
    XCnct.RectCheckIn;
    XCnct.Nr:=CnctPropertyDLG.IDNrSpin.Value;
    Selected.Size:=Element.BasicElements.Count+1;
    ClearSelection;
    Selected[Element.BasicElements.Add(XCnct)]:=True;
    Plan.Invalidate;
  end;
  ActualizeEditIcons;
end;

procedure TElEd.NewArc;
var XArc:TCSegAtom;
begin
  ArcPropertyDLG.DAEdit.Text:='180';
  ArcPropertyDLG.REdit.Text:='100';
  ArcPropertyDLG.XCur:=CursorPos.X;
  ArcPropertyDLG.YCur:=CursorPos.Y;
  ArcPropertyDLG.ACur:=FixedAngle(CursorAngle);
  ArcPropertyDLG.P1:=PosKey1;
  ArcPropertyDLG.P2:=PosKey2;
  ArcPropertyDLG.W1:=AngKey1;
  ArcPropertyDLG.W2:=AngKey2;


  ArcPropertyDLG.XEdit.Text:=CommonMakeString(CursorPos.X);
  ArcPropertyDLG.YEdit.Text:=CommonMakeString(-CursorPos.Y);
  ArcPropertyDLG.AEdit.Text:=CommonMakeString(FixedAngle(CursorAngle)/Pi*180);
  ArcPropertyDLG.AddAngleEdit.Text:=CommonMakeString(0);
  ArcPropertyDLG.CenterRBT.Checked:=True;

  ArcPropertyDLG.TrackCBX.Checked:=True;

  if ArcPropertyDLG.ShowModal=mrOK then begin
    IsSaved:=False;  SaveContext;
    XArc:=TCSegAtom.Create;
    XArc.Center.X:=CommonMakeDouble(ArcPropertyDLG.XEdit.Text);
    XArc.Center.Y:=-CommonMakeDouble(ArcPropertyDLG.YEdit.Text);
    XArc.R:=CommonMakeDouble(ArcPropertyDLG.REdit.Text);

    XArc.w:=FixedAngle(CommonMakeDouble(ArcPropertyDLG.AEdit.Text)/180*Pi+CommonMakeDouble(ArcPropertyDLG.AddAngleEdit.Text)/180*Pi);
    XArc.dw:=CommonMakeDouble(ArcPropertyDLG.DAEdit.Text)/180*Pi;
    if ArcPropertyDLG.FirstRBT.Checked then begin
      XArc.w:=-XArc.w-Pi/2;
      XArc.Center.X:=XArc.Center.X-Cos(XArc.w)*XArc.R;
      XArc.Center.Y:=XArc.Center.Y+Sin(XArc.w)*XArc.R;
    end else if ArcPropertyDLG.SecondRBT.Checked then begin
      XArc.w:=-XArc.w+Pi/2;
      XArc.Center.X:=XArc.Center.X-Cos(XArc.w)*XArc.R;
      XArc.Center.Y:=XArc.Center.Y+Sin(XArc.w)*XArc.R;
      XArc.w:=XArc.w-XArc.dw;
    end;
    if ArcPropertyDLG.TrackCBX.Checked then
      XArc.EditState:= CAtomTrack or CAtomEdLk
    else
      XArc.EditState:= 0;
    XArc.RectCheckIn;
    Selected.Size:=Element.BasicElements.Count+1;
    ClearSelection;
    Selected[Element.BasicElements.Add(XArc)]:=True;
    Plan.Invalidate;
  end;
  ActualizeEditIcons;
end;

procedure TElEd.ElPropertyMClick(Sender: TObject);
var i:longint;
    C:longint;

  procedure HandleLine;
  var XLine:TLineAtom;
  begin
    LinePropertyDLG.XCur:=CursorPos.X;
    LinePropertyDLG.YCur:=CursorPos.Y;
    LinePropertyDLG.ACur:=FixedAngle(CursorAngle);
    LinePropertyDLG.MiddleOrientCBX.Checked:=False;

    XLine:=TLineAtom(Element.BasicElements.Items[i]);
    LinePropertyDLG.XEdit.Text:=CommonMakeString(XLine.A.X);
    LinePropertyDLG.YEdit.Text:=CommonMakeString(-XLine.A.Y);
    LinePropertyDLG.AngleEdit.Text:=CommonMakeString(-FixedAngle(XLine.w)/Pi*180);
    LinePropertyDLG.AddAngleEdit.Text:=CommonMakeString(0);

    LinePropertyDLG.LengthEdit.Text:=CommonMakeString(XLine.GetLengthIntern);
    LinePropertyDLG.TrackCBX.Checked:=(XLine.EditState and CAtomTrack)>0;
    if LinePropertyDLG.ShowModal=mrOK then begin
      IsSaved:=False;  SaveContext;
      XLine.w:=FixedAngle(-CommonMakeDouble(LinePropertyDLG.AngleEdit.Text)/180*Pi-CommonMakeDouble(LinePropertyDLG.AddAngleEdit.Text)/180*Pi);
      XLine.A.X:=CommonMakeDouble(LinePropertyDLG.XEdit.Text);
      XLine.A.Y:=-CommonMakeDouble(LinePropertyDLG.YEdit.Text);
      if LinePropertyDLG.MiddleOrientCBX.Checked then begin
        XLine.B.X:=XLine.A.X+Cos(XLine.w)*CommonMakeDouble(LinePropertyDLG.LengthEdit.Text)/2;
        XLine.B.Y:=XLine.A.Y+Sin(XLine.w)*CommonMakeDouble(LinePropertyDLG.LengthEdit.Text)/2;
        XLine.A.X:=XLine.A.X+Cos(XLine.w+Pi)*CommonMakeDouble(LinePropertyDLG.LengthEdit.Text)/2;
        XLine.A.Y:=XLine.A.Y+Sin(XLine.w+Pi)*CommonMakeDouble(LinePropertyDLG.LengthEdit.Text)/2;
      end else begin
        XLine.B.X:=XLine.A.X+Cos(XLine.w)*CommonMakeDouble(LinePropertyDLG.LengthEdit.Text);
        XLine.B.Y:=XLine.A.Y+Sin(XLine.w)*CommonMakeDouble(LinePropertyDLG.LengthEdit.Text);
      end;
      if LinePropertyDLG.TrackCBX.Checked then
        XLine.EditState:=XLine.EditState or CAtomTrack
      else
        XLine.EditState:=XLine.EditState and(not CAtomTrack);
      XLine.RectCheckIn;
    end;
  end;

  procedure HandleArc;
  var XArc:TCSegAtom;
  begin
    ArcPropertyDLG.XCur:=CursorPos.X;
    ArcPropertyDLG.YCur:=CursorPos.Y;
    ArcPropertyDLG.ACur:=FixedAngle(CursorAngle);
    ArcPropertyDLG.P1:=PosKey1;
    ArcPropertyDLG.P2:=PosKey2;
    ArcPropertyDLG.W1:=AngKey1;
    ArcPropertyDLG.W2:=AngKey2;

    XArc:=TCSegAtom(Element.BasicElements.Items[i]);

    ArcPropertyDLG.XEdit.Text:=CommonMakeString(XArc.Center.X);
    ArcPropertyDLG.YEdit.Text:=CommonMakeString(-XArc.Center.Y);
    ArcPropertyDLG.AEdit.Text:=CommonMakeString(FixedAngle(XArc.w)/Pi*180);
    ArcPropertyDLG.AddAngleEdit.Text:=CommonMakeString(0);
    ArcPropertyDLG.DAEdit.Text:=CommonMakeString(XArc.dw/Pi*180);
    ArcPropertyDLG.REdit.Text:=CommonMakeString(XArc.R);
    ArcPropertyDLG.CenterRBT.Checked:=True;

    ArcPropertyDLG.TrackCBX.Checked:=(XArc.EditState and CAtomTrack)>0;

    if ArcPropertyDLG.ShowModal=mrOK then begin
      IsSaved:=False;  SaveContext;
      XArc.Center.X:=CommonMakeDouble(ArcPropertyDLG.XEdit.Text);
      XArc.Center.Y:=-CommonMakeDouble(ArcPropertyDLG.YEdit.Text);
      XArc.R:=CommonMakeDouble(ArcPropertyDLG.REdit.Text);

      XArc.w:=FixedAngle(CommonMakeDouble(ArcPropertyDLG.AEdit.Text)/180*Pi+CommonMakeDouble(ArcPropertyDLG.AddAngleEdit.Text)/180*Pi);
      XArc.dw:=CommonMakeDouble(ArcPropertyDLG.DAEdit.Text)/180*Pi;
      if ArcPropertyDLG.FirstRBT.Checked then begin
        XArc.w:=-XArc.w-Pi/2;
        XArc.Center.X:=XArc.Center.X-Cos(XArc.w)*XArc.R;
        XArc.Center.Y:=XArc.Center.Y+Sin(XArc.w)*XArc.R;
      end else if ArcPropertyDLG.SecondRBT.Checked then begin
        XArc.w:=-XArc.w+Pi/2;
        XArc.Center.X:=XArc.Center.X-Cos(XArc.w)*XArc.R;
        XArc.Center.Y:=XArc.Center.Y+Sin(XArc.w)*XArc.R;
        XArc.w:=XArc.w-XArc.dw;
      end;
      if ArcPropertyDLG.TrackCBX.Checked then
        XArc.EditState:=XArc.EditState or CAtomTrack
      else
        XArc.EditState:=XArc.EditState and(not CAtomTrack);
      XArc.RectCheckIn;
    end;
  end;

 procedure HandleCnct;
  var XCnct:TCnctAtom;
  begin
    CnctPropertyDLG.XCur:=CursorPos.X;
    CnctPropertyDLG.YCur:=CursorPos.Y;
    CnctPropertyDLG.ACur:=FixedAngle(-CursorAngle);

    XCnct:=TCnctAtom(Element.BasicElements.Items[i]);
    CnctPropertyDLG.IDNrSpin.Value:=XCnct.Nr;

    CnctPropertyDLG.XEdit.Text:=CommonMakeString(XCnct.P.X);
    CnctPropertyDLG.YEdit.Text:=CommonMakeString(-XCnct.P.Y);
    CnctPropertyDLG.AngleEdit.Text:=CommonMakeString(FixedAngle(-XCnct.w)/Pi*180);
    CnctPropertyDLG.AddAngleEdit.Text:=CommonMakeString(0);

    if CnctPropertyDLG.ShowModal=mrOK then begin
      IsSaved:=False;  SaveContext;
      XCnct.w:=FixedAngle(-CommonMakeDouble(CnctPropertyDLG.AngleEdit.Text)/180*Pi-CommonMakeDouble(CnctPropertyDLG.AddAngleEdit.Text)/180*Pi);
      XCnct.P.X:=CommonMakeDouble(CnctPropertyDLG.XEdit.Text);
      XCnct.P.Y:=-CommonMakeDouble(CnctPropertyDLG.YEdit.Text);
      XCnct.EditState:= CAtomEdLk;
      XCnct.RectCheckIn;
      XCnct.Nr:=CnctPropertyDLG.IDNrSpin.Value;
      Plan.Invalidate;
    end;
  end;


begin
  C:=CountSelected;
  if C=1 then begin
    for i:=Element.BasicElements.Count-1 downto 0 do begin
      if Selected[i] then begin
        if TBasicAtom(Element.BasicElements.Items[i]) is TLineAtom then HandleLine;
        if TBasicAtom(Element.BasicElements.Items[i]) is TCSegAtom then HandleArc;
        if TBasicAtom(Element.BasicElements.Items[i]) is TCnctAtom then HandleCnct;
        Break;
      end;
    end;
    Plan.Invalidate;
  end
end;

procedure TElEd.FormActivate(Sender: TObject);
begin
  Self.Width:=GlobalElEdWidth; Self.Height:=GlobalElEdHeight;
  Self.Top:=GlobalElEdTop;     Self.Left:=GlobalElEdLeft;
  Rearrange;
  SetDrawInfo;
  UndoBTN.Enabled:=CanUndo;
end;

procedure TElEd.SetDrawInfo;
var M:TModule;
begin
  //set default DrawInfo
  if GlobalModules.GetModule(EditingModule, M) then DrawInfo.Spurweite:=M.Info.Spurweite
                                               else DrawInfo.Spurweite:=20;
  if GlobalModules.GetModule(EditingModule, M) then DrawInfo.ElWidth:=M.Info.ElWidth
                                               else DrawInfo.ElWidth:=20;

  DrawInfo.ClickBreite:=DrawInfo.Spurweite/5;
  DrawInfo.Exact:=GlobalElEdExact;
  DrawInfo.Precision:=GlobalElEdPrec;
  DrawInfo.DoubleDraw:=GlobalElEdDouble;
  DrawInfo.Selected:=False;
  DrawInfo.ForceTransparent:=GlobalElEdTransPoly;
  DrawInfo.CnctDraw:=$FF;  // Draw as much as possible
end;

procedure TElEd.TransElementRBExit(Sender: TObject);
begin
  TransToCombo.Enabled:=TransElementRBT.Checked;
  IsSaved:=False;  //SaveContext;
end;

procedure TElEd.NewCSegAtomBTNClick(Sender: TObject);
begin
  NewArc;
end;

procedure TElEd.RemarkEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  IsSaved:=False;  //SaveContext;
end;

//******************************************************************************
// Handling the Element-Tree
//******************************************************************************

procedure TElEd.ImplementChange(Node: TTreeNode; Force:boolean);
var M: TModule;
    E: TElement;
    S: TMemoryStream;
    tempS:Single;
    code:integer;

    // is at least one connector present?
    // if not then insert one in the Center
    procedure CheckConnections(X:TElement);
    var i  : integer;
        Ok : boolean;
        TA, TB:TDoublePoint;
        C  : TCnctAtom;
    begin
      Ok:=False;
      for i:=0 To X.BasicElements.Count-1 do
        if TBasicAtom(X.BasicElements[i]) is TCnctAtom then begin
          Ok:=True;
          Break;
      end;
      if not Ok then begin
        X.GetRectAround0(TA, TB);
        C:=TCnctAtom.Create;
        C.P:=Middle(TA, TB);
        C.w:=0;
        C.Nr:=0;
        X.BasicElements.Add(C);
      end;
    end;

begin
  if Assigned(Node) and (Node.Level=ElementLevel) then begin
    TabControl.show;
    EnableButtons(True);
    if (not IsSaved) and (Force or (Confirm(TransStr('[Element Editor:Confirm changes To module]') +
      ' ( '+EditingElement+' --> [ '+EditingModule+' ] )'))) then begin
      if GlobalModules.LoadModule(EditingModule) then
        if GlobalModules.GetModule(EditingModule, M) then begin
// Kill old Element in module
          M.RemoveElement(EditingElement);
// insert the New Element
          StrPCopy(Element.Info.Remark, RemarkEdit.Text);
          Val(RadiusEdit.Text, tempS, code);
          if code=0 then Element.Info.TheRadius:=tempS else Element.Info.TheRadius:=0;
          Val(LengthEdit.Text, tempS, code);
          if code=0 then Element.Info.TheLength:=tempS else Element.Info.TheLength:=0;
          Val(AngleEdit.Text, tempS, code);
          if code=0 then Element.Info.TheAngle:=tempS else Element.Info.TheAngle:=0;

          if GeradeRBT.Checked then Element.Info.TheType:=Gerade;
          if KurveRBT.Checked then Element.Info.TheType:=Kurve;
          if WeicheRBT.Checked then Element.Info.TheType:=Weiche;
          if KreuzungRBT.Checked then Element.Info.TheType:=Kreuzung;
          if KreuzweicheRBT.Checked then Element.Info.TheType:=Kreuzungsweiche;
          if SpecialRBT.Checked then Element.Info.TheType:=Spezialelement;
          if FlexElementRBT.Checked then Element.Info.TheType:=FlexElement;
          if LFlexRBT.Checked then Element.Info.TheType:=LengthFlex;

          if TransElementRBT.Checked then begin
            Element.Info.TheType:=UebergangsStueck;
            StrPCopy(Element.Info.Uebergang, TransToCombo.Text);
          end;
          CheckConnections(Element);
          M.AddElement(EditingElement, Element);
          AdjustTreeImage(EditingNode, M);
      end;
    end else Element.Free;
// Kill current Element (it is saved by now if neccessary)
// Create A New Element
    Element:=TElement.Create;

// Copy the New Element
    S:=TMemoryStream.Create;

    EditingModule:=Node.Parent.Text;
    EditingElement:=Node.Text;
    EditingNode:=Node;
    SetDrawInfo;

    CursorPos.X:=0; CursorPos.Y:=0; CursorAngle:=0;
    if GlobalModules.LoadModule(EditingModule) then
      if GlobalModules.GetModule(EditingModule, M) then
        if M.GetElement(EditingElement, E) then begin
          // Save the Element To A stream...
          E.ToStream(TStream(S));
          // Reset stream
          S.Seek(0,0);
          // Load Element from stream
          Element.FromStream(TStream(S));
        end;
    ActualizeData;
    IsSaved:=True;
    ClearUndoList;

    S.Free; // Release stream

    Selected.Size:=Element.BasicElements.Count;
    ClearSelection;
    ElementSelected;
    ActualizeEditIcons;
    ShowAll;
  end else begin
    TabControl.Hide;
    EnableButtons(False);
  end;
end;

procedure TElEd.ElTreeChange(Sender: TObject; Node: TTreeNode);
begin
  ImplementChange(Node, False);
end;

procedure TElEd.FillInModule(ModName:string);
var Nr:integer;
    Home,
    Where,
    New:TTreeNode;
    Manufacturer:string;
begin
   if ElTree.Items.Count>0 then Home:=ElTree.Items.Item[0] else Home:=NIL;
   Manufacturer:=UpperCase(GlobalModules.ManufacturerOf(ModName));
   if not ManufacturerNodes.Find(Manufacturer, Nr) then begin
      Where:=ElTree.Items.Add(Home, GlobalModules.ManufacturerOf(ModName));
      ManufacturerNodes.AddObject(Manufacturer, Where);
    end else Where:=TTreeNode(ManufacturerNodes.Objects[Nr]);
    New:=ElTree.Items.AddChildfirst(Where, ModName);
    New.HasChildren:=True;
    if GlobalModules.IsLoaded(ModName) then begin
      New.ImageIndex:=ActiveIMG;
      New.SelectedIndex:=ActiveSelectedIMG;
    end else begin
      New.ImageIndex:=InActiveIMG;
      New.SelectedIndex:=InActiveSelectedIMG;
    end;
end;

procedure TElEd.FillTreeWithModules;
var i:integer;
begin
  ElTree.Items.Clear;
  ElTree.Enabled:=False;
  ElTree.SortType:=stnone;
  ElTree.Items.BeginUpdate;
  ManufacturerNodes.Clear;
  for i:=0 To GlobalModules.AvailableModules.Count-1 do FillInModule(GlobalModules.AvailableModules[i]);
  ElTree.Items.EndUpdate;
  ElTree.Enabled:=True;
  ElTree.SortType:=stText;
end;

procedure TElEd.AdjustTreeImage(XTemp:TTreeNode; M:TModule);
var El:TElement;
begin
  try
  if Assigned(M) then begin
    if M.GetElement(XTemp.Text, El) then begin
      case El.Info.TheType of
         Gerade                 : XTemp.ImageIndex:=GeradeIMG;
         Kurve                  : XTemp.ImageIndex:=KurveIMG;
         Weiche                 : XTemp.ImageIndex:=WeicheIMG;
         Kreuzung               : XTemp.ImageIndex:=KreuzungIMG;
         Kreuzungsweiche        : XTemp.ImageIndex:=KreuzWeichIMG;
         Spezialelement         : XTemp.ImageIndex:=SpecialIMG;
         UebergangsStueck       : XTemp.ImageIndex:=TransIMG;
      else XTemp.ImageIndex:=OtherIMG; end
    end else XTemp.ImageIndex:=OtherIMG;
  end else XTemp.ImageIndex:=OtherIMG;
  except
    // Whatever goes wrong goes here
///    Messagedlg('Error (Pflotsch 1) occured. Press Ok To Continue.', mtinformation, [mbok], 0);
  end;
  ElTree.Invalidate;
end;

function TElEd.FindTreeEntry(N:string; X:TTreeNode; var Where:TTreeNode):boolean;
begin
  Result:=False;
  Where:=NIL;
  if not Assigned(X) then exit;
  repeat
    if UpperCase(X.Text) = UpperCase(N) then begin
      Where:=X;
      Result:=True;
      Break;
    end;
    X:=X.GetNextSibling;
  until not Assigned(X);
end;

procedure TElEd.LiteModule(N:string);
var Where : TTreeNode;
begin
  ElTree.Items.BeginUpdate;
  if FindTreeEntry(GlobalModules.ManufacturerOf(N), ElTree.Items.GetFirstNode, Where) then
    if FindTreeEntry(N, Where.GetFirstChild, Where) then begin
    Where.ImageIndex:=ActiveIMG;
    Where.SelectedIndex:=ActiveSelectedIMG;
  end;
  ElTree.Items.EndUpdate;
end;

procedure TElEd.FillTreeWithRailsFrom(ModName:string);
var Where : TTreeNode;
    Temp,
    XTemp : TTreeNode;
    i     : integer;
    M     : TModule;
    TempCursor: TCursor;


begin
  GlobalModules.LoadModule(ModName);
  // Calm down the User
  TempCursor:=Screen.cursor;
  Screen.cursor:=crHourglass;

  ElTree.Items.BeginUpdate;
  ElTree.Enabled:=False;
  ElTree.SortType:=stnone;
  DummyTree.Items.Clear;
  Temp:=DummyTree.Items.AddFirst(NIL, ModName);
  if FindTreeEntry(GlobalModules.ManufacturerOf(ModName), ElTree.Items.GetFirstNode, Where) then
    if FindTreeEntry(ModName, Where.GetFirstChild, Where) then begin
      if GlobalModules.GetModule(ModName, M) then begin
        Where.DeleteChildren;
        for i:=0 To M.elements.Count-1 do begin
          XTemp:=DummyTree.Items.AddFirst(Temp, TElement(M.elements.Objects[i]).Info.Name);
          XTemp.MoveTo(Where, NAAddchild);
          AdjustTreeImage(XTemp, M);
        end;
      end;
  end;
  LiteModule(ModName);
  ElTree.SortType:=stText;
  ElTree.Items.EndUpdate;
  ElTree.Enabled:=True;
  // get the standard cursor back
  Screen.cursor:=TempCursor;
end;

procedure TElEd.ElTreeExpanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: boolean);
begin
  if Node.Level=ObjectLevel then begin
    if Node.Count=0 then FillTreeWithRailsFrom(Node.Text);
    AllowExpansion:=True;
  end;
end;

procedure TElEd.ExportModule1Click(Sender: TObject);
var M:TModule;
begin
{$IFDEF XMAS}
  if ElTree.Selected.Level=ObjectLevel then begin
    if GlobalModules.GetModule(ElTree.Selected.Text, M) then begin
      if XMASSaveDLG.Execute then M.ExportWR1(XMASSaveDLG.FileName);
    end;
  end;
{$ENDIF}  
end;

procedure TElEd.NewElement1Click(Sender: TObject);
var M:TModule;
    X:TElement;
    New:TTreeNode;
begin
  if ElTree.Selected.Level=ObjectLevel then begin
    if GlobalModules.GetModule(ElTree.Selected.Text, M) then begin
      ElNameDLG.NameEdit.Text:='';
      if ElNameDLG.ShowModal=mrOK then begin
        if (ElNameDLG.NameEdit.Text<>'') and (not M.GetElement(ElNameDLG.NameEdit.Text, X)) then begin
          X:=TElement.Create;
          StrPCopy(X.Info.Name, ElNameDLG.NameEdit.Text);
          X.Info.Remark:='';
          X.Info.TheRadius:=0;
          X.Info.TheLength:=0;
          X.Info.TheAngle:=0;
          M.AddElement(X.Info.Name, X);
          New:=ElTree.Items.AddChild(ElTree.Selected, X.Info.Name);
          New.Selected:=True;
          AdjustTreeImage(New, M);
        end;
      end;
    end;
  end;
end;

procedure TElEd.ElEdTreePopPopup(Sender: TObject);
begin
  try
    NewElement1.Enabled:=ElTree.Selected.Level=ObjectLevel;
    ExportModule1.Enabled:=ElTree.Selected.Level=ObjectLevel;
    EditmoduleInfo1.Enabled:=ElTree.Selected.Level=ObjectLevel;
    Savemodule1.Enabled:=ElTree.Selected.Level=ObjectLevel;
    DeleteElement1.Enabled:=ElTree.Selected.Level=ElementLevel;
    ElTree.ReadOnly:=not ((ParamCount>0) and (LowerCase(ParamStr(1))=DevelopStr));
  except
    NewElement1.Enabled:=False;
    ExportModule1.Enabled:=False;
    EditmoduleInfo1.Enabled:=False;
    Savemodule1.Enabled:=False;
    DeleteElement1.Enabled:=False;
  end;
end;

procedure TElEd.DeleteElement1Click(Sender: TObject);
var M:TModule;
    old:TTreeNode;
begin
  if Confirm(TransStr('[Delete?]')+' ('+ElTree.Selected.Text+') ') then begin
    if GlobalModules.GetModule(ElTree.Selected.Parent.Text, M) then begin
      M.RemoveElement(ElTree.Selected.Text);
      ElTree.Items.BeginUpdate;
      old:=ElTree.Selected;
      ElTree.Selected.Parent.Selected:=True;
      ElTree.Selected.Collapse(True); // ??? if i don't do this the programm will Collapse
      old.Delete;
// begin change in Raily for Windows, too ?  YES!!!
      EditingNode:=NIL;
      EditingElement:='';
      ElTreeChange(ElTree, NIL);
// end change in Raily for Windows, too ? YES!!!
      ElTree.Selected.expand(True);  // To compensate the Collapse from above
      ElTree.Items.EndUpdate;
      ElTree.Refresh;
    end;
  end;
end;

procedure TElEd.NewCnctAtomBTNClick(Sender: TObject);
begin
  NewConnector;
end;

procedure TElEd.SaveModule(Name:string);
begin
  if GlobalModules.SaveModule(Name) then begin
    Inform(TransStr('[module: successfully saved]'));
  end else begin
    Warn(TransStr('[module: Save failed]'));
  end;
end;

procedure TElEd.Savemodule1Click(Sender: TObject);
begin
  if ElTree.Selected.Level=ObjectLevel then begin
    ElTreeChange(ElTree, EditingNode);
    SaveModule(ElTree.Selected.Text);
  end;
end;

procedure TElEd.NewModule1Click(Sender: TObject);
var M:TModule;
    SP:Double;
    C:integer;
begin
  ModulePropertyDLG.NameEdit.Enabled:=True;
  ModulePropertyDLG.FileNameEdit.Enabled:=True;
  ModulePropertyDLG.ManufacturerEdit.Enabled:=True;
  ModulePropertyDLG.Reset;
  try
    if ElTree.Selected.Level=ManufacturerLevel then ModulePropertyDLG.ManufacturerEdit.Text:=ElTree.Selected.Text;
  except end;
  if ModulePropertyDLG.ShowModal = mrOK then begin
    M:=TModule.Create;
    StrPCopy(M.Info.Author, ModulePropertyDLG.AuthorEdit.Text);
    StrPCopy(M.Info.Name, ModulePropertyDLG.NameEdit.Text);
    StrPCopy(M.Info.Manufacturer, ModulePropertyDLG.ManufacturerEdit.Text);
    ModulePropertyDLG.RemarkMemo.GetTextBuf(M.Info.Remark, 127);
    StrPCopy(M.Info.System, ModulePropertyDLG.SystemEdit.Text);

    Val(ModulePropertyDLG.TrackWidthEdit.Text, SP, C);
    if C>0 then SP:=0;
    M.Info.Spurweite:=SP;

    Val(ModulePropertyDLG.ElWidthEdit.Text, SP, C);
    if C>0 then SP:=0;
    M.Info.ElWidth:=SP;

    M.Changed:=True;
    GlobalModules.AddModule(ModulePropertyDLG.FileNameEdit.Text, M);

    if GlobalModules.Modules.Count = 1 then FillTreeWithModules
                                       else FillInModule(ModulePropertyDLG.NameEdit.Text);
  end;
end;

function TElEd.CanClose:boolean;
var i:integer;
begin
  Result:=True;
  if Assigned (EditingNode) then ElTreeChange(ElTree, EditingNode);
  for i:=0 To GlobalModules.Modules.Count-1 do begin
    if not GlobalModules.IsSaved(GlobalModules.Modules[i]) then begin
      case ConfirmAbort(TransStr('[ModuleNotSaved!]')+' ( '+GlobalModules.Modules[i]+' ) '+
                 TransStr('[SaveNow?]')) of
        IDYes   : SaveModule(GlobalModules.Modules[i]);
        IDNo    : begin end; // do nothing
        IDCancel : Result:=False;
      end; //case
    end;
  end;
end;

procedure TElEd.ElEdOptionsClick(Sender: TObject);
begin
  // select the Element Editor tabsheet because the User most probably wants this one
  OptionsDLG.PageControl1.ActivePage:=OptionsDLG.ElEdTab;
  if OptionsDLG.ShowModal = mrOK then Plan.Invalidate;//sometimes Windows cheats
  // WITH redrawing parts of the Screen therefore we have To redraw it for sure
end;

procedure TElEd.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var i:integer;
begin
  if (Key=VK_Delete) then begin
    DeleteSelection;
    Plan.Invalidate;
    Key:=0;
    ActualizeEditIcons;
  end;
  if (Key=88{VK_X}) and (ssCtrl in Shift) then begin
    CopySelection;
    DeleteSelection;
    Plan.Invalidate;
    Key:=0;
  end;
  if (Key=67{VK_C}) and (ssCtrl in Shift) then begin
    CopySelection;
    Key:=0;
  end;
  if (Key=86{VK_V}) and (ssCtrl in Shift) then begin
// boc 2.01
    if not ((ssShift in Shift) or (ssAlt in Shift)) then PasteNormal
                                                    else StretchPaste;
// eoc 2.01
    Plan.Invalidate;
    Key:=0;
  end;
  if (Key=65{VK_A}) and (ssCtrl in Shift) then begin
    for i:=0 To Selected.Size-1 do Selected[i]:=True;
    ActualizeEditIcons;
    Plan.Invalidate;
    Key:=0;
  end;
  if TabControl.ActivePage = VisualTab then begin
    if Key=VK_Add then begin ZoomInBTNClick(Sender); Key:=0; end;
    if Key=VK_Subtract then begin ZoomOutBtnClick(Sender); Key:=0; end;
    if Key=VK_F4{Ord('1')} then begin
                  PosKey1:=CursorPos;
                  AngKey1:=CursorAngle;
                  Key:=0;
                  MessageBeep(maxint);
                end;
    if Key=VK_F5{Ord('2')} then begin
                  PosKey2:=CursorPos;
                  AngKey2:=CursorAngle;
                  Key:=0;
                  MessageBeep(maxint);
                end;
  end;
end;

procedure TElEd.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if (ActiveControl = VisualTab) then Key:=#0;
end;

procedure TElEd.ElTreeKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key in [#1, #3, #24, #22]) then Key:=#0;
end;


procedure TElEd.UndoBTNClick(Sender: TObject);
begin
  Undo;
  Plan.Invalidate;
end;

procedure TElEd.UndoTextBTNClick(Sender: TObject);
begin
  ActualizeData;
end;

procedure TElEd.PlanGetBounds(var UL, DR: TDoublePoint);
begin
  Element.GetRectAround0(UL, DR);
end;

procedure TElEd.PlanDruckerAusgabe(X:TCanvas; xs, ys, xf, yf:Double; BW:boolean);
begin
  X.Pen.Mode:=pmCopy;
  X.Pen.Color:=clBlack;
  Element.Draw(X, xs, ys, 0, xf, yf, @DrawInfo);
end;

procedure TElEd.PrintBTNClick(Sender: TObject);
var Preview:TPreviewForm;
begin
  Preview:=TPreviewForm.Create(Self);
  Preview.AusgabeProc:=PlanDruckerAusgabe;
  Preview.GetBoundsProc:=PlanGetBounds;
  Preview.Title:='Raily - '+EditingElement;
  Preview.Info.Name:=EditingElement;
  Preview.Info.Author:='('+EditingModule+')';
  Preview.PrepShowAll;
  Preview.ShowModal;
  Preview.Destroy;
end;

procedure TElEd.FormDeactivate(Sender: TObject);
begin
  GlobalElEdHeight:=Height;
  GlobalElEdWidth:=Width;
  GlobalElEdTop:=Top;
  GlobalElEdLeft:=Left;
end;

procedure TElEd.EditmoduleInfo1Click(Sender: TObject);
var MN:string;
    St:string;
    M :TModule;
    SP:Double;
    C :integer;
begin
  MN:=ElTree.Selected.Text;
  if GlobalModules.LoadModule(MN) then begin
    ModulePropertyDLG.NameEdit.Enabled:=False;
    ModulePropertyDLG.FileNameEdit.Enabled:=False;
    ModulePropertyDLG.ManufacturerEdit.Enabled:=False;

    ModulePropertyDLG.NameEdit.Text:=MN;
    ModulePropertyDLG.FileNameEdit.Text:=GlobalModules.KnownFileName(MN);
    ModulePropertyDLG.ManufacturerEdit.Text:=GlobalModules.ManufacturerOf(MN);

    Str(GlobalModules.SpurweiteOf(MN):2:2, St);
    ModulePropertyDLG.TrackWidthEdit.Text:=St;

    if GlobalModules.GetModule(MN, M) then begin
      ModulePropertyDLG.AuthorEdit.Text:=M.Info.Author;
      ModulePropertyDLG.RemarkMemo.SetTextBuf(M.Info.Remark);
      ModulePropertyDLG.SystemEdit.Text:=StrPas(M.Info.System);
      
      Str(M.Info.ElWidth:2:2, St);
      ModulePropertyDLG.ElWidthEdit.Text:=St;
    end;

    if ModulePropertyDLG.ShowModal = mrOK then begin
      StrPCopy(M.Info.Author, ModulePropertyDLG.AuthorEdit.Text);
      ModulePropertyDLG.RemarkMemo.GetTextBuf(M.Info.Remark, 127);
      StrPCopy(M.Info.System, ModulePropertyDLG.SystemEdit.Text);

      Val(ModulePropertyDLG.TrackWidthEdit.Text, SP, C);
      if C>0 then SP:=0;
      M.Info.Spurweite:=SP;
      GlobalModules.UpdateShortInfo(MN, SP);

      Val(ModulePropertyDLG.ElWidthEdit.Text, SP, C);
      if C>0 then SP:=0;
      M.Info.ElWidth:=SP;

      M.Changed:=True;
    end;
  end;
end;

procedure TElEd.ConvertModuleClick(Sender: TObject);
var M:TModule;
    NewName:string;
    Error:integer;
begin
  if OpenConvert.Execute then begin
    GlobalModules.ConvertModule(OpenConvert.FileName, GlobalModulePath, M, NewName, Error);
    if Error<>0 then begin
      case Error of
        1: Warn(TransStr('[same already loaded]'));
        2: Warn(TransStr('[illegal module file]'));
        3: Warn(TransStr('[general file Error]'));
      end;
    end else begin
      GlobalModules.AddModule(NewName, M);
      FillInModule(M.Info.Name);
      Inform(TransStr('[New file Name is...]')+''''+ NewName+'''');
    end
  end;
end;

function TElEd.CheckDragablePoints(X, Y:integer; Points:TList; var Nr:integer):boolean;
var i        : integer;
    TX, TY   : integer;
begin
  Result:=False;
  if not Assigned(Points) then exit;
  Nr:=-1;
  for i:=0 To Points.Count-1 do begin
    TX:=Round((TPointObject(Points[i]).P.X+XSpace)*Zoomfactor);
    TY:=Round((TPointObject(Points[i]).P.Y+YSpace)*Zoomfactor);
    if (X>TX-PointRectSize) and (X<TX+PointRectSize) and
       (Y>TY-PointRectSize) and (Y<TY+PointRectSize) then begin
       Nr:=i;
       Result:=True;
       exit;
    end;
  end;
end;

procedure TElEd.ClearTPointList(var X:TList);
var i:integer;
begin
  if Assigned(X) then
    for i:=X.Count-1 downto 0 do
      if Assigned(X.Items[i]) then begin
        TPointObject(X.Items[i]).Free;
        X.Delete(i);
      end;
  X.Pack; // should not be needed
end;

procedure TElEd.DrawDragablePoints(Points:TList; Selected:integer);
var i        : integer;
    OldStyle : TBrushStyle;
    OldMode  : TPenMode;
    TX, TY   : integer;
    PRS      : integer;
    OldWidth : integer;
begin
  if not Assigned(Points) then exit;
  OldMode:=Plan.Canvas.Pen.Mode;
  Plan.Canvas.Pen.Mode:=pmNotxor;
  OldStyle:=Plan.Canvas.Brush.Style;
  Plan.Canvas.Brush.Color:=clBlack;
  Plan.Canvas.Brush.Style:=bsClear;
  OldWidth:=Plan.Canvas.Pen.Width;
  for i:=0 To Points.Count-1 do begin
    if i=Selected then Plan.Canvas.Pen.Color:=clRed else Plan.Canvas.Pen.Color:=clBlack;
    TX:=Round((TPointObject(Points[i]).P.X+XSpace)*Zoomfactor);
    TY:=Round((TPointObject(Points[i]).P.Y+YSpace)*Zoomfactor);
    PRS:=PointRectSize;
    Plan.Canvas.Rectangle(TX-PRS, TY-PRS, TX+PRS, TY+PRS);
  end;
  Plan.Canvas.Brush.Style:=OldStyle;
  Plan.Canvas.Pen.Mode:=OldMode;
  Plan.Canvas.Pen.Width:=OldWidth;
end;

procedure TElEd.AddInterestingPoints(Points:TList; Invert:boolean);
var i: integer;

  procedure HandleLine(X: TLineAtom);
  begin
    Points.Add(TPointObject.Create(X.A.X, X.A.Y));
    Points.Add(TPointObject.Create(X.B.X, X.B.Y));
  end;

  procedure HandlePoly(X: TPolyLineAtom);
  var j:integer;
      P:TDoublePoint;
  begin
    for j:=0 To X.Points.Count-1 do begin
      P:=TPointObject(X.Points[j]).P;
      Points.Add(TPointObject.Create(P.X, P.Y));
    end;
  end;


  procedure HandleArc(X: TCSegAtom);
  var A, B, C:TDoublePoint;
      cs, sn:Extended;
  begin
    SinCos(X.w, sn, cs);
    A.X:=X.Center.X+cs*X.R;A.Y:=X.Center.Y-sn*X.R;
    SinCos((X.w+X.dw), sn, cs);
    B.X:=X.Center.X+cs*X.R;B.Y:=X.Center.Y-sn*X.R;
    SinCos((X.w+X.dw/2), sn, cs);
    C.X:=X.Center.X+cs*X.R;C.Y:=X.Center.Y-sn*X.R;
    Points.Add(TPointObject.Create(X.Center.X, X.Center.Y));
    Points.Add(TPointObject.Create(A.X, A.Y));
    Points.Add(TPointObject.Create(B.X, B.Y));
    Points.Add(TPointObject.Create(C.X, C.Y));
  end;

  procedure HandleCnct(X: TCnctAtom);
  begin
    Points.Add(TPointObject.Create(X.P.X, X.P.Y));
  end;

begin
  for i:=Element.BasicElements.Count-1 downto 0 do begin
    if Selected[i] XOR Invert then begin
      if TBasicAtom(Element.BasicElements.Items[i]) is TLineAtom then HandleLine(Element.BasicElements.Items[i]);
      if TBasicAtom(Element.BasicElements.Items[i]) is TCSegAtom then HandleArc(Element.BasicElements.Items[i]);
      if TBasicAtom(Element.BasicElements.Items[i]) is TCnctAtom then HandleCnct(Element.BasicElements.Items[i]);
      if TBasicAtom(Element.BasicElements.Items[i]) is TPolyLineAtom then HandlePoly(Element.BasicElements.Items[i]);
    end;
  end;
end;

//WARNING runtime quadratic in number of atoms!!!
procedure TElEd.AddAllCuts(PL:TList);
var i, j: integer;
    P:TDoublePoint;
    L1, L2:TLineAtom;
begin
  for i := 0 To Element.BasicElements.Count-1 do
    for j:=0 To i-1 do begin
      if (TBasicAtom(Element.BasicElements[i]) is TLineAtom)
         and (TBasicAtom(Element.BasicElements[j]) is TLineAtom)then begin
           L1:=(TBasicAtom(Element.BasicElements[i]) as TLineAtom);
           L2:=(TBasicAtom(Element.BasicElements[j]) as TLineAtom);
           if EchtSchnitt(L1.A, L1.B, L2.A, L2.B, P) then begin
             PL.Add(TPointObject.Create(P.X, P.Y));
           end;
      end;
  end;
end;

procedure TElEd.ElementSelected;
var i: integer;

  procedure HandleLine(X: TLineAtom);
  var j:integer;
      L2:TLineAtom;
      P:TDoublePoint;
  begin
    EditPoints.Add(TPointObject.Create(X.A.X, X.A.Y));
    EditPoints.Add(TPointObject.Create(X.B.X, X.B.Y));
    for j:=0 To Element.BasicElements.Count-1 do
      if (TBasicAtom(Element.BasicElements[j]) is TLineAtom)then begin
        L2:=(TBasicAtom(Element.BasicElements[j]) as TLineAtom);
        if (L2<>X) and EchtSchnitt(X.A, X.B, L2.A, L2.B, P) then
         FixPoints.Add(TPointObject.Create(P.X, P.Y));
      end;
  end;

  procedure HandleArc(X: TCSegAtom);
  var A, B, C:TDoublePoint;
      cs, sn:Extended;
  begin
    SinCos(X.w, sn, cs);
    A.X:=X.Center.X+cs*X.R;A.Y:=X.Center.Y-sn*X.R;
    SinCos((X.w+X.dw), sn, cs);
    B.X:=X.Center.X+cs*X.R;B.Y:=X.Center.Y-sn*X.R;
    SinCos((X.w+X.dw/2), sn, cs);
    C.X:=X.Center.X+cs*X.R;C.Y:=X.Center.Y-sn*X.R;
    EditPoints.Add(TPointObject.Create(X.Center.X, X.Center.Y));
    EditPoints.Add(TPointObject.Create(X.Center.X+X.R, X.Center.Y+X.R));
    EditPoints.Add(TPointObject.Create(A.X, A.Y));
    EditPoints.Add(TPointObject.Create(B.X, B.Y));
    EditPoints.Add(TPointObject.Create(C.X, C.Y));
  end;

  procedure HandlePoly(X: TPolyLineAtom);
  var j:integer;
      P:TDoublePoint;
  begin
    for j:=0 To X.Points.Count-1 do begin
      P:=TPointObject(X.Points[j]).P;
      EditPoints.Add(TPointObject.Create(P.X, P.Y));
    end;
  end;

begin
  ClearTPointList(EditPoints);
  if CountSelected=1 then begin
    ClearTPointList(FixPoints);
    AddInterestingPoints(FixPoints, True);
  //  AddAllCuts(FixPoints);
    for i:=Element.BasicElements.Count-1 downto 0 do begin
      if Selected[i] and (TBasicAtom(Element.BasicElements.Items[i]).EditState and CAtomEdLk = 0) then begin
        if TBasicAtom(Element.BasicElements.Items[i]) is TLineAtom then HandleLine(Element.BasicElements.Items[i]);
        if TBasicAtom(Element.BasicElements.Items[i]) is TCSegAtom then HandleArc(Element.BasicElements.Items[i]);
        if TBasicAtom(Element.BasicElements.Items[i]) is TPolyLineAtom then HandlePoly(Element.BasicElements.Items[i]);
   //     if TBasicAtom(Element.BasicElements.Items[i]) is TCnctAtom then HandleCnct;
        Break;
      end;
    end;
  end;
end;

function TElEd.ToPlanCoordinates(X, Y:integer):TDoublePoint;
begin
  Result.X := X / Zoomfactor - XSpace;
  Result.Y := Y / Zoomfactor - YSpace;
end;

procedure TElEd.AdjustElement(TouchedNr:integer; Shift:TShiftState);
var i: integer;

  function AdjustPoint(P:TDoublePoint):TDoublePoint; register;
  begin
    Result:=P;
    if not (ssShift in Shift) then Result:=PointToGridPoint(P);
    if (ssAlt in Shift) then Result:=MapToPointList(FixPoints, P, GlobalElEdGRange, False);
  end;

  procedure HandleLine(X: TLineAtom);
  var Dist:Double;
  begin
    if TouchedNr=0 then X.A:=AdjustPoint(TPointObject(EditPoints[0]).P);
    if TouchedNr=1 then X.B:=AdjustPoint(TPointObject(EditPoints[1]).P);
    if (ssCtrl in Shift) then begin
      Dist:=CalcDist(X.A, X.B);
      if TouchedNr=0 then begin
        X.A.X:=X.B.X-Cos(X.w)*Dist;
        X.A.Y:=X.B.Y-Sin(X.w)*Dist;
      end;
      if TouchedNr=1 then begin
        X.B.X:=X.A.X+Cos(X.w)*Dist;
        X.B.Y:=X.A.Y+Sin(X.w)*Dist;
      end;
    end else X.w:=MyAng(X.B.X-X.A.X, X.B.Y-X.A.Y);
    X.RectCheckIn;
    ElementSelected;
  end;

  procedure HandlePoly(X: TPolyLineAtom);
  begin
    if (TouchedNr>=0) and (TouchedNr<X.Points.Count) then begin
      TPointObject(X.Points[TouchedNr]).P:=AdjustPoint(TPointObject(EditPoints[TouchedNr]).P);
    end;
    X.RectCheckIn;
    ElementSelected;
  end;

  procedure HandleArc(X: TCSegAtom);
  const TouchCenter=0;
        TouchDR=1;
        TouchAng1=2;
        TouchAng2=3;
        TouchMovAng=4;
var
    CSegStart,
    CSegEnd         : Double;

  begin
    case TouchedNr of
         TouchCenter: begin
                        X.Center:=AdjustPoint(TPointObject(EditPoints[0]).P);
                      end;
         TouchDR    : begin
                        if not (ssShift in Shift) then
                          X.R:=Round(CalcDist(X.Center, TPointObject(EditPoints[1]).P)/SQRT(2)/GlobalElEdGridSize)*GlobalElEdGridSize
                        else
                          X.R:=CalcDist(X.Center, TPointObject(EditPoints[1]).P)/SQRT(2);
                      end;

         TouchAng1,
         TouchAng2  : begin
                         if TouchedNr=TouchAng1 then TPointObject(EditPoints[TouchAng1]).P:=AdjustPoint(TPointObject(EditPoints[TouchAng1]).P);
                         if TouchedNr=TouchAng2 then TPointObject(EditPoints[TouchAng2]).P:=AdjustPoint(TPointObject(EditPoints[TouchAng2]).P);

                         CSegStart:=-MyAng(TPointObject(EditPoints[TouchAng1]).P.X-X.Center.X,
                                    TPointObject(EditPoints[TouchAng1]).P.Y-X.Center.Y){-Pi/2};
                         CSegEnd:=-MyAng(TPointObject(EditPoints[TouchAng2]).P.X-X.Center.X,
                                    TPointObject(EditPoints[TouchAng2]).P.Y-X.Center.Y){-Pi/2};
                         X.w:=CSegStart;
                         X.dw:=FixedAngle(CSegEnd-CSegStart);
                      end;
         TouchMovAng: begin
                         X.w:=-MyAng(AdjustPoint(TPointObject(EditPoints[TouchMovAng]).P).X-X.Center.X,
                                    AdjustPoint(TPointObject(EditPoints[TouchMovAng]).P).Y-X.Center.Y)-X.dw/2{-Pi/2};

                      end;

    end;
    X.RectCheckIn;
    ElementSelected;
  end;

begin
  if CountSelected=1 then begin
    for i:=Element.BasicElements.Count-1 downto 0 do begin
      if Selected[i] then begin
        if TBasicAtom(Element.BasicElements.Items[i]) is TLineAtom then HandleLine(Element.BasicElements.Items[i]);
        if TBasicAtom(Element.BasicElements.Items[i]) is TCSegAtom then HandleArc(Element.BasicElements.Items[i]);
        if TBasicAtom(Element.BasicElements.Items[i]) is TPolyLineAtom then HandlePoly(Element.BasicElements.Items[i]);
   //     if TBasicAtom(Element.BasicElements.Items[i]) is TCnctAtom then HandleCnct;
        Break;
      end;
    end;
  end;
end;

procedure TElEd.XORDrawSelected;
var i:integer;
    OldMode:TPenMode;
begin
  OldMode:=Plan.Canvas.Pen.Mode;
  Plan.Canvas.Pen.Mode:=pmNotxor;
  for i:=Element.BasicElements.Count-1 downto 0 do
    if Selected[i] then
      Element.SingleDraw(Plan.Canvas, XSpace, YSpace, 0, Zoomfactor, Zoomfactor, clRed, i, @DrawInfo);
  Plan.Canvas.Pen.Mode:=OldMode;
end;

function TElEd.MapToPointList(Points:TList; Point:TDoublePoint; Tol:Double; Always:boolean):TDoublePoint;
var i     : integer;
    MinI  : integer;
    MinR  : Double;
    First : boolean;
begin
  First:=True;
  MinR:=Tol+1;
  MinI:=0;
  for i:=0 To Points.Count-1 do begin
    if First then begin
      First:=False;
      MinR:=CalcDist(TPointObject(Points[i]).P, Point);
      MinI:=i;
    end;
    if CalcDist(TPointObject(Points[i]).P, Point)< MinR then begin
      MinI:=i;
      MinR:=CalcDist(TPointObject(Points[i]).P, Point);
    end;
  end;
  if (not First) and ((MinR<=Tol) or Always) then Result:=TPointObject(Points[MinI]).P
                                             else Result:=Point;
end;

procedure TElEd.SilentUpdate;
begin
  DrawElements; // nothing else so far
end;

function TElEd.PointToGridPoint(X:TDoublePoint):TDoublePoint;
begin
  if GlobalElEdGridSize>0 then begin
    Result.X:=Round(X.X/GlobalElEdGridSize)*GlobalElEdGridSize;
    Result.Y:=Round(X.Y/GlobalElEdGridSize)*GlobalElEdGridSize;
  end else Result:=X;
end;

procedure TElEd.GetRectAroundSelection(var A, B:TDoublePoint);
var i:longint;
    TUL, TDR: TDoublePoint;
    First:boolean;
begin
  A.X:=0; A.Y:=0; B:=A;
  First:=True;
  for i:=Element.BasicElements.Count-1 downto 0 do begin
    if Selected[i] then begin
      TBasicAtom(Element.BasicElements[i]).GetBasicRectAround(TUL, TDR);
      if First then begin
        A:=TUL;
        B:=TDR;
        First:=False;
      end;
      if TUL.X<A.X then A.X:=TUL.X;
      if TUL.Y<A.Y then A.Y:=TUL.Y;
      if TDR.X>B.X then B.X:=TDR.X;
      if TDR.Y>B.Y then B.Y:=TDR.Y;
    end;
  end;
end;

procedure TElEd.MirrorXBTNClick(Sender: TObject);
var i:longint;
    TUL, TDR: TDoublePoint;
    Mirror:Double;

  procedure HandleLine(X: TLineAtom);
  begin
    X.A:=XMirrorPoint(Mirror, X.A);
    X.B:=XMirrorPoint(Mirror, X.B);
    X.w:=MyAng(X.B.X-X.A.X, X.B.Y-X.A.Y);
    X.RectCheckIn;
  end;

  procedure HandleArc(X: TCSegAtom);
  begin
    X.Center:=XMirrorPoint(Mirror, X.Center);
    X.w:=Pi-X.w-X.dw;
    X.RectCheckIn;
  end;

  procedure HandleCnct(X: TCnctAtom);
  begin
    X.P:=XMirrorPoint(Mirror, X.P);
    X.w:=Pi-X.w;
    X.RectCheckIn;
  end;

  procedure HandlePoly(X: TPolyLineAtom);
  var j:integer;
  begin
    for j:=0 To X.Points.Count-1 do
      TPointObject(X.Points[j]).P:=XMirrorPoint(Mirror, TPointObject(X.Points[j]).P);
    X.RectCheckIn;
  end;

begin
  SaveContext;
  GetRectAroundSelection(TUL, TDR);
  Mirror:=(TUL.X+TDR.X)/2;
  for i:=Element.BasicElements.Count-1 downto 0 do begin
    if Selected[i] then begin
      if TBasicAtom(Element.BasicElements.Items[i]) is TLineAtom then HandleLine(Element.BasicElements.Items[i]);
      if TBasicAtom(Element.BasicElements.Items[i]) is TCSegAtom then HandleArc(Element.BasicElements.Items[i]);
      if TBasicAtom(Element.BasicElements.Items[i]) is TCnctAtom then HandleCnct(Element.BasicElements.Items[i]);
      if TBasicAtom(Element.BasicElements.Items[i]) is TPolyLineAtom then HandlePoly(Element.BasicElements.Items[i]);
    end;
  end;
  ElementSelected;
  Plan.Invalidate;
end;

procedure TElEd.MirrorYBTNClick(Sender: TObject);
var i:longint;
    TUL, TDR: TDoublePoint;
    Mirror:Double;

  procedure HandleLine(X: TLineAtom);
  begin
    X.A:=YMirrorPoint(Mirror, X.A);
    X.B:=YMirrorPoint(Mirror, X.B);
    X.w:=MyAng(X.B.X-X.A.X, X.B.Y-X.A.Y);
    X.RectCheckIn;
  end;

  procedure HandlePoly(X: TPolyLineAtom);
  var j:integer;
  begin
    for j:=0 To X.Points.Count-1 do
      TPointObject(X.Points[j]).P:=YMirrorPoint(Mirror, TPointObject(X.Points[j]).P);
    X.RectCheckIn;
  end;

  procedure HandleArc(X: TCSegAtom);
  begin
    X.Center:=YMirrorPoint(Mirror, X.Center);
    X.w:=-X.w-X.dw;
    X.RectCheckIn;
  end;

  procedure HandleCnct(X: TCnctAtom);
  begin
    X.P:=YMirrorPoint(Mirror, X.P);
    X.w:=-X.w;
    X.RectCheckIn;
  end;

begin
  SaveContext;
  GetRectAroundSelection(TUL, TDR);
  Mirror:=(TUL.Y+TDR.Y)/2;
  for i:=Element.BasicElements.Count-1 downto 0 do begin
    if Selected[i] then begin
      if TBasicAtom(Element.BasicElements.Items[i]) is TLineAtom then HandleLine(Element.BasicElements.Items[i]);
      if TBasicAtom(Element.BasicElements.Items[i]) is TCSegAtom then HandleArc(Element.BasicElements.Items[i]);
      if TBasicAtom(Element.BasicElements.Items[i]) is TCnctAtom then HandleCnct(Element.BasicElements.Items[i]);
      if TBasicAtom(Element.BasicElements.Items[i]) is TPolyLineAtom then HandlePoly(Element.BasicElements.Items[i]);
    end;
  end;
  ElementSelected;
  Plan.Invalidate;
end;

procedure TElEd.RotateBTNClick(Sender: TObject);
var i:longint;
    Pivot, TUL, TDR: TDoublePoint;
    Delta : Double;
    C     : integer;
begin
  Val(Trim(DeltaAngleEdit.Text), Delta, C);
  if C=0 then begin
    SaveContext;
    Delta:=-FixedAngle(Pi*Delta/180);
    GetRectAroundSelection(TUL, TDR);
    Pivot:=Middle(TUL, TDR);
    for i:=Element.BasicElements.Count-1 downto 0 do begin
      if Selected[i] then begin
        TBasicAtom(Element.BasicElements.Items[i]).RotateAround(Pivot, Delta);
      end;
    end;
    ElementSelected;
    Plan.Invalidate;
  end;
end;

procedure TElEd.PolygonBTNClick(Sender: TObject);
var XPoly: TPolyLineAtom;
begin
  SaveContext;
  XPoly:=TPolyLineAtom.Create;
  XPoly.FillStyle:=bsSolid;
  XPoly.BrushCol:=clGray;
  XPoly.PenCol:=clBlack;

  XPoly.Transparent:=False;
  XPoly.Points.Add(TPointObject.Create(-10,-10));
  XPoly.Points.Add(TPointObject.Create(-10, 10));
  XPoly.Points.Add(TPointObject.Create(10,10));
  XPoly.Points.Add(TPointObject.Create(10,-10));
  XPoly.RectCheckIn;
  Selected.Size:=Element.BasicElements.Count+1;
  ClearSelection;
  Selected[Element.BasicElements.Add(XPoly)]:=True;
  ElementSelected;
  Plan.Invalidate;
  ActualizeEditIcons;
end;

procedure TElEd.PolyDelVertexClick(Sender: TObject);
var i:integer;
    XPoly:TPolyLineAtom;
begin
  if CountSelected=1 then begin
    for i:=Element.BasicElements.Count-1 downto 0 do begin
      if Selected[i] then begin
        if TBasicAtom(Element.BasicElements.Items[i]) is TPolyLineAtom then begin
          XPoly:=TPolyLineAtom(Element.BasicElements.Items[i]);
          if (SelEdPoint>=0) and (SelEdPoint<XPoly.Points.Count) then begin
            TPointObject(XPoly.Points[SelEdPoint]).Free;
            XPoly.Points.Delete(SelEdPoint);
            XPoly.Points.Pack;
            ElementSelected;
            Plan.Invalidate;
          end;
        end;
        Break;
      end;
    end;
  end;
end;

procedure TElEd.PolyAddVertexClick(Sender: TObject);
var i:integer;
    XPoly:TPolyLineAtom;
    NP:TDoublePoint;
begin
  if CountSelected=1 then begin
    for i:=Element.BasicElements.Count-1 downto 0 do begin
      if Selected[i] then begin
        if TBasicAtom(Element.BasicElements.Items[i]) is TPolyLineAtom then begin
          XPoly:=TPolyLineAtom(Element.BasicElements.Items[i]);
          if (SelEdPoint>=0) and (SelEdPoint<XPoly.Points.Count) then begin
            NP:=Middle(TPointObject(XPoly.Points[SelEdPoint]).P, TPointObject(XPoly.Points[(SelEdPoint+1) MOD XPoly.Points.Count]).P);
            XPoly.Points.insert((SelEdPoint+1)MOD XPoly.Points.Count, TPointObject.Create(NP.X, NP.Y));
            ElementSelected;
            Plan.Invalidate;
          end;
        end;
        Break;
      end;
    end;
  end;
end;

procedure TElEd.PolyBorderColClick(Sender: TObject);
var i:integer;
    XPoly:TPolyLineAtom;
begin
  if CountSelected=1 then begin
    for i:=Element.BasicElements.Count-1 downto 0 do begin
      if Selected[i] then begin
        if TBasicAtom(Element.BasicElements.Items[i]) is TPolyLineAtom then begin
          XPoly:=TPolyLineAtom(Element.BasicElements.Items[i]);
          BorderColDLG.Color:=XPoly.PenCol;
          if BorderColDLG.Execute then begin
            SaveContext;
            XPoly.PenCol:=BorderColDLG.Color;
            ElementSelected;
            Plan.Invalidate;
          end;
        end;
        Break;
      end;
    end;
  end;
end;

procedure TElEd.PolyContentColClick(Sender: TObject);
var i:integer;
    XPoly:TPolyLineAtom;
begin
  if CountSelected=1 then begin
    for i:=Element.BasicElements.Count-1 downto 0 do begin
      if Selected[i] then begin
        if TBasicAtom(Element.BasicElements.Items[i]) is TPolyLineAtom then begin
          XPoly:=TPolyLineAtom(Element.BasicElements.Items[i]);
          BorderColDLG.Color:=XPoly.BrushCol;
          if BorderColDLG.Execute then begin
            SaveContext;
            XPoly.BrushCol:=BorderColDLG.Color;
            ElementSelected;
            Plan.Invalidate;
          end;
        end;
        Break;
      end;
    end;
  end;
end;

procedure TElEd.MoveDownBTNClick(Sender: TObject);
var i:integer;
begin
  if CountSelected<>1 then exit;
  SaveContext;
  for i:=Element.BasicElements.Count-1 downto 1 do begin
    if Selected[i] then begin
      Element.BasicElements.Exchange(i, i-1);
      Selected[i]:=False;
      Selected[i-1]:=True;
      Plan.Invalidate;
      Break;
    end;
  end;
end;

procedure TElEd.MoveUpBTNClick(Sender: TObject);
var i:integer;
begin
  if CountSelected<>1 then exit;
  SaveContext;
  for i:=Element.BasicElements.Count-2 downto 0 do begin
    if Selected[i] then begin
      Element.BasicElements.Exchange(i, i+1);
      Selected[i]:=False;
      Selected[i+1]:=True;
      Plan.Invalidate;
      Break;
    end;
  end;
end;

procedure TElEd.GetVisibleRect(var TL, DR:TDoublePoint);
var X, Y:Double;
begin
  X:=Planscroll.HorzScrollBar.position;
  Y:=Planscroll.VertScrollBar.position;
  TL.X:=X/Zoomfactor-XSpace;
  TL.Y:=Y/Zoomfactor-YSpace;
  X:=Planscroll.HorzScrollBar.position+Planscroll.Width;
  Y:=Planscroll.VertScrollBar.position+Planscroll.Height;
  DR.X:=X/Zoomfactor-XSpace;
  DR.Y:=Y/Zoomfactor-YSpace;
end;

procedure TElEd.DrawGrid;
var TL, DR:TDoublePoint;
    X, Y  : Double;
    Delta : Double;
begin
  Delta:=GlobalElEdGridSize;
  if Delta*Zoomfactor<7 then exit;
  GetVisibleRect(TL, DR);
  TL.Y:=(Trunc(TL.Y/Delta)-1)*Delta;
  TL.X:=(Trunc(TL.X/Delta)-1)*Delta;
  Y:=TL.Y;
  while Y<DR.Y do begin
    X:=TL.X;
    while X<DR.X do begin
      X:=X+Delta;
      Plan.Canvas.MoveTo(Round((X+XSpace)*Zoomfactor), Round((Y+YSpace)*Zoomfactor));
      Plan.Canvas.LineTo(Round((X+XSpace)*Zoomfactor)+1, Round((Y+YSpace)*Zoomfactor)+1);
    end;
    Y:=Y+Delta;
  end;
end;

procedure TElEd.FormPaint(Sender: TObject);
var X, Y:integer;
begin
  X:=0;
  while X<Width do begin
    Y:=0;
    while Y<Height do begin
      Canvas.Draw(X, Y, Marmor.Picture.Graphic);
      Inc(Y, Marmor.Picture.Height);
    end;
    Inc(X, Marmor.Picture.Width);
  end;
end;

procedure TElEd.FormHide(Sender: TObject);
begin
  ElTreeChange(ElTree, EditingNode);
end;

procedure TElEd.ElTreeEdited(Sender: TObject; Node: TTreeNode;
  var S: string);
var M:TModule;
    old:string;
begin
  if GlobalModules.GetModule(EditingModule, M) then begin
    old:=EditingElement;
    if Length(S)>20 then S:=Copy(S, 1, 20);
    EditingElement:=S;
    StrPCopy(Element.Info.Name, S);
    Node.Text:=S;
    if old<>EditingElement then begin
      IsSaved:=False;
      ImplementChange(EditingNode, True);
      M.RemoveElement(old);
    end;
  end;
end;

procedure TElEd.ElTreeEditing(Sender: TObject; Node: TTreeNode;
  var AllowEdit: boolean);
begin
  AllowEdit:=(Assigned(Node) and (Node.Level=ElementLevel));
end;

procedure TElEd.ElEdPasteAtomBTNMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if (Button=mbLeft) and ((ssShift in Shift) or(ssAlt in Shift) or (ssCtrl in Shift)) then
    StretchPaste
  else
    PasteNormal;
end;

procedure TElEd.ElEdPasteMClick(Sender: TObject);
begin
  PasteNormal;
end;

procedure TElEd.Stretchpaste1Click(Sender: TObject);
begin
  StretchPaste;
end;

end.
