(* Copyright (c) 1994-2001, Enigon Software
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list
  of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this
  list of conditions and the following disclaimer in the documentation and/or
  other materials provided with the distribution.
- Neither the name of Enigon Software nor the names of its contributors may be
  used to endorse or promote products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-- end of licence --
Author: tfrey@enigon.com
Compiled version of Raily 2.0 can be found at http://www.enigon.com/museum *)
unit ImportTypes;

interface
type Int16=-32768 .. 32767;

     TImportSchienenTyp = (Gerade, Kurve, Weiche, Kreuzung, Kreuzungsweiche,
                           Spezialelement, UebergangsStueck, FlexElement, LengthFlex, gnu, muell, gaga);
// WARNING do not (NEVER, in NO case, ABSOLUTELY not) use ALIGNED RECORDS
{$ALIGN OFF}
     TImportModuleRecord = PACKED RECORD
                      ModulName      : array[0..25] of CHAR;
                      ModulDatei     : array[0..8]  of CHAR;
                      System         : array[0..4]  of CHAR;
                      HerstellerList : Pointer;
                      Hersteller     : array[0..15] of CHAR;
                      Autor          : array[0..20] of CHAR;
                      Anmerkung      : array[0..40] of CHAR;
                    end;
                    
     TImportElementInfo = PACKED RECORD
                      Name           : array[0..20] of CHAR;
                      Bemerkung      : array[0..20] of CHAR;
                      TheType        : TImportSchienenTyp;
                      TheRadius      : real;
                      TheLaenge      : real;
                      TheWinkel      : real;
                    end;

     TImportGridInfoRecord=PACKED RECORD
                       Show   : WordBOOL;
                       Null   : WordBOOL;
                       Fuenf  : WordBOOL;
                       Zehn   : WordBOOL;
                       Halb   : WordBOOL;
                       Meter  : WordBOOL;
                     end;

     TImportTextInfoRecord=PACKED RECORD
                       Selection: WordBOOL;
                       Always : WordBOOL;
                       NEVER  : WordBOOL;
                       SelectionFull:WordBOOL;
                       AlwaysFull:WordBOOL;
                       NeverFull:WordBOOL;
                     end;

     TImportRLYHeader = PACKED RECORD
                    Kennung: array[0..128] of CHAR;
                    Version: WORD;
                  end;

implementation


end.
