(* Copyright (c) 1994-2001, Enigon Software
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list
  of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this
  list of conditions and the following disclaimer in the documentation and/or
  other materials provided with the distribution.
- Neither the name of Enigon Software nor the names of its contributors may be
  used to endorse or promote products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-- end of licence --
Author: tfrey@enigon.com
Compiled version of Raily 2.0 can be found at http://www.enigon.com/museum *)
unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, StdCtrls, Buttons, Elementeditor, ComCtrls,
  Elemente,Modules, Globals, Plan, PlanEditor, AppTranslator, RailyTypes, ImportTypes, USpriteFX,
  Spin, ToolWin, ShellApi, GeneralConstants;

type
  THauptfenster = class(TForm)
    SideToolbar: TPanel;
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    exit1: TMenuItem;
    LoadPlanDLG: TOpenDialog;
    SavePlanDLG: TSaveDialog;
    Options1: TMenuItem;
    Hilfe1: TMenuItem;
    Index1: TMenuItem;
    Info1: TMenuItem;
    N1: TMenuItem;
    NewPlan1: TMenuItem;
    Open1: TMenuItem;
    Closeplan1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    Elementeditor1: TMenuItem;
    TopToolbar: TPanel;
    NewPlanBTN: TSpeedButton;
    OpenPlanBTN: TSpeedButton;
    SavePlanBTN: TSpeedButton;
    PrintBTN: TSpeedButton;
    CopyBTN: TSpeedButton;
    PasteBTN: TSpeedButton;
    CutBTN: TSpeedButton;
    DeleteBTN: TSpeedButton;
    UndoBTN: TSpeedButton;
    ActiveModulesBTN: TSpeedButton;
    TypFlexBTN: TSpeedButton;
    TypKreuzungBTN: TSpeedButton;
    TypWeicheBTN: TSpeedButton;
    TypKurveBTN: TSpeedButton;
    FollowingBTN: TSpeedButton;
    TypGeradeBTN: TSpeedButton;
    TypKreuzWeicheBTN: TSpeedButton;
    TypSpecialBTN: TSpeedButton;
    TypTransBTN: TSpeedButton;
    Panel1: TPanel;
    Panel2: TPanel;
    Overview: TPaintBox;
    Preview: TPaintBox;
    SpeedButton1: TSpeedButton;
    Windows1: TMenuItem;
    FXHeart: TTimer;
    Table1: TMenuItem;
    Standardtable1: TMenuItem;
    ClearTable1: TMenuItem;
    EditTable: TSpeedButton;
    Insertpoint1: TMenuItem;
    EditFlex: TSpeedButton;
    Extras1: TMenuItem;
    StandardProperties1: TMenuItem;
    ZoomInBTN: TSpeedButton;
    ZoomOutBtn: TSpeedButton;
    ShowAllBtn: TSpeedButton;
    Edit1: TMenuItem;
    Undo1: TMenuItem;
    N5: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Cut1: TMenuItem;
    Delete1: TMenuItem;
    Color1: TMenuItem;
    N6: TMenuItem;
    Saveplan1: TMenuItem;
    ExportBTN: TSpeedButton;
    LineExportDLG: TSaveDialog;
    ProgressBar1: TProgressBar;
    EditText: TSpeedButton;
    NewAngle: TSpeedButton;
    DeletePoint1: TMenuItem;
    Exportplan1: TMenuItem;
    Tile1: TMenuItem;
    Cascade1: TMenuItem;
    Arrangeicons1: TMenuItem;
    N4: TMenuItem;
    Printselection1: TMenuItem;
    LayerSelBTN: TSpeedButton;
    AppTranslator1: TAppTranslator;
    Saveas1: TMenuItem;
    N7: TMenuItem;
    SpeedButton2: TSpeedButton;
    CDROMHelp1: TMenuItem;
    N8: TMenuItem;
    SpeedButton3: TSpeedButton;
    N9: TMenuItem;
    CopyalltoMeta1: TMenuItem;
    procedure ShowAllBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EditTableClick(Sender: TObject);
    procedure OpenPlanBTNClick(Sender: TObject);
    procedure SavePlanBTNClick(Sender: TObject);
    procedure NewPlanBTNClick(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Info1Click(Sender: TObject);
    procedure Closeplan1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure exit1Click(Sender: TObject);
    procedure Elementeditor1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FollowingBTNClick(Sender: TObject);
    procedure OverviewPaint(Sender: TObject);
    procedure OverviewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure StatusBar1DrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure ActiveModulesBTNClick(Sender: TObject);
    procedure DeleteBTNClick(Sender: TObject);
    procedure FXHeartTimer(Sender: TObject);
    procedure CopyBTNClick(Sender: TObject);
    procedure CutBTNClick(Sender: TObject);
    procedure PreviewPaint(Sender: TObject);
    procedure TypGeradeBTNClick(Sender: TObject);
    procedure StatusBar1DblClick(Sender: TObject);
    procedure PasteBTNClick(Sender: TObject);
    procedure ZoomInBTNClick(Sender: TObject);
    procedure ZoomOutBtnClick(Sender: TObject);
    procedure Standardtable1Click(Sender: TObject);
    procedure ClearTable1Click(Sender: TObject);
    procedure Insertpoint1Click(Sender: TObject);
    procedure ActiveModulesBTNMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: integer);
    procedure PrintBTNClick(Sender: TObject);
    procedure OverviewMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: integer);
    procedure OverviewMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure UndoBTNClick(Sender: TObject);
    procedure StandardProperties1Click(Sender: TObject);
    procedure EditFlexClick(Sender: TObject);
    procedure ExportBTNClick(Sender: TObject);
    procedure DeletePoint1Click(Sender: TObject);
    procedure Tile1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure Arrangeicons1Click(Sender: TObject);
    procedure Printselection1Click(Sender: TObject);
    procedure EditTextClick(Sender: TObject);
    procedure EditTextMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer);
    procedure Color1Click(Sender: TObject);
    procedure NewAngleClick(Sender: TObject);
    procedure LayerSelBTNClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Saveas1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Index1Click(Sender: TObject);
    procedure CDROMHelp1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure CopyalltoMeta1Click(Sender: TObject);
  private
    { private-Deklarationen }
    FirstActiv       : boolean;
    ToLoadList       : TStringList;
  public
    FirstActiavtion  : boolean;
    Painting         : boolean;
    Stretch          : real;
    XSpace, YSpace   : longint;
    FirstPoint,
    SecondPoint      : TPoint;
    Zug              : array[0..10] of TSprite;
    ZugH             : array[0..10] of Byte;
    WagenNr          : integer;
    ZugLaenge        : integer;
    RunTrain         : boolean;
    CompleteRedraw   : boolean;
    PlanDblClickCount: integer;
    RecentDown       : boolean;
    OverviewMoving   : boolean;
    LastOvXPos,
    LastOvYPos       : integer;
    FirstPaint       : boolean;
    { public-Deklarationen }
    procedure UpdateFileMenu(Child:boolean);
    procedure ComposeATrain;
    procedure DecomposeATrain;
    procedure InstallPublicComponents;
    procedure WegMitDemZug;
    procedure SecondInstanceLoadFile(var Msg:TMessage); message WM_LoadFile;

    procedure OhTannenbaum; // Lites the bulbs of the Element editor
   private
    procedure ChooseBTN(X:TImportSchienenTyp);
    procedure ChooseMode(X:integer);
    procedure Retranslate(X:string);
    procedure SpecialMode(X:boolean);
    procedure ChildClosing;
    procedure CreateParams (var Params : TCreateParams); override;
    procedure ClearToLoadList;
  end;

var
  Hauptfenster: THauptfenster;

implementation

uses OptionsDialog, AboutDLG, NewCDRomLetter, Scanner;
{$R *.DFM}


procedure THauptfenster.CreateParams (var Params : TCreateParams);
begin
  inherited CreateParams (Params);
  Params.WinClassName:='ENIGON Raily 2.1';
end;

procedure THauptfenster.ComposeATrain;
var i:integer;
    Swap:TSprite;
    T:integer;
    R1, R2:integer;
begin
  Randomize;
  if not RunTrain then begin
    RunTrain:=TRUE;
    WagenNr:=6;
    for i:=0 TO WagenNr do Zug[i]:=TSprite.Create;
    Zug[0].LoadFromFile(GlobalPathBase+'Loki.dat'); ZugH[0]:=10;
    Zug[0].OldX:=-Zug[0].Bild.Width;
    Zug[1].LoadFromFile(GlobalPathBase+'WA2.dat');ZugH[1]:=5;
    Zug[2].LoadFromFile(GlobalPathBase+'WA.dat');ZugH[2]:=27;
    Zug[3].LoadFromFile(GlobalPathBase+'WB.dat');ZugH[3]:=20;
    Zug[4].LoadFromFile(GlobalPathBase+'WC.dat');ZugH[4]:=11;
    Zug[5].LoadFromFile(GlobalPathBase+'WD.dat');ZugH[5]:=21;
    Zug[6].LoadFromFile(GlobalPathBase+'WE.dat');ZugH[6]:=12;
    for i:=0 TO 3 do begin
      R1:=Random(5)+1;
      R2:=Random(5)+1;
      if R1<>R2 then begin
        Swap:=Zug[R1]; T:=ZugH[R1];
        Zug[R1]:=Zug[R2]; ZugH[R1]:=ZugH[R2];
        Zug[R2]:=Swap; ZugH[R2]:=T;
      end;
    end;
    ZugLaenge:=0;
    for i:=0 TO WagenNr do INC(ZugLaenge, Zug[i].Bild.Width);
  end;
end;

procedure THauptfenster.DecomposeATrain;
var i:integer;
begin
  if RunTrain then begin
    RunTrain:=FALSE;
    for i:=0 TO WagenNr do begin
      Zug[i].Free;
      Zug[i]:=NIL;
    end;
    WagenNr:=0;
  end;
end;

procedure THauptfenster.ShowAllBtnClick(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).ShowAll;
end;

procedure THauptfenster.FormCreate(Sender: TObject);
begin
  ToLoadList:=TStringList.Create;
  FirstActiv:=TRUE;
  RunTrain:=FALSE;
  PlanDblClickCount:=0;
  Top:=GlobalTop;     Left:=GlobalLeft;
  Width:=GlobalWidth; Height:=GlobalHeight;
  OverviewMoving:=FALSE;
  GlobalProgressBar:=ProgressBar1;
  GlobalAppTranslator:=AppTranslator1;
  GlobalProgressBar.Visible:=FALSE;
  FirstPaint:=TRUE;
end;


procedure THauptfenster.InstallPublicComponents;
begin
   ParentElements.Overview:=Overview;
   ParentElements.Preview:=Preview;
   ParentElements.Timer:=FXHeart;
   ParentElements.Status:=StatusBar1;
   ParentElements_ChooseBTN:=ChooseBTN;
   ParentElements_ChooseMode:=ChooseMode;
   ParentElements_IsClosing:=ChildClosing;
   ParentElements.Translator:=AppTranslator1;
   ParentElements_SpecialMode:=SpecialMode;
   ChooseBTN(Kurve);
   //  X.SetSomeComponents(T)
end;

procedure THauptfenster.EditTableClick(Sender: TObject);
begin
  if EditTable.Down then ChooseMode(1);
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).EditTable(EditTable.Down);
end;

procedure THauptfenster.OpenPlanBTNClick(Sender: TObject);
var Temp : TPlanWindow;
    i    : integer;
begin
  LoadPlanDLG.InitialDir:=GlobalWorkPath;
  if LoadPlanDLG.Execute then begin
    for i:=0 TO LoadPlanDLG.Files.Count-1 do begin
      Temp:=TPlanWindow.Create(Self);
      UpdateFileMenu(TRUE);
      Temp.WindowState:=wsMaximized;
      Temp.Load(LoadPlanDLG.Files[i]);
      Temp.Show;
      Application.Processmessages;
      Overview.Invalidate;
    end;
    ChooseMode(0);
    OhTannenbaum;
  end;
end;

procedure THauptfenster.SecondInstanceLoadFile(var Msg:TMessage);
var FileName:string;
    at:Atom;
begin
  SetLength(FileName, Msg.wParam+1);
  at:=Msg.LParam;
  GlobalGetAtomName(at, PChar(FileName), Length(FileName));
  GlobalDeleteAtom(at);
  if FileName[1]<>'/' then ToLoadList.Add(FileName);
  Application.Restore;
  Application.BringToFront;
end;

procedure THauptfenster.SavePlanBTNClick(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then
    if not TPlanWindow(ActiveMDIChild).MyPlan.PlanDestroyed then
      TPlanWindow(ActiveMDIChild).SavePlan
    else Saveas1Click(NIL);
end;

procedure THauptfenster.NewPlanBTNClick(Sender: TObject);
var Temp:TPlanWindow;
begin
  Overview.Invalidate;
  Temp:=TPlanWindow.Create(Self);
  UpdateFileMenu(TRUE);
  Temp.WindowState:=wsMaximized;
  Temp.Show;
  Temp.ShowAll;
  ChooseMode(0);
end;

procedure THauptfenster.Options1Click(Sender: TObject);
var i:integer;
begin
  OptionsDLG.ShowModal;
  for i:=0 TO MDIChildCount-1 do TPlanWindow(MDIChildren[i]).OptionsChanged;
end;

procedure THauptfenster.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  GlobalHeight:=Height;
  GlobalWidth:=Width;
  GlobalTop:=Top;
  GlobalLeft:=Left;
  Action:=caNone;
  if ElEd.CanClose then begin
    Action:=caFree;
  end;
end;

procedure THauptfenster.Info1Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure THauptfenster.Closeplan1Click(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).Close;
end;

procedure THauptfenster.FormActivate(Sender: TObject);
var Dummy:integer;
begin
  if FirstActiv then begin
    if (ParamCount>0) and (LowerCase(ParamStr(1))=DevelopStr) then begin
      SpeedButton1.Visible:=TRUE;
      SpeedButton2.Visible:=TRUE;
    end;

    AppTranslator1.ScanForLanguages(GlobalPathBase, FALSE);
    AppTranslator1.GetAvailLanguages(GlobalAvailLangList);
    if not GlobalAvailLangList.Find(GlobalCurrentLang, Dummy) then
      if GlobalAvailLangList.Count>0 then GlobalCurrentLang:=GlobalAvailLangList[0];
    AppTranslator1.FileName:=AppTranslator1.GetLangFileName(GlobalCurrentLang);
    AppTranslator1.Translate;
    GlobalCurrentLang:=AppTranslator1.LangName;
    OptionsDLG.Retranslate:=Retranslate;
    FirstActiv:=FALSE;
    GlobalModules.ReadRemarks(GlobalModulePath, TransStr('[ModTransExt]'));
  end;
  UpdateFileMenu(MDIChildCount>0);
  InstallPublicComponents;
end;

procedure THauptfenster.Retranslate(X:string);
var i:integer;
begin
  AppTranslator1.FileName:=AppTranslator1.GetLangFileName(X);
  GlobalCurrentLang:=X;
  AppTranslator1.Translate;
  GlobalModules.ReadRemarks(GlobalModulePath, TransStr('[ModTransExt]'));
  for i:=0 TO MDIChildCount-1 do TPlanWindow(MDIChildren[i]).Retranslate;
end;

procedure THauptfenster.UpdateFileMenu(Child:boolean);
begin
    Closeplan1.Enabled:=Child;
    Print1.Enabled:=Child;
    ZoomInBTN.Enabled:=Child;
    ZoomOutBtn.Enabled:=Child;
    ShowAllBtn.Enabled:=Child;
    SavePlanBTN.Enabled:=Child;
    ExportBTN.Enabled:=Child;
    PrintBTN.Enabled:=Child;
    ActiveModulesBTN.Enabled:=Child;
    FollowingBTN.Enabled:=Child;
    TypKurveBTN.Enabled:=Child;
    TypGeradeBTN.Enabled:=Child;
    TypWeicheBTN.Enabled:=Child;
    TypKreuzungBTN.Enabled:=Child;
    TypKreuzWeicheBTN.Enabled:=Child;
    TypSpecialBTN.Enabled:=Child;
    TypTransBTN.Enabled:=Child;
    TypFlexBTN.Enabled:=Child;
    EditTable.Enabled:=Child;
    EditFlex.Enabled:=Child;
    EditText.Enabled:=Child;
    CutBTN.Enabled:=Child;
    CopyBTN.Enabled:=Child;
    PasteBTN.Enabled:=Child;
    DeleteBTN.Enabled:=Child;
    UndoBTN.Enabled:=Child;
    LayerSelBTN.Enabled:=Child;
    NewAngle.Enabled:=Child;
  if Child then begin
    //only the first time
    if MDIChildCount=1 then begin
      MainMenu1.Items[1].Enabled:=TRUE;
      MainMenu1.Items[2].Enabled:=FALSE;
      MainMenu1.Items[3].Enabled:=TRUE;
      MainMenu1.Items[5].Enabled:=TRUE;
      Saveplan1.Enabled:=TRUE;
      Exportplan1.Enabled:=TRUE;
      ElEd.Hide;
// Maximize after menu update --> bug worked around and flickerfree
{      if(ActiveMDIChild is TPlanWindow) then begin
      // arrgh bug in windoof/delphi
        TPlanWindow(ActiveMDIChild).BorderIcons:=TPlanWindow(ActiveMDIChild).BorderIcons-[biSystemMenu];
        TPlanWindow(ActiveMDIChild).BorderIcons:=TPlanWindow(ActiveMDIChild).BorderIcons+[biSystemMenu];
      end;}
    end;
  end else begin
    MainMenu1.Items[1].Enabled:=FALSE;
    MainMenu1.Items[2].Enabled:=TRUE;
    MainMenu1.Items[3].Enabled:=FALSE;
    MainMenu1.Items[5].Enabled:=FALSE;
    Saveplan1.Enabled:=FALSE;
    Exportplan1.Enabled:=FALSE;
  end;
end;

procedure THauptfenster.exit1Click(Sender: TObject);
begin
  Close;
end;

procedure THauptfenster.Elementeditor1Click(Sender: TObject);
begin
  ElEd.Show;
end;

procedure THauptfenster.SpeedButton1Click(Sender: TObject);
begin
  AppTranslator1.AddTransList(Application, FALSE);
  if ActiveMDIChild is TPlanWindow then AppTranslator1.AddTransList(TPlanWindow(ActiveMDIChild), TRUE);
end;

procedure THauptfenster.FollowingBTNClick(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).FollowingElement;
end;

procedure THauptfenster.OverviewPaint(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).RedrawOverview
                                   else begin
                                     Overview.Canvas.TextOut(2,2,'Raily 2.1');
                                   end;
end;

procedure THauptfenster.StatusBar1DrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
begin
  FXHeart.Enabled:=FALSE;
  if RunTrain then begin
    WegMitDemZug;
    StatusBar.Invalidate;
  end;
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).DrawStatus(StatusBar.Canvas, Rect)
                                   else begin
    StatusBar.Canvas.TextOut(2,2,'ENIGON-Software presents : Raily 2.1 (C) Copyright (1993-1998) by Thomas M. Frey & Christoph Rthenmund');
  end;
  FXHeart.Enabled:=TRUE;
end;

procedure THauptfenster.ActiveModulesBTNClick(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).ModuleSelection;
  OhTannenbaum;
end;

procedure THauptfenster.DeleteBTNClick(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).TrashSelection;
end;

procedure THauptfenster.ClearToLoadList;
var Temp : TPlanWindow;
    i    : integer;
    FileName:string;
    Changed: boolean;
begin
  Changed:=FALSE;
  try
    for i:=ToLoadList.Count-1 downto 0 do begin
      FileName:=ToLoadList[i];
      ToLoadList.Delete(i);
      Temp:=TPlanWindow.Create(Self);
      UpdateFileMenu(TRUE);
      Temp.WindowState:=wsMaximized;
      Temp.Load(FileName);
      Temp.Show;
      Application.Processmessages;
      Changed:=TRUE;
    end;
  finally
    ToLoadList.Clear;
    if Changed then begin
      Overview.Invalidate;
      ChooseMode(0);
      OhTannenbaum;
    end;  
  end;
end;

procedure THauptfenster.FXHeartTimer(Sender: TObject);
var i:integer;
begin
  FXHeart.Enabled:=FALSE;
  try
    ClearToLoadList;
    if (ActiveMDIChild is TPlanWindow)
      then TPlanWindow(ActiveMDIChild).FXTick;

    if Assigned(Zug[0]) and RunTrain then begin
      if Zug[0].OldX<Width+ZugLaenge then Zug[0].MoveTo(StatusBar1.Canvas, Zug[0].OldX+2, ZugH[0])
                                     else Zug[0].MoveTo(StatusBar1.Canvas, -Zug[0].Bild.Width, ZugH[0]);

      for i:=1 TO WagenNr do if Assigned(Zug[i]) then begin
        if Assigned(Zug[i]) then Zug[i].MoveTo(StatusBar1.Canvas, Zug[i-1].OldX-Zug[i].Bild.Width, ZugH[i] );
      end;
    end;
  except end;  
  FXHeart.Enabled:=TRUE;
end;

procedure THauptfenster.CopyBTNClick(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).CopySelection;
end;

procedure THauptfenster.CutBTNClick(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).CutSelection;
end;

procedure THauptfenster.PreviewPaint(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).UpdatePreview
                                   else begin
                                     Overview.Canvas.TextOut(2,2,'Raily 2.1 for Windows');
                                   end;
end;

procedure THauptfenster.TypGeradeBTNClick(Sender: TObject);
var X:TImportSchienenTyp;
begin
  X:=Gerade;
  if Sender=TypKurveBTN then X:=Kurve;
  if Sender=TypWeicheBTN then X:=Weiche;
  if Sender=TypKreuzungBTN then X:=Kreuzung;
  if Sender=TypKreuzWeicheBTN then X:=Kreuzungsweiche;
  if Sender=TypSpecialBTN then X:=Spezialelement;
  if Sender=TypTransBTN then X:=UebergangsStueck;
  if Sender=TypFlexBTN then X:=FlexElement;
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).SetActualTyp(X);
end;

procedure THauptfenster.ChooseBTN(X:TImportSchienenTyp);
begin
  case X of
    Kurve            : TypKurveBTN.Down:=TRUE;
    Gerade           : TypGeradeBTN.Down:=TRUE;
    Weiche           : TypWeicheBTN.Down:=TRUE;
    Kreuzung         : TypKreuzungBTN.Down:=TRUE;
    Kreuzungsweiche  : TypKreuzWeicheBTN.Down:=TRUE;
    Spezialelement   : TypSpecialBTN.Down:=TRUE;
    UebergangsStueck : TypTransBTN.Down:=TRUE;
    FlexElement      : TypFlexBTN.Down:=TRUE;
  end;
end;

procedure THauptfenster.SpecialMode(X:boolean);
begin
  TypKurveBTN.Enabled:= not X;
  TypGeradeBTN.Enabled:= not X;
  TypWeicheBTN.Enabled:= not X;
  TypKreuzungBTN.Enabled:= not X;
  TypKurveBTN.Enabled:= not X;
  TypKreuzWeicheBTN.Enabled:= not X;
  TypSpecialBTN.Enabled:= not X;
  TypTransBTN.Enabled:= not X;
  TypFlexBTN.Enabled:= not X;
  ActiveModulesBTN.Enabled:= not X;
  FollowingBTN.Enabled:= not X;
  ExportBTN.Enabled:= not X;
  PrintBTN.Enabled:= not X;
  CutBTN.Enabled:= not X;
  CopyBTN.Enabled:= not X;
  PasteBTN.Enabled:= not X;
  DeleteBTN.Enabled:= not X;
  UndoBTN.Enabled:= not X;
  Undo1.Enabled:=not X;
  Copy1.Enabled:=not X;
  Paste1.Enabled:=not X;
  Cut1.Enabled:=not X;
  Delete1.Enabled:=not X;
  Printselection1.Enabled:=not X;
  Color1.Enabled:=not X;
end;

procedure THauptfenster.ChooseMode(X:integer);
begin
  EditTable.Down:=FALSE;
  EditFlex.Down:=FALSE;
  EditText.Down:=FALSE;

  case X of
    1  : begin
           EditTable.Down:=TRUE; SpecialMode(TRUE);
           Delete1.Enabled:=TRUE;
           DeleteBTN.Enabled:=TRUE;
         end;
    2  : begin
           EditFlex.Down:=TRUE; SpecialMode(TRUE);
         end;
    3  : begin
           EditText.Down:=TRUE; SpecialMode(TRUE);
         end;
  else SpecialMode(FALSE); end;
end;

procedure THauptfenster.StatusBar1DblClick(Sender: TObject);
begin
  INC(PlanDblClickCount);
  if PlanDblClickCount = 3 then ComposeATrain;
end;

procedure THauptfenster.PasteBTNClick(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).PasteClipboard;
end;

procedure THauptfenster.WegMitDemZug;
var i:integer;
begin
  if RunTrain then begin
    for i:=0 TO WagenNr do if Assigned(Zug[i]) then Zug[i].Hide(StatusBar1.Canvas);
    DecomposeATrain;
    PlanDblClickCount:=0;
  end;
end;

procedure THauptfenster.ChildClosing;
begin
  UpdateFileMenu(MDIChildCount>1);
end;


procedure THauptfenster.ZoomInBTNClick(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).Bigger;
end;

procedure THauptfenster.ZoomOutBtnClick(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).Smaller;
end;

procedure THauptfenster.Standardtable1Click(Sender: TObject);
begin
   if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).BuildStandardTable;
end;

procedure THauptfenster.ClearTable1Click(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).ClearTable;
end;

procedure THauptfenster.Insertpoint1Click(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).InsertTablePoint;
end;

procedure THauptfenster.ActiveModulesBTNMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if (Button=MBLeft) and ((ssAlt in Shift) or (ssCtrl in Shift)) then
    if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).ResetModulesInUse;
end;

procedure THauptfenster.PrintBTNClick(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).PrintDialog;
end;

procedure THauptfenster.OhTannenbaum;
var i:integer;
begin
  for i:=0 TO GlobalModules.Modules.Count-1 do ElEd.LiteModule(GlobalModules.Modules[i]);
end;

procedure THauptfenster.OverviewMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if Button=MBRight then Overview.Invalidate;
  if ActiveMDIChild is TPlanWindow then begin
    if Button=MBLeft then begin
      TPlanWindow(ActiveMDIChild).OverviewClick(X, Y);
      RecentDown:=TRUE;
      // TO prevent moving if not wanted
      LastOvXPos:=X;
      LastOvYPos:=Y;
    end;
  end;
end;

procedure THauptfenster.OverviewMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: integer);
begin
  // TO prevent moving if not wanted
  OverviewMoving:=OverviewMoving or ( RecentDown and
   (X>0) and (Y>0) and (X<Overview.Width) and (Y<Overview.Height) and
    ((Abs(X-LastOvXPos)>2) or (Abs(Y-LastOvYPos)>2)));

  if OverviewMoving and (X>0) and (Y>0) and (X<Overview.Width) and (Y<Overview.Height) and
    (ActiveMDIChild is TPlanWindow) then TPlanWindow(ActiveMDIChild).OverviewClick(X, Y);
end;

procedure THauptfenster.OverviewMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  RecentDown:=FALSE;
  OverviewMoving:=FALSE;
end;

procedure THauptfenster.UndoBTNClick(Sender: TObject);
begin
    if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).Undo;
end;

procedure THauptfenster.StandardProperties1Click(Sender: TObject);
var i:integer;
begin
  if Confirm(TransStr('[ReallyStandard?]')) then begin
    ResetProfile;
    for i:=0 TO MDIChildCount-1 do TPlanWindow(MDIChildren[i]).OptionsChanged;
  end;
end;

procedure THauptfenster.EditFlexClick(Sender: TObject);
begin
  if EditFlex.Down then ChooseMode(2);
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).EditFlex(EditFlex.Down);
end;

procedure THauptfenster.ExportBTNClick(Sender: TObject);
begin
  LineExportDLG.InitialDir:=GlobalExportPath;
  if LineExportDLG.Execute then begin
    if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).ExportLines(LineExportDLG.FileName);
  end;
end;

procedure THauptfenster.DeletePoint1Click(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).DeleteTablePoint;
end;

procedure THauptfenster.Tile1Click(Sender: TObject);
begin
  TileMode := tbVertical;
  Tile;
end;

procedure THauptfenster.Cascade1Click(Sender: TObject);
begin
  Cascade;
end;

procedure THauptfenster.Arrangeicons1Click(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure THauptfenster.Printselection1Click(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).PrintSelectionDialog
end;

procedure THauptfenster.EditTextClick(Sender: TObject);
begin
  if EditText.Down then ChooseMode(3);
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).EditText(EditText.Down);
end;

procedure THauptfenster.EditTextMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if not EditText.Down then
    if (Button=MBLeft) and ((ssAlt in Shift) or (ssCtrl in Shift)) then
      if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).ResetTextPositions;

end;

procedure THauptfenster.Color1Click(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).ColorDialog
end;

procedure THauptfenster.NewAngleClick(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).NewAngle;
end;

procedure THauptfenster.LayerSelBTNClick(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).SelectLayers;
end;

procedure THauptfenster.FormPaint(Sender: TObject);
var
    Temp:TPlanWindow;
    i:integer;
    N:string;
    Print:boolean;
begin
  if not FirstPaint then Exit;
  FirstPaint:=FALSE;
  Print:=FALSE;
  Application.Processmessages;
  for i:=1 TO ParamCount do begin
    if (LowerCase(Trim(ParamStr(i)))=DevelopStr) then Continue;
    if UpperCase(Trim(ParamStr(i)))='/P' then begin
      Print:=TRUE;
      Continue;
    end;
    Application.Processmessages;
    Temp:=TPlanWindow.Create(Self);
    Application.Processmessages;
    UpdateFileMenu(TRUE);
    Application.Processmessages;
    Temp.WindowState:=wsMaximized;
    N:=ParamStr(i);
    if POS('.',N)<=0 then N:=Trim(N)+'.RLY';
    Application.Processmessages;
    Temp.Load(N);
    Application.Processmessages;
    Temp.Show;
    Application.Processmessages;
    Temp.ShowAll;
    Application.Processmessages;
    Overview.Invalidate;
    if Print then Temp.PrintDialog;
    Print:=FALSE;
  end;
end;

procedure THauptfenster.Saveas1Click(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).SaveAs;
end;

procedure THauptfenster.SpeedButton2Click(Sender: TObject);
begin
  GlobalModules.WriteRemarks(GlobalModulePath, TransStr('[ModTransExt]'));
end;

procedure THauptfenster.Index1Click(Sender: TObject);
begin
  Application.HelpFile := TransStr('[HelpFile]');
  Application.HelpCommand(HELP_CONTENTS, 0);
end;

procedure THauptfenster.CDROMHelp1Click(Sender: TObject);
var FName:string;
    Abort, Success:boolean;
begin
  Abort:=FALSE;
  Success:=FALSE;
  while not (Abort or Success) do begin
    FName:=GlobalCDROMDrive+':'+TransStr('[CDROMHelp]');
    if FileExists(FName) then begin
      ShellExecute(Self.Handle, 'open', PChar(FName), '', PChar(ExtractFilePath(FName)), SW_Show);
      Success:=TRUE;
    end else begin
      NewCDROMDriveDLG.CDROMEdit.Text:=GlobalCDROMDrive;
      if NewCDROMDriveDLG.ShowModal = mrOK then GlobalCDROMDrive:=NewCDROMDriveDLG.CDROMEdit.Text
                                           else Abort:=TRUE;
    end;
  end;
end;

var
  hSem:THandle;
  hw:Hwnd;
  at:Atom;
  st:string;
  i, j:integer;
  SemIsMine:boolean;


procedure THauptfenster.SpeedButton3Click(Sender: TObject);
begin
  ScannerForm.Show;
end;

procedure THauptfenster.CopyalltoMeta1Click(Sender: TObject);
begin
  if ActiveMDIChild is TPlanWindow then TPlanWindow(ActiveMDIChild).AllToMeta;
end;

initialization
  SemIsMine:=FALSE;
  hSem := CreateSemaphore(NIL, 0, 1, 'ENIGONRaily1997a');
  if ((hSem <> 0) and (GetLastError() = ERROR_ALREADY_EXISTS)) then begin
    j:=0;
    repeat
      hw:=FindWindow('ENIGON Raily 2.1', NIL);
      for i:=0 TO 10 do Application.Processmessages;
      INC(j);
    until (hw<>0) or (j>10000);
    for i:=1 TO ParamCount do begin
      st:=ParamStr(i);
      if st[i]='/' then Continue;
      at:=GlobalAddAtom(PChar(st));
      SendMessage(hw, WM_LoadFile, Length(st), integer(at));
      Application.Processmessages;
    end;

    if ParamCount = 0 then begin
      st:='/';
      at:=GlobalAddAtom(PChar(st));
      SendMessage(hw, WM_LoadFile, Length(st), integer(at));
      Application.Processmessages;
    end;
    Halt;
  end;
  SemIsMine:=TRUE;
finalization
  if SemIsMine then ReleaseSemaphore(hSem, 1, NIL);
end.


