(* Copyright (c) 1994-2001, Enigon Software
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list
  of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this
  list of conditions and the following disclaimer in the documentation and/or
  other materials provided with the distribution.
- Neither the name of Enigon Software nor the names of its contributors may be
  used to endorse or promote products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-- end of licence --
Author: tfrey@enigon.com
Compiled version of Raily 2.0 can be found at http://www.enigon.com/museum *)
unit OptionsDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Globals, StdCtrls, ComCtrls, Buttons, Spin, GeneralConstants, FileCtrl, Math;

type
  TOptionsDLG = class(TForm)
    PageControl1: TPageControl;
    OkBtn: TBitBtn;
    BitBtn2: TBitBtn;
    ElEdTab: TTabSheet;
    GroupBox1: TGroupBox;
    ElEdFastRBT: TRadioButton;
    ElEdExactRBT: TRadioButton;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    ElEdGravityRangeSpin: TSpinEdit;
    ElEdGravityEnabledCBX: TCheckBox;
    Label3: TLabel;
    ElEdPrecisionSpin: TSpinEdit;
    GroupBox3: TGroupBox;
    PlanEditTab: TTabSheet;
    GroupBox4: TGroupBox;
    PlanFastRBT: TRadioButton;
    PlanExactRBT: TRadioButton;
    Label4: TLabel;
    PlanPrecisionSpin: TSpinEdit;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    Label5: TLabel;
    ElEdUndoSpin: TSpinEdit;
    Label6: TLabel;
    LangTab: TTabSheet;
    LangList: TListBox;
    Label7: TLabel;
    PrintTab: TTabSheet;
    PlanMiddleCBX: TCheckBox;
    PlanDoubleCBX: TCheckBox;
    PlanBettungCBX: TCheckBox;
    SpeedDrawCBX: TCheckBox;
    PrintPlanGroupBox: TGroupBox;
    PlanPrintGrid: TCheckBox;
    PlanPrintTable: TCheckBox;
    TableGroup: TGroupBox;
    ShowTableNrs: TCheckBox;
    IncludeTable: TCheckBox;
    TextGroup: TGroupBox;
    PlanShowElName: TCheckBox;
    RTextFontHeight: TSpinEdit;
    Label18: TLabel;
    LayersGroup: TGroupBox;
    UseLayerCBX: TCheckBox;
    GrayUnusedLayers: TCheckBox;
    PlanPureGray: TCheckBox;
    UserTHeightLBL: TLabel;
    UsrTHeight: TSpinEdit;
    ShowUsrTx: TCheckBox;
    TabSheet1: TTabSheet;
    Overview: TGroupBox;
    PlanOOnCmdRBT: TRadioButton;
    PlanOAlways: TRadioButton;
    ConnectGroup: TGroupBox;
    ConnectDiffModules: TCheckBox;
    GroupBox9: TGroupBox;
    PlanGRange: TEdit;
    FlexGroupBox: TGroupBox;
    Label14: TLabel;
    Label16: TLabel;
    FlexRadiEdit: TEdit;
    Label19: TLabel;
    Label20: TLabel;
    PrintBWCBX: TCheckBox;
    GridGroupBox: TGroupBox;
    Label15: TLabel;
    Label17: TLabel;
    PlanGridEdit: TEdit;
    PlanShowGridCBX: TCheckBox;
    CnctrGRP: TGroupBox;
    SepElCBX: TCheckBox;
    ShowArrowsCBX: TCheckBox;
    GroupBox10: TGroupBox;
    TolDist: TLabel;
    Label22: TLabel;
    TolDistEdit: TEdit;
    Label23: TLabel;
    TolAngleEdit: TEdit;
    TolAngle: TLabel;
    GroupBox11: TGroupBox;
    DALBL: TLabel;
    DAEdit: TEdit;
    Label21: TLabel;
    GroupBox12: TGroupBox;
    ElEdGSize: TEdit;
    Label24: TLabel;
    ElEdMiddleCBX: TCheckBox;
    ElEdDoubleCBX: TCheckBox;
    ElEdElSizeCBX: TCheckBox;
    InvGBX: TGroupBox;
    MLeftLBL: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    MTopLBL: TLabel;
    MRightLBL: TLabel;
    Label11: TLabel;
    Label10: TLabel;
    MBotLBL: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    InfPicCBX: TCheckBox;
    INVLHSpin: TSpinEdit;
    INVFHSpin: TSpinEdit;
    LMSpin: TSpinEdit;
    TMSpin: TSpinEdit;
    RMSpin: TSpinEdit;
    BMSpin: TSpinEdit;
    INVHeader: TCheckBox;
    ElEdShowGrid: TCheckBox;
    ElEdTransPoly: TCheckBox;
    PlanTransPoly: TCheckBox;
    procedure OkBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ElEdExactRBTClick(Sender: TObject);
    procedure LangListClick(Sender: TObject);
  private
    { private-Deklarationen }
  public
    { public-Deklarationen }
    Retranslate : procedure (X:string) of object;
  end;

var
  OptionsDLG: TOptionsDLG;

implementation

{$R *.DFM}

procedure TOptionsDLG.OkBtnClick(Sender: TObject);
var c:integer;
    T:Double;
begin
// Plan
  GlobalPlanSingle := PlanMiddleCBX.Checked;
  GlobalPlanDouble := PlanDoubleCBX.Checked;
  GlobalPlanBettung := PlanBettungCBX.Checked;
  GlobalPlanTransPoly:=PlanTransPoly.Checked;

  // how to draw the connectors
  GlobalPlanSpeedDraw:=SpeedDrawCBX.Checked;
  GlobalPlanExact:=PlanExactRBT.Checked;

  GlobalPlanShowArrow:=ShowArrowsCBX.Checked;
  GlobalPlanSeparate :=SepElCBX.Checked;

  GlobalPlanPrec:=PlanPrecisionSpin.Value;
  // stupid user check
  if not (GlobalPlanSingle or GlobalPlanDouble or GlobalPlanBettung) then GlobalPlanDouble:=TRUE;
  //Flex
  T:=GlobalFlexLegalRad;
  VAL(Trim(FlexRadiEdit.Text), GlobalFlexLegalRad, c); if c>0 then GlobalFlexLegalRad:=T;
  // Grid
  T:=GlobalPlanGridSize;
  VAL(Trim(PlanGridEdit.Text), GlobalPlanGridSize, c); if c>0 then GlobalPlanGridSize:=T;
  GlobalPlanShowGrid:=PlanShowGridCBX.Checked;


  //Gravity Range
  T:=ABS(GlobalGravityRange);
  VAL(Trim(PlanGRange.Text), GlobalGravityRange, c); if (c>0) or (GlobalGravityRange<0) then GlobalGravityRange:=T;

  //Distance tolerance
  T:=ABS(GlobalDistTol);
  VAL(Trim(TolDistEdit.Text), GlobalDistTol, c); if (c>0) or (GlobalDistTol<0) then GlobalDistTol:=T;

  //Angle tolerance
  T:=ABS(GlobalAngleTol);
  VAL(Trim(TolAngleEdit.Text), GlobalAngleTol, c);
  GlobalAngleTol:=FixedAngle(DegToRad(GlobalAngleTol));
  if (c>0) or (GlobalAngleTol<0) then GlobalAngleTol:=T;

  //Delta Angle
  T:=ABS(GlobalDeltaAngle);
  VAL(Trim(DAEdit.Text), GlobalDeltaAngle, c); if (c>0) or (GlobalDeltaAngle<0) then GlobalDeltaAngle:=T;

  // Table
  GlobalTableSizeNrs:=ShowTableNrs.Checked;
  GlobalPlanIncTable:=IncludeTable.Checked;
  GlobalPlanShowNames:=PlanShowElName.Checked;
  GlobalRailNrHeight:=RTextFontHeight.Value;

  GlobalPlanUseLayers:=UseLayerCBX.Checked;
  GlobalPlanGrayLayer:=GrayUnusedLayers.Checked;
  GlobalPlanCheapGray:=PlanPureGray.Checked;
  GlobalUserTXTHeight:=UsrTHeight.Value;
  GlobalPlanUserTXT:=ShowUsrTx.Checked;

//  GlobalModulePath  := ModPathEdit.Text;

// Element editor
  GlobalElEdGravity := ElEdGravityEnabledCBX.Checked;
  GlobalElEdGridShow:= ElEdShowGrid.Checked;
  GlobalElEdGRange  := ElEdGravityRangeSpin.Value;
  GlobalElEdExact   := ElEdExactRBT.Checked;
  GlobalElEdPrec    := ElEdPrecisionSpin.Value;
  GlobalElEdMaxUndo := ElEdUndoSpin.Value;
  GlobalOverview    := PlanOAlways.Checked;
  GlobalCheckDiffMod:=ConnectDiffModules.Checked;
  GlobalElEdTransPoly:=ElEdTransPoly.Checked;

  // Grid Size in Elementeditor
  T:=GlobalElEdGridSize;
  VAL(Trim(ElEdGSize.Text), GlobalElEdGridSize, c); if c>0 then GlobalElEdGridSize:=T;

  // Print tab
  GlobalPlanPrintGrid:=PlanPrintGrid.Checked;
  GlobalPlanPrintTable:=PlanPrintTable.Checked;
  GlobalPrintBW:=PrintBWCBX.Checked;

// Inventory
  GlobalInvPictures := InfPicCBX.Checked;
  GlobalInvLM       := LMSpin.Value;
  GlobalInvTM       := TMSpin.Value;
  GlobalInvRM       := RMSpin.Value;
  GlobalInvBM       := BMSpin.Value;
  GlobalInvFontHeight:=INVFHSpin.Value;
  GlobalInvHeight   := INVLHSpin.Value;
  GlobalInvHeader   := INVHeader.Checked;

  GlobalElEdDouble:=0;
  if ElEdMiddleCBX.Checked then GlobalElEdDouble:=GlobalElEdDouble or CDrawInner;
  if ElEdDoubleCBX.Checked then GlobalElEdDouble:=GlobalElEdDouble or CDrawOuter;
  if ElEdElSizeCBX.Checked then GlobalElEdDouble:=GlobalElEdDouble or CDrawBettung;
  if (GlobalElEdDouble and (CDrawInner or CDrawOuter or CDrawBettung))=0 then begin
    GlobalElEdDouble:=CDrawInner;
		MessageDLG('Hi',mtInformation,[mbok],0);  // forgot this debug output in release ;-)
  end;

  ElEdChanged:=TRUE;

  ModalResult:=mrOK;
end;

procedure TOptionsDLG.FormActivate(Sender: TObject);
var Nr:integer;
    S : string;
begin
// Plan
  PlanMiddleCBX.Checked:=GlobalPlanSingle;
  PlanDoubleCBX.Checked:=GlobalPlanDouble;
  PlanBettungCBX.Checked:=GlobalPlanBettung;
  PlanTransPoly.Checked:=GlobalPlanTransPoly;

  // how to draw the connectors
  ShowArrowsCBX.Checked:=GlobalPlanShowArrow;
  SepElCBX.Checked:=GlobalPlanSeparate;

  SpeedDrawCBX.Checked:=GlobalPlanSpeedDraw;
  PlanPrecisionSpin.Value:=GlobalPlanPrec;
  PlanFastRBT.Checked:=TRUE;
  PlanExactRBT.Checked:=GlobalPlanExact;
  //Flex
  Str(GlobalFlexLegalRad:0:2, S); FlexRadiEdit.Text:=S;
  //Grid
  Str(GlobalPlanGridSize:0:2, S); PlanGridEdit.Text:=S;
  PlanShowGridCBX.Checked:=GlobalPlanShowGrid;

  //Distance tolerance
  Str(GlobalDistTol:0:2, S); TolDistEdit.Text:=S;

  //Angle tolerance
  Str(RadToDeg(FixedAngle(GlobalAngleTol)):0:2, S); TolAngleEdit.Text:=S;

  //Delta Angle
  Str(GlobalDeltaAngle:0:2, S); DAEdit.Text:=S;

  // Table
  ShowTableNrs.Checked:=GlobalTableSizeNrs;
  IncludeTable.Checked:=GlobalPlanIncTable;
  PlanShowElName.Checked:=GlobalPlanShowNames;
  RTextFontHeight.Value:=GlobalRailNrHeight;
  UseLayerCBX.Checked:=GlobalPlanUseLayers;
  GrayUnusedLayers.Checked:=GlobalPlanGrayLayer;
  PlanPureGray.Checked:=GlobalPlanCheapGray;
  ConnectDiffModules.Checked:=GlobalCheckDiffMod;
  UsrTHeight.Value:=GlobalUserTXTHeight;
  ShowUsrTx.Checked:=GlobalPlanUserTXT;

  Str(GlobalGravityRange:0:2, S); PlanGRange.Text:=S;


// Print tab
  PlanPrintGrid.Checked:=GlobalPlanPrintGrid;
  PlanPrintTable.Checked:=GlobalPlanPrintTable;
  PrintBWCBX.Checked:=GlobalPrintBW;

//  ModPathEdit.Text:=GlobalModulePath;
  ElEdGravityEnabledCBX.Checked:=GlobalElEdGravity;
  ElEdGravityRangeSpin.Value:=Round(GlobalElEdGRange);
  ElEdExactRBT.Checked:=TRUE;
  ElEdFastRBT.Checked:=not GlobalElEdExact;
  ElEdPrecisionSpin.Enabled:=ElEdExactRBT.Checked;
  ElEdPrecisionSpin.Value:=GlobalElEdPrec;
  ElEdUndoSpin.Value:= GlobalElEdMaxUndo;
  ElEdShowGrid.Checked:=GlobalElEdGridShow;

// Inventory
  InfPicCBX.Checked:=GlobalInvPictures;
  LMSpin.Value := GlobalInvLM;
  TMSpin.Value := GlobalInvTM;
  RMSpin.Value := GlobalInvRM;
  BMSpin.Value := GlobalInvBM;
  INVFHSpin.Value:=GlobalInvFontHeight;
  INVLHSpin.Value:=GlobalInvHeight;
  INVHeader.Checked:=GlobalInvHeader;

  PlanOOnCmdRBT.Checked:=TRUE;  PlanOAlways.Checked:=  GlobalOverview;

  ElEdMiddleCBX.Checked := GlobalElEdDouble and CDrawInner >0;
  ElEdDoubleCBX.Checked := GlobalElEdDouble and CDrawOuter >0;
  ElEdElSizeCBX.Checked := GlobalElEdDouble and CDrawBettung >0;
  ElEdTransPoly.Checked:=GlobalElEdTransPoly;

  if (GlobalElEdDouble and (CDrawInner or CDrawOuter or CDrawBettung))=0 then ElEdMiddleCBX.Checked;

  Str(GlobalElEdGridSize:0:2, S);ElEdGSize.Text:=S;

  LangList.Items.Clear;
  LangList.Items.AddStrings(GlobalAvailLangList);
  if GlobalAvailLangList.Find(GlobalCurrentLang, Nr) then LangList.ItemIndex:=Nr;
end;

procedure TOptionsDLG.ElEdExactRBTClick(Sender: TObject);
begin
  ElEdPrecisionSpin.Enabled:=ElEdExactRBT.Checked;
end;

procedure TOptionsDLG.LangListClick(Sender: TObject);
begin
  if (LangList.ItemIndex>=0) and (LangList.ItemIndex<LangList.Items.Count) and
     Assigned(Retranslate) then Retranslate(LangList.Items[LangList.ItemIndex]);
end;

end.
