(* Copyright (c) 1994-2001, Enigon Software
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list
	of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this
  list of conditions and the following disclaimer in the documentation and/or
  other materials provided with the distribution.
- Neither the name of Enigon Software nor the names of its contributors may be
  used to endorse or promote products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED to, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR a PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED to, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-- end of licence --
Author: tfrey@enigon.com, DXF stuff added by Bernhard Egger
Compiled version of Raily 2.0 can be found at http://www.enigon.com/museum *)
unit PlanEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Menus,
  Instances, RailyTypes, ImportTypes, Elemente, Modules, Globals, Plan, URailyFX,
  Spin, Grids, AppTranslator, UInventory, Buttons, PrintPreview, GeneralConstants,
  Math, UPlanUndo, ULineExporter;

type
	TPlanWindow = class(TForm)
    Planscroll: TScrollBox;
    Plan: TPaintBox;
    PlanTab: TPageControl;
    VisualSheet: TTabSheet;
    InfoSheet: TTabSheet;
    InventorySheet: TTabSheet;
    FileInfoGBX: TGroupBox;
    Label1: TLabel;
    FullPath: TEdit;
    RemarkMemo: TMemo;
    Label3: TLabel;
    InventoryGrid: TStringGrid;
    PlanRightPop: TPopupMenu;
    Paste: TMenuItem;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    Delete1: TMenuItem;
    PlanElNrLBL: TLabel;
    PlanInfoElNr: TEdit;
    AuthorEdit: TEdit;
    Label2: TLabel;
    IsNotSavedLBL: TLabel;
    SaveInvBTN: TSpeedButton;
    PrintBTN: TSpeedButton;
    ExportBTN: TSpeedButton;
    OpenInvBTN: TSpeedButton;
    INVShowAllCBX: TCheckBox;
    INVInclUsableModsCBX: TCheckBox;
    SaveInvDLG: TSaveDialog;
    LoadInvDLG: TOpenDialog;
    ExportInvDLG: TSaveDialog;
		Flex1: TMenuItem;
    ColorDialog1: TColorDialog;
    Color1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    TableEditPopup: TPopupMenu;
    N3: TMenuItem;
    Insertpoint1: TMenuItem;
		Deletepoint1: TMenuItem;
    ClearTable1: TMenuItem;
    Standardtable1: TMenuItem;
    FlexPopup: TPopupMenu;
    Addpoint1: TMenuItem;
    SavePlanDLG: TSaveDialog;
    Text1: TMenuItem;
    Showfullname1: TMenuItem;
    Showshortname1: TMenuItem;
    Noname1: TMenuItem;
    N4: TMenuItem;
    Resetposition1: TMenuItem;
    Layer1: TMenuItem;
    TextPopup: TPopupMenu;
    DeleteText1: TMenuItem;
    NewText1: TMenuItem;
    EditText1: TMenuItem;
    TrackLeng: TLabel;
    TrackLengthEdit: TEdit;
    Meter: TLabel;
    DeleteFlexPoint: TMenuItem;
    RTrackLenLBL: TLabel;
    RTrackLEdit: TEdit;
    Label5: TLabel;
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure PlanPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure PlanTabChange(Sender: TObject);
    procedure PlanMouseDown(Sender: TObject; Button: TMouseButton;
			Shift: TShiftState; X, Y: integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PlanDragOver(Sender, Source: TObject; X, Y: integer;
      State: TDragState; var Accept: boolean);
    procedure PlanMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: integer);
    procedure PlanMouseUp(Sender: TObject; Button: TMouseButton;
			Shift: TShiftState; X, Y: integer);
    procedure FormDestroy(Sender: TObject);
    procedure PasteClick(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);

    procedure InventoryGridSelectCell(Sender: TObject; Col, Row: longint;
      var CanSelect: boolean);
    procedure InventoryGridDrawCell(Sender: TObject; Col, Row: longint;
      Rect: TRect; State: TGridDrawState);
    procedure InventoryGridGetEditMask(Sender: TObject; ACol,
      ARow: longint; var Value: string);
    procedure InventoryGridSetEditText(Sender: TObject; ACol,
      ARow: longint; const Value: string);
    procedure InventoryGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure INVShowAllCBXClick(Sender: TObject);
    procedure PrintBTNClick(Sender: TObject);
    procedure ExportBTNClick(Sender: TObject);
    procedure OpenInvBTNClick(Sender: TObject);
    procedure SaveInvBTNClick(Sender: TObject);
    procedure Flex1Click(Sender: TObject);
    procedure Color1Click(Sender: TObject);
    procedure AuthorEditChange(Sender: TObject);
    procedure RemarkMemoChange(Sender: TObject);
    procedure Insertpoint1Click(Sender: TObject);
    procedure Deletepoint1Click(Sender: TObject);
    procedure ClearTable1Click(Sender: TObject);
    procedure Standardtable1Click(Sender: TObject);
    procedure Addpoint1Click(Sender: TObject);
    procedure DeleteFlexPointClick(Sender: TObject);
		procedure FormDeactivate(Sender: TObject);
    procedure Showfullname1Click(Sender: TObject);
    procedure Showshortname1Click(Sender: TObject);
    procedure Noname1Click(Sender: TObject);
    procedure Resetposition1Click(Sender: TObject);
    procedure Layer1Click(Sender: TObject);
    procedure NewText1Click(Sender: TObject);
    procedure DeleteText1Click(Sender: TObject);
		procedure EditText1Click(Sender: TObject);
    procedure AuthorEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { private-Deklarationen }
    Translated : boolean;
    RailyFX    : TRailyFX;
    XSpace,
    YSpace     : Double;
    Zoomfactor : Double;

    CursorPos       : TDoublePoint;
    CursorAngle     : Double;
    UserRotation    : Double;
    FirstPoint,
    SecondPoint     : TPoint;

    CurrentModule,
    CurrentElement  : string;
    CurrentPointer  : TElement;
    CurrentColor    : TColor;
    CurrentInstList,
    CurrentFolge    : TList;
    CurrentAllFreeConList:TList;
    CurrentOldFolge : TList;
    CurrentNewPlace : integer;
    CurrentAddPos   : TDoublePoint;
    CurrentCM       : TDoublePoint;
    CurrentAddAngle : Double;
    CurrentOldPlace : integer;

    CurrentTextPList: TList;

    PlacingElements : boolean;
    MousePositioning: boolean;
    MovingPossible  : boolean;
    RectSelecting   : boolean;
    Zooming         : boolean;

    TableEditing    : boolean;
		MovTablePoint   : boolean;
    SelTablePoint   : integer;

    FlexEditing     : boolean;
    MoveFlexPoint   : boolean;
    SelFlexPoint    : integer;
    CurrentFlexPoly : TList;
    CurrentFlexInst : TInstance;
    CurrentFlexINr  : integer;
    CurrentLayer    : integer;
    CurrentLFlexMin,
    CurrentLFlexMax : Double;

    TextEditing     : boolean;
    MoveTextPoint   : boolean;
    SelTextNr       : integer;

    CurrentTyp      : TImportSchienenTyp;
    LastOfTyp       : array[gerade..FlexElement] of integer;
    LastDragPos     : TDoublePoint;

    ModulesInUse    : TStringList;


    OverviewF       : Double;
    OverviewXS      : Double;
    OverviewYS      : Double;

    TextDX, TextDY  : Double;
    CTextA, CTextB  : TDoublePoint;
    CurrentText     : string;
    CurrentTextNr   : integer;

    CurrentFileName : string;
    HasInfoFloater  : boolean;

    procedure Rearrange;
  public
    { public-Deklarationen }
    MyPlan      : TPlan;
		function ShowAllFactor:Double;
    procedure ShowAll;
    procedure FollowingElement;
    function Save(Name:string):boolean;
    function SavePlan:boolean;
    function Load(Name:string):boolean;
    procedure RedrawOverview;
    procedure OverviewClick(X, Y:integer);
    procedure CenterToPos(P:TDoublePoint);
    function GetCenterPos:TDoublePoint;
    procedure TrashSelection;
    procedure CopySelection;
    procedure CutSelection;
    procedure PasteClipboard;
    procedure AllToMeta;
    procedure DrawListElements(X:TList);
    procedure NextNewPlace;
    procedure NextOldPlace;
    procedure ConfirmCurrentPlace;
    procedure AbortPlace;
    procedure FXTick;
    procedure StopFX;
    procedure SilentUpdate;
    procedure OverviewSilentUpdate;
    procedure DrawStatus(C:TCanvas; R:TRect);
    procedure NextElement;
    procedure LastElement;
    procedure ShowPreview(X:TCanvas; l, t, w, h:integer; CM, CE:string; HandStand:boolean);
    procedure UpdatePreview;
    procedure Bigger;
    procedure Smaller;
    procedure SetActualTyp(X:TImportSchienenTyp);
		procedure UpdateInfoSheet;
    procedure UpdateInventorySheet;
    procedure CurrentElementToCurrentList;
    procedure GetCurrentRect(var tUL, tDR:TDoublePoint);
    procedure ZoomRect(A, B: TDoublePoint);

    // Editing "floating" points for table / flex
    procedure DrawDragablePoints(points:TList; Selected:integer);
		function CheckDragablePoints(X, Y:integer;points:TList;var Nr:integer):boolean;
		function CheckTextPoints(X, Y:integer; var Nr:integer):boolean;
		procedure FreeTextPointList;
		procedure EditTable(Really:boolean);
		procedure EditFlex(Really:boolean);
		procedure EditText(Really:boolean);
		procedure DeletePolyPoint(points:TList; Nr:integer);
		//procedures concerning the table
		procedure BuildStandardTable;
		procedure ClearTable;
    procedure CleverDrawTable;
    procedure InsertTablePoint;
    procedure DeleteTablePoint;
    // procedures concerning selection of Modules
    procedure ModuleSelection;
    procedure ResetModulesInUse; // Selects all the currently needed Modules
    // procedures dealing with the inventory
    procedure InventoryPageCount(DW, DH:integer; var PC:integer);
    procedure InventoryPagePrint(X:TCanvas; DW, DH, PG:integer);
    // procedures dealing with the printer
    procedure PrintDialog;
    procedure PlanGetBounds(var UL, DR: TDoublePoint);
    procedure PlanDruckerAusgabe(X:TCanvas; xs, ys, xf, yf:Double; BW:boolean);
    procedure Undo;
    procedure Retranslate;
    procedure PopupEditMenu(X, Y:integer);
    function IsLegalElement(CM, CE:string):boolean;
    procedure FreeConnectorList(var X:TList);
    procedure FreeTPointList(var X:TList);
    function UseGravity(GravityPointList:TList; var P:TDoublePoint; var A:Double):boolean;
    procedure ExportLines(N:string);
    procedure OptionsChanged;
		procedure GetVisibleRect(var TL, DR:TDoublePoint);
    procedure ShowGrid;

    //Printing a selection
    procedure SelectionGetBounds(var UL, DR: TDoublePoint);
    procedure PrintSelection(X:TCanvas; xs, ys, xf, yf:Double; BW:boolean);
    procedure PrintSelectionDialog;

		procedure ResetTextPositions;
    procedure NewAngle;

    procedure ColorDialog;

    procedure SelectLayers;
    procedure RescanAllTexts;
    procedure NewUserText;
    procedure DeleteuserText;
		procedure EditUserText;
    function AskIfModDifferenceOk(S1, S2:string; P:TDoublePoint):boolean;
    function AskIfSystemDifferenceOk(S1, S2:string; P:TDoublePoint):boolean;
    procedure SaveAs;
  end;


implementation
{$R *.DFM}
uses UModuleSelect, OptionsDialog, QueryDoubleDLG, LayerDLG, LayerSelectDLG,
  UNewTextDLG;

const PointRectSize = 5;
      ModNameCol    = 0;
      ElNameCol     = 1;
      PreviewCol    = 2;
      EditableCol   = 3;
      UsedCol       = 4;
      ResultCol     = 5;

procedure TPlanWindow.FormCreate(Sender: TObject);
var i:TImportSchienenTyp;
begin
	CurrentTextNr:=-1;
  CurrentText:='';

  CurrentColor:=clBlack;
  CurrentLayer:=0;
  Translated:=FALSE;
  MyPlan:=TPlan.Create;
  MyPlan.OkNotTheSameModules:=AskIfModDifferenceOk;
	MyPlan.OkNotTheSameSystems:=AskIfSystemDifferenceOk;
  RailyFX:=TRailyFX.Create;
  ModulesInUse:=TStringList.Create;
  ModulesInUse.Duplicates:=dupIgnore; // we need a module only once
  ModulesInUse.Sorted:=TRUE; // why not

  for i:= gerade to Uebergangsstueck do LastOfTyp[i]:=0;

  Zoomfactor:=1; //  to prevent from division by zero

  PlacingElements:=FALSE;
  MousePositioning:=FALSE;
  TextEditing:=FALSE;
  Zooming:=FALSE;
  PlanTab.ActivePage:=VisualSheet;
  CurrentFileName:='';
  HasInfoFloater:=FALSE;
  UserRotation:=0;
end;

procedure TPlanWindow.FormCloseQuery(Sender: TObject;
  var CanClose: boolean);
var R:integer;
begin
  if not MyPlan.IsSaved then begin
    CanClose:=FALSE;
    R:=ConfirmAbort(TransStr('[Plan not saved. Save now?]')+' ( '+CurrentFileName+' )');
    case R of
      IDYES : CanClose:=SavePlan;
      IDNo  : CanClose:=TRUE;
    end;
  end else CanClose:=TRUE;
	StopFX;
end;

procedure TPlanWindow.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Assigned(ParentElements.Overview) then ParentElements.Overview.Invalidate;
  if Assigned(ParentElements.Preview) then ParentElements.Preview.Invalidate;
  if Assigned(ParentElements_IsClosing) then ParentElements_IsClosing;
  if Assigned(ParentElements_InfoFloaterVisible) then ParentElements_InfoFloaterVisible(FALSE);
  Action:=caFree;
end;

procedure TPlanWindow.RedrawOverview;
var xs,ys:Double;
    Backup:boolean;
begin
  if Assigned(ParentElements.Overview) then with ParentElements do begin
		MyPlan.CalcRectAround;
    with MyPlan do begin
      try
        xs:=1; ys:=1;
        if ABS(LR.X-UL.X)>0 then xs:=(Overview.Width-6)/ABS(LR.X-UL.X);
        if ABS(LR.Y-UL.Y)>0 then ys:=(Overview.Height-6)/ABS(LR.Y-UL.Y);
        if xs<ys then OverviewF:=xs else OverviewF:=ys;
        OverviewXS:=3/OverviewF-UL.X+((Overview.Width-6-(LR.X-UL.X)*OverviewF)/2)/OverviewF;
        OverviewYS:=3/OverviewF-UL.Y+((Overview.Height-6-(LR.Y-UL.Y)*OverviewF)/2)/OverviewF;
        Backup:=MyPlan.DrawInfo.OverruleColor;
        MyPlan.DrawInfo.OverruleColor:=FALSE;
        Draw(Overview.Canvas, OverviewXS, OverviewYS, OverviewF, OverviewF, TRUE, TRUE, -1);
        MyPlan.DrawInfo.OverruleColor:=Backup;
        MyPlan.DrawTable(Overview.Canvas, OverviewXS, OverviewYS, OverviewF, OverviewF, -1, FALSE);
      except end;
    end;
  end;
end;

procedure TPlanWindow.OverviewClick(X, Y:integer);
var t:TDoublePoint;
begin
  t.X:=X/OverviewF-OverviewXS;
	t.Y:=Y/OverviewF-OverviewYS;
  CenterToPos(t);
end;

procedure TPlanWindow.CenterToPos(P:TDoublePoint);
begin
  Planscroll.HorzScrollBar.Position:=Round((P.X+XSpace)*Zoomfactor)-((Planscroll.Width) DIV 2);
  Planscroll.VertScrollBar.Position:=Round((P.Y+YSpace)*Zoomfactor)-((Planscroll.Height) DIV 2);
end;

function TPlanWindow.GetCenterPos:TDoublePoint;
begin
  Result.X:=(Planscroll.HorzScrollBar.Position+Planscroll.Width DIV 2)/Zoomfactor-XSpace;
  Result.Y:=(Planscroll.VertScrollBar.Position+Planscroll.Height DIV 2)/Zoomfactor-YSpace;
end;

function TPlanWindow.ShowAllFactor:Double;
var xs,ys:Double;
begin
  xs:=1; ys:=1;
  MyPlan.CalcRectAround;
  with MyPlan do begin
    if (ABS(LR.X-UL.X)>0) then xs:=(Planscroll.Width-GlobalScrollThick)/ABS(LR.X-UL.X);
    if (ABS(LR.Y-UL.Y)>0) then ys:=(Planscroll.Height-GlobalScrollThick)/ABS(LR.Y-UL.Y);
  end;
  if xs<ys then Result:=xs else Result:=ys;
end;

procedure TPlanWindow.ShowAll;
var P:TDoublePoint;
begin
  Zoomfactor:=ShowAllFactor*0.95;
  if Zoomfactor>10 then Zoomfactor:=10;
  if (MyPlan.InstanceElements.count=0) and (MyPlan.TablePolygon.count<3) then Zoomfactor:=0.5;
  P.X:=MyPlan.LR.X-(MyPlan.LR.X-MyPlan.UL.X)/2;
  P.Y:=MyPlan.LR.Y-(MyPlan.LR.Y-MyPlan.UL.Y)/2;
  with MyPlan do begin
    XSpace:=-UL.X+(((ABS(MyPlan.LR.X-MyPlan.UL.X)*Zoomfactor)+2*Planscroll.Width)/Zoomfactor-(LR.X-UL.X))/2;
    YSpace:=-UL.Y+(((ABS(MyPlan.LR.Y-MyPlan.UL.Y)*Zoomfactor)+2*Planscroll.Height)/Zoomfactor-(LR.Y-UL.Y))/2;
    Plan.Width:=Round(ABS(MyPlan.LR.X-MyPlan.UL.X)*Zoomfactor)+2*Planscroll.Width;
		Plan.Height:=Round(ABS(MyPlan.LR.Y-MyPlan.UL.Y)*Zoomfactor)+2*Planscroll.Height;
  end;
  CenterToPos(P);
  Plan.Invalidate;
end;

procedure TPlanWindow.ZoomRect(A, B: TDoublePoint);
var xs,ys:Double;
    P:TDoublePoint;
    TXW, TYW:integer;
    ZF, TXS, TYS:Double;
begin
//  P.X:=A.X+(B.X-A.X)/2;
//  P.Y:=A.Y+(B.Y-A.Y)/2;
  P:=Middle(A, B);
  if (B.X-A.X>0) and (B.Y-A.Y>0) and
  // if the rectangle is Smaller than PointRectSize in Pixles then just move the
	// clicked Point to the screencenter
     ((B.Y-A.Y)*Zoomfactor>PointRectSize) and ((B.X-A.X)*Zoomfactor>PointRectSize) then begin
    xs:=(Planscroll.Width-GlobalScrollThick)/(B.X-A.X);
    ys:=(Planscroll.Height-GlobalScrollThick)/(B.Y-A.Y);
    if xs<ys then ZF:=xs else ZF:=ys;
    if ZF>10 then ZF:=10;


    with MyPlan do begin
      TXS:=-UL.X+(((ABS(MyPlan.LR.X-MyPlan.UL.X)*ZF)+2*Planscroll.Width)/ZF-(LR.X-UL.X))/2;
      TYS:=-UL.Y+(((ABS(MyPlan.LR.Y-MyPlan.UL.Y)*ZF)+2*Planscroll.Height)/ZF-(LR.Y-UL.Y))/2;
      TXW:=Round(ABS(MyPlan.LR.X-MyPlan.UL.X)*ZF)+2*Planscroll.Width;
      TYW:=Round(ABS(MyPlan.LR.Y-MyPlan.UL.Y)*ZF)+2*Planscroll.Height;


      // On error do exit
      if not ((ZF>10) or (TXW>32000) or (TYW>32000)or (TXW<0) or (TYW<0)) then begin
        Zoomfactor:=ZF;
        XSpace:=TXS;
        YSpace:=TYS;
        Plan.Width:=TXW;
        Plan.Height:=TYW;
      end;  
		end;
  end;
  CenterToPos(P);
  Plan.Invalidate;
end;

procedure TPlanWindow.Bigger;
var P:TDoublePoint;
    TXW, TYW:integer;
    ZF, TXS, TYS:Double;

begin
  P:=GetCenterPos;
  ZF:=Zoomfactor*1.1;
  with MyPlan do begin
    TXS:=-UL.X+(((ABS(MyPlan.LR.X-MyPlan.UL.X)*ZF)+2*Planscroll.Width)/ZF-(LR.X-UL.X))/2;
    TYS:=-UL.Y+(((ABS(MyPlan.LR.Y-MyPlan.UL.Y)*ZF)+2*Planscroll.Height)/ZF-(LR.Y-UL.Y))/2;
		TXW:=Round(ABS(MyPlan.LR.X-MyPlan.UL.X)*ZF)+2*Planscroll.Width;
    TYW:=Round(ABS(MyPlan.LR.Y-MyPlan.UL.Y)*ZF)+2*Planscroll.Height;

    // On error do exit
    if ZF>10 then exit;
    if (TXW>32000) or (TYW>32000)or (TXW<0) or (TYW<0) then exit;

    Zoomfactor:=ZF;
    XSpace:=TXS;
    YSpace:=TYS;
    Plan.Width:=TXW;
    Plan.Height:=TYW;
  end;
  CenterToPos(P);
end;

procedure TPlanWindow.Smaller;
var P:TDoublePoint;
begin
  P:=GetCenterPos;
  if Zoomfactor>10E-5 then Zoomfactor:=Zoomfactor*0.9;
  with MyPlan do begin
    XSpace:=-UL.X+(((ABS(MyPlan.LR.X-MyPlan.UL.X)*Zoomfactor)+2*Planscroll.Width)/Zoomfactor-(LR.X-UL.X))/2;
		YSpace:=-UL.Y+(((ABS(MyPlan.LR.Y-MyPlan.UL.Y)*Zoomfactor)+2*Planscroll.Height)/Zoomfactor-(LR.Y-UL.Y))/2;
    Plan.Width:=Round(ABS(MyPlan.LR.X-MyPlan.UL.X)*Zoomfactor)+2*Planscroll.Width;
    Plan.Height:=Round(ABS(MyPlan.LR.Y-MyPlan.UL.Y)*Zoomfactor)+2*Planscroll.Height;
  end;
  CenterToPos(P);
end;

procedure TPlanWindow.GetVisibleRect(var TL, DR:TDoublePoint);
var X, Y:Double;
begin
  X:=Planscroll.HorzScrollBar.Position;
  Y:=Planscroll.VertScrollBar.Position;
  TL.X:=X/Zoomfactor-XSpace;
  TL.Y:=Y/Zoomfactor-YSpace;
  X:=Planscroll.HorzScrollBar.Position+Planscroll.Width;
  Y:=Planscroll.VertScrollBar.Position+Planscroll.Height;
  DR.X:=X/Zoomfactor-XSpace;
	DR.Y:=Y/Zoomfactor-YSpace;
end;

procedure TPlanWindow.ShowGrid;
var TL, DR:TDoublePoint;
    X, Y  : Double;
    Delta : Double;
begin
  Delta:=GlobalPlanGridSize;
  if Delta*Zoomfactor<7 then exit;
  GetVisibleRect(TL, DR);
  TL.Y:=(Trunc(TL.Y/Delta)-1)*Delta;
  TL.X:=(Trunc(TL.X/Delta)-1)*Delta;
  Y:=TL.Y;
  while Y<DR.Y do begin
    X:=TL.X;
    while X<DR.X do begin
      X:=X+Delta;
      Plan.Canvas.MoveTo(Round((X+XSpace)*Zoomfactor), Round((Y+YSpace)*Zoomfactor));
      Plan.Canvas.LineTo(Round((X+XSpace)*Zoomfactor)+1, Round((Y+YSpace)*Zoomfactor)+1);
    end;
    Y:=Y+Delta;
  end;
end;

procedure TPlanWindow.PlanPaint(Sender: TObject);
var t:boolean;
    TL, DR:TDoublePoint;
begin
  if GlobalPlanShowGrid then ShowGrid;
  Plan.Canvas.Pen.Mode:=pmCopy;
  Plan.Canvas.Brush.Color:=Plan.Color;
  GetVisibleRect(TL, DR);

  if FlexEditing then begin
    if GlobalPlanSpeedDraw then
      MyPlan.SpeedDraw(Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor, FALSE, FALSE, CurrentFlexINr, TL, DR)
    else
      MyPlan.Draw(Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor, FALSE, FALSE, CurrentFlexINr)
  end else begin
		if GlobalPlanSpeedDraw then
      MyPlan.SpeedDraw(Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor, FALSE, FALSE, -1, TL, DR)
    else
      MyPlan.Draw(Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor, FALSE, FALSE, -1);
  end;
  CleverDrawTable;
  if Assigned(RailyFX) then begin
    if Assigned(ParentElements.Timer) then ParentElements.Timer.Enabled:=FALSE;
    RailyFX.Redraw(Zoomfactor,Zoomfactor, XSpace, YSpace);
    if Assigned(ParentElements.Timer) then ParentElements.Timer.Enabled:=TRUE;
  end;
  if PlacingElements then DrawListElements(CurrentInstList);
  if FlexEditing then begin
    DrawDragablePoints(CurrentFlexPoly, SelFlexPoint);
    Plan.Canvas.Pen.Mode:=pmNotXOR;
    t:=MyPlan.DrawInfo.OverruleColor;
    MyPlan.DrawInfo.OverruleColor:=FALSE;
    MyPlan.UpdateSingle(CurrentFlexINr, Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor, FALSE, TRUE);
    MyPlan.DrawInfo.OverruleColor:=t;
    Plan.Canvas.Pen.Mode:=pmCopy;
  end;
  if TextEditing then begin
    Plan.Canvas.Brush.Style:=bsClear;
		Plan.Canvas.Pen.Mode:=pmNotXOR;
    Plan.Canvas.rectangle(Round((CTextA.X+XSpace)*Zoomfactor), Round((CTextA.Y+YSpace)*Zoomfactor),
                   Round((CTextB.X+XSpace)*Zoomfactor), Round((CTextB.Y+YSpace)*Zoomfactor));

    Plan.Canvas.Pen.Mode:=pmCopy;
  end;
  if TableEditing then DrawDragablePoints(MyPlan.TablePolygon,SelTablePoint);
  if GlobalPlanUserTXT then MyPlan.DrawUserText(Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor);

end;

function TPlanWindow.Save(Name:string):boolean;
begin
{  if IsReadOnly(Name) then begin
    Inform(TransStr('[FileIsWriteProtected]'));
    Result:=FALSE;
    exit;
	end;                           }
  CurrentFileName:=Name;
  Result:=MyPlan.Save(Name);
  Caption:=ExtractFileName(Name);
  FullPath.Text:=Name;
  UpdateInfoSheet;
end;

function TPlanWindow.Load(Name:string):boolean;
begin
  CurrentFileName:=Name;
  Result:=TRUE;
  Caption:=ExtractFileName(Name);
  FullPath.Text:=Name;
  // try reading the file as a RAILY for Windows 2.00 Plan
  if not MyPlan.Load(Name) then begin
    // if this fails, we can hope it is a RAILY for Windows 1.02 Plan...
    if not MyPlan.ImportWR1(Name) then begin
      Result:=FALSE;
    end else begin
      Caption:=ExtractFileName(Name)+' (RAILY 1.0x for Windows)';
    end;
  end;
	ResetModulesInUse;
  ShowAll;
end;

procedure TPlanWindow.Rearrange;
var f:Double;
    S, i:integer;
const DefWidth:array[0..5] of integer=(180, 100, 85, 64, 64, 64);

begin
// Rearrange Info-Sheet
  FullPath.Width:=Width-30;

  InventoryGrid.Width:=InventorySheet.Width-InventorySheet.Left*2;
  InventoryGrid.Height:=InventorySheet.Height-InventorySheet.Top*2;

  // Calc the ColWidth
	f:=1;S:=0;
  for i:=0 to 5 do S:=S+DefWidth[i];
  if (S>0) and (S<InventoryGrid.Width-30) then f:=(InventoryGrid.Width-30)/S;
  for i:=0 to 5 do InventoryGrid.ColWidths[i]:=Round(DefWidth[i]*f);

  INVShowAllCBX.Width:=Width-INVShowAllCBX.Left-20;
  INVInclUsableModsCBX.Width:=Width-INVInclUsableModsCBX.Left-20;
end;

procedure TPlanWindow.FormResize(Sender: TObject);
begin
  Rearrange;
end;

procedure TPlanWindow.FormActivate(Sender: TObject);
var Nr:integer;
begin
  if not Translated then begin
    if Assigned(ParentElements.Translator) then begin
      ParentElements.Translator.TranslateMDI(Self);
      Translated:=TRUE;
    end;
  end;

  if Assigned(ParentElements_InfoFloaterVisible) then ParentElements_InfoFloaterVisible(HasInfoFloater);
  Rearrange;
  if Assigned(ParentElements.Overview) then ParentElements.Overview.Invalidate;
  if Assigned(RailyFX) then RailyFX.SetCanvas(Plan.Canvas);
  // Down the current Button
  if Assigned(ParentElements_ChooseBTN) then ParentElements_ChooseBTN(CurrentTyp);
  Nr:=0;
  if TableEditing then Nr:=1;
  if FlexEditing then Nr:=2;
  if TextEditing then Nr:=3;
  // Down the current Mode Button
  if Assigned(ParentElements_ChooseBTN) then ParentElements_ChooseMode(Nr);
  // Enable Buttons
//if Assigned(ParentElements.SpecialMode) then ParentElements.SpecialMode((TableEditing or TextEditing or FlexEditing or TextEditing));
  // Redraw statusline
  if Assigned(ParentElements.Status) then ParentElements.Status.Invalidate;
	// Redraw nice little picture
  if Assigned(ParentElements.Preview) then ParentElements.Preview.Invalidate;
end;

procedure TPlanWindow.UpdateInfoSheet;
var S:string;
begin
  PlanInfoElNr.Text:=IntToStr(MyPlan.InstanceElements.count);

  Str(MyPlan.CalcRealLength/(1000*1000):0:2, S);
  RTrackLEdit.Text:=S;

  Str(MyPlan.CalcLength/1000:0:2, S);
  TrackLengthEdit.Text:=S;

  IsNotSavedLBL.Visible:=not MyPlan.IsSaved;
  AuthorEdit.Text:=StrPas(MyPlan.Info.Author);
  RemarkMemo.SetTextBuf(MyPlan.Info.Remark);
end;

procedure TPlanWindow.UpdateInventorySheet;
var i:integer;
    TIE:TInventoryListEntry;
begin
  Rearrange;
  if (InventoryGrid.Width<30) or (InventoryGrid.Height<30) then Rearrange;

  MyPlan.CalcInventory(INVShowAllCBX.Checked, INVInclUsableModsCBX.Checked, ModulesInUse);
  if MyPlan.inventory.List.count=0 then InventoryGrid.RowCount:=2
                                   else InventoryGrid.RowCount:=MyPlan.inventory.List.count+1;

  // titles for inventory columns
  if Assigned(ParentElements.Translator) then
    for i:=0 to 5 do InventoryGrid.Cells[i, 0]:=ParentElements.Translator.GetStr('[PECol'+IntToStr(i)+']');

  for i:=0 to MyPlan.inventory.List.count-1 do begin
    TIE:=MyPlan.inventory.List[i];
    if Assigned(TIE) then begin
      InventoryGrid.Cells[0, i+1]:=TIE.module;
      InventoryGrid.Cells[1, i+1]:=TIE.Element;
			InventoryGrid.Cells[3, i+1]:=IntToStr(TIE.Has);
      InventoryGrid.Cells[4, i+1]:=IntToStr(TIE.count);
    end;
  end;
  InventoryGrid.Row:=1;
  InventoryGrid.Col:=EditableCol;
end;

procedure TPlanWindow.PlanTabChange(Sender: TObject);
begin
  if PlanTab.ActivePage=InfoSheet then begin
    UpdateInfoSheet;
  end;
  if PlanTab.ActivePage=InventorySheet then begin
    UpdateInventorySheet;
  end;
end;

procedure TPlanWindow.PlanMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
var i, j          : integer;
    ReHit, HitAny : boolean;
    TempNr        : integer;
		TempInst      : TInstance;
    TempSL        : TStringList;
    TP       : TTextListPoint;
begin
  CursorPos.X:=X/Zoomfactor-XSpace;
  CursorPos.Y:=Y/Zoomfactor-YSpace;

  if TextEditing then begin
    if CheckTextPoints(X, Y, TempNr) then begin
      SelTextNr:=TempNr;
      TP:=TTextListPoint(CurrentTextPList[SelTextNr]);
      if not TP.RailText then begin
        CurrentTextNr:=TP.ID;
        CurrentText:=TUserTextEntry(MyPlan.UserTexts[TP.ID]).S;
      end;
      Plan.Canvas.Pen.Mode:=pmNotXOR;
      Plan.Canvas.Brush.Style:=bsClear;

      Plan.Canvas.rectangle(Round((CTextA.X+XSpace)*Zoomfactor), Round((CTextA.Y+YSpace)*Zoomfactor),
                     Round((CTextB.X+XSpace)*Zoomfactor), Round((CTextB.Y+YSpace)*Zoomfactor));
      CTextA:=TTextListPoint(CurrentTextPList[SelTextNr]).A;
      CTextB:=TTextListPoint(CurrentTextPList[SelTextNr]).B;
      Plan.Canvas.rectangle(Round((CTextA.X+XSpace)*Zoomfactor), Round((CTextA.Y+YSpace)*Zoomfactor),
                     Round((CTextB.X+XSpace)*Zoomfactor), Round((CTextB.Y+YSpace)*Zoomfactor));

      Plan.Canvas.Pen.Mode:=pmCopy;

      MoveTextPoint:=TRUE;
    end;
    if MoveTextPoint then exit; // and out
  end;

  if FlexEditing then begin
    if CheckDragablePoints(X, Y, CurrentFlexPoly, TempNr) then begin
      DrawDragablePoints(CurrentFlexPoly, SelFlexPoint);
      SelFlexPoint:=TempNr;
      MoveFlexPoint:=TRUE;
      DrawDragablePoints(CurrentFlexPoly, SelFlexPoint);
    end;
    if MoveFlexPoint then exit; // and out
	end;

  if TableEditing then begin
    if CheckDragablePoints(X, Y, MyPlan.TablePolygon, TempNr) then begin
      DrawDragablePoints(MyPlan.TablePolygon, SelTablePoint);
      CleverDrawTable;
      MovTablePoint:=TRUE;
      SelTablePoint:=TempNr;
      CleverDrawTable;
      DrawDragablePoints(MyPlan.TablePolygon, SelTablePoint);
    end;
    if MovTablePoint then exit; // and out
  end;

  if Button=MBLeft then begin
    Zooming:=(ssAlt in Shift) or (ssShift in Shift);
    if (not Zooming) and (FlexEditing or TableEditing or TextEditing) then exit;
		if not Zooming and (not (ssCtrl in Shift)) then begin
      for i:=0 to MyPlan.InstanceElements.count-1 do
        if MyPlan.Selected[i] then MyPlan.UpdateSingle(i, Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor, FALSE, TRUE);
      MyPlan.ClearSelection;
    end;

  // Check if an already Selected Element is clicked
    ReHit:=FALSE;
    with MyPlan do for i:=0 to InstanceElements.count-1 do
      ReHit:=ReHit or (Selected[i] and IsHit(i, X, Y, XSpace, YSpace, Zoomfactor, Zoomfactor));
  // if Selected is clicked then move a group of elements
    MovingPossible:=ReHit;
    HitAny:=FALSE;
    if not Zooming then begin
      if not ReHit then with MyPlan do for i:=0 to InstanceElements.count-1 do
        HitAny:=HitAny or IsHit(i, X, Y, XSpace, YSpace, Zoomfactor, Zoomfactor)
                   else HitAny:=TRUE;
    end;

    RectSelecting:=(not HitAny) and (not PlacingElements);
    if not HitAny then begin
      FirstPoint.X:=X;
      FirstPoint.Y:=Y;
			SecondPoint:=FirstPoint;
    end;
  end;
  if Zooming then exit;


  // Use alt(or Ctrl or Shift for convenience) - mouse right to grab an Element
  if (Button=MBRight) and ((ssAlt in Shift) or (ssCtrl in Shift) or (ssShift in Shift)) then begin
    with MyPlan do for i:=0 to InstanceElements.count-1 do
      if IsHit(i, X, Y, XSpace, YSpace, Zoomfactor, Zoomfactor) then begin
        if GetElement(i, TempInst) and Assigned(TempInst) then begin
          if Assigned(TempInst.CacheElement) then begin
            CurrentTyp:=TempInst.CacheElement.Info.TheType;
            if CurrentTyp=LengthFlex then CurrentTyp:=FlexElement;
          end else CurrentTyp:=gerade;
          // Down the current Button
          if Assigned(ParentElements_ChooseBTN) then ParentElements_ChooseBTN(CurrentTyp);
					CurrentElement:=StrPas(TempInst.ElementName);
          CurrentModule:=StrPas(TempInst.ModuleName);

// Get +/- should produce the next/last Element even after using Ctrl-right
          TempSL:=TStringList.Create;
          TempSL.Sorted:=TRUE;
          TempSL.Duplicates:=dupIgnore;

          GlobalModules.GetAllOfAType(ModulesInUse, CurrentTyp, TempSL);
          if CurrentTyp=FlexElement then GlobalModules.GetAllOfAType(ModulesInUse, LengthFlex,  TempSL);
          if TempSL.Find(CurrentElement, j) then LastOfTyp[CurrentTyp]:=j;
          for j:=TempSL.count-1 downto 0 do TMyString(TempSL.Objects[j]).Free;
          TempSL.Free;
// end of +/- fix

          // Redraw statusline
          if Assigned(ParentElements.Status) then ParentElements.Status.Invalidate;
          // Redraw nice little picture
          if Assigned(ParentElements.Preview) then ParentElements.Preview.Invalidate;
          // to allow changing the current Element while inserting
          if PlacingElements then begin
            DrawListElements(CurrentInstList);
            CurrentElementToCurrentList;
						DrawListElements(CurrentInstList);
          end;
        end;
        Break;
      end;
    exit; // and out
  end;

  if PlacingElements then begin
    if Button = MBRight then begin
      NextNewPlace;
    end;
    if Button= MBMiddle then begin
      NextOldPlace;
    end;
    exit;
  end;

  if (Button= MBMiddle)then begin
    FollowingElement;
    exit;
  end;

end;

procedure TPlanWindow.PopupEditMenu(X, Y:integer);
var
    Typ           : TImportSchienenTyp;
    flex          : boolean;
begin
  Flex1.Visible:=(MyPlan.OneSelectedTyp(Typ, flex) and ((Typ=FlexElement) or (Typ=LengthFlex)));// and not flex;
  PlanRightPop.PopUp(X, Y);
end;

procedure TPlanWindow.GetCurrentRect(var tUL, tDR:TDoublePoint);
begin
  if FirstPoint.X<SecondPoint.X then begin
    tUL.X:=FirstPoint.X/Zoomfactor-XSpace;
    tDR.X:=SecondPoint.X/Zoomfactor-XSpace;
  end else begin
		tUL.X:=SecondPoint.X/Zoomfactor-XSpace;
    tDR.X:=FirstPoint.X/Zoomfactor-XSpace;
  end;
  if FirstPoint.Y<SecondPoint.Y then begin
    tUL.Y:=FirstPoint.Y/Zoomfactor-YSpace;
    tDR.Y:=SecondPoint.Y/Zoomfactor-YSpace;
  end else begin
    tUL.Y:=SecondPoint.Y/Zoomfactor-YSpace;
    tDR.Y:=FirstPoint.Y/Zoomfactor-YSpace;
  end;
end;

procedure TPlanWindow.PlanMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: integer);
var OldMode  : TPenMode;
    OldStyle : TPenStyle;
    i        : integer;
		TOldP, tUL,
    tDR, TDP : TDoublePoint;
    TOldA    : Double;
    t        : boolean;
    dist     : Double;
    NoanP    : TDoublePoint;
    Si, Co   : Extended;
    S        : string;
    TInst    : TInstance;
    TNR      : integer;
    TP       : TTextListPoint;
    Dummy    : Double;
begin
  if RectSelecting then begin
    with Plan.Canvas do begin
      Brush.Style:=bsClear;
      OldMode:=Pen.Mode;
      OldStyle:=Pen.Style;
      Pen.Style:=psDot;
      Pen.Mode:=pmNotXOR;
      rectangle(FirstPoint.X, FirstPoint.Y, SecondPoint.X, SecondPoint.Y);
      SecondPoint.X:=X; SecondPoint.Y:=Y;
      Pen.Mode:=OldMode;
			Pen.Style:=OldStyle;
// here is the place to select the choosen elements
      GetCurrentRect(tUL, tDR);
// the Rect is the same if Zooming
      if not Zooming then begin
        with MyPlan do for i:=0 to InstanceElements.count-1 do begin
          t:=MyPlan.InRect(i, tUL, tDR);
          // is current sel.State not correct
          if t XOR Selected[i] then begin
            if (ssCtrl in Shift) then Selected[i]:=Selected[i] or t else Selected[i]:=t;
            MyPlan.UpdateSingle(i, Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor, FALSE, FALSE)
          end else Selected[i]:=t;
        end;
      end;
// after this line nothing of the Plan may be drawn
      Pen.Style:=psDot;
      Pen.Mode:=pmNotXOR;
			rectangle(FirstPoint.X, FirstPoint.Y, SecondPoint.X, SecondPoint.Y);
      Pen.Mode:=OldMode;
      Pen.Style:=OldStyle;
    end;
  end;

  if TextEditing then begin
    if MoveTextPoint then begin
      Plan.Canvas.Pen.Mode:=pmNotXOR;
      Plan.Canvas.Brush.Style:=bsClear;
      Plan.Canvas.rectangle(Round((CTextA.X+XSpace)*Zoomfactor), Round((CTextA.Y+YSpace)*Zoomfactor),
                     Round((CTextB.X+XSpace)*Zoomfactor), Round((CTextB.Y+YSpace)*Zoomfactor));

      TDP.X:=(X/Zoomfactor-XSpace)-TextDX;
      TDP.Y:=(Y/Zoomfactor-YSpace)-TextDY;
      if (SelTextNr>=0) and (SelTextNr<CurrentTextPList.count) then begin
        TP:=TTextListPoint(CurrentTextPList[SelTextNr]);
        if TP.RailText then begin
          if MyPlan.FindElementWithID(TP.ID, TInst, TNR) then begin
            TInst.TextPos:=TDP;
            TP.A:=TInst.TextPos;
            Plan.Canvas.Font.Height:=GlobalRailNrHeight;
            if ((TInst.Status and CShowFullNames) >0) or (Pos(' ', TInst.CacheElement.Info.Name)=0) then
							 S:=TInst.CacheElement.Info.Name
            else
               S:=Copy(TInst.CacheElement.Info.Name, 1, Pos(' ', TInst.CacheElement.Info.Name));

            TP.B.X:=TP.A.X+Plan.Canvas.TextWidth(S);
            TP.B.Y:=TP.A.Y+GlobalRailNrHeight;
            CurrentTextNr:=-1;
            CTextA:=TTextListPoint(CurrentTextPList[SelTextNr]).A;
            CTextB:=TTextListPoint(CurrentTextPList[SelTextNr]).B;
          end;
        end else begin
          TUserTextEntry(MyPlan.UserTexts[TP.ID]).P:=TDP;
          TP.A:=TDP;
          Plan.Canvas.Font.Height:=GlobalUserTXTHeight;
          S:=TUserTextEntry(MyPlan.UserTexts[TP.ID]).S;
          TP.B.X:=TP.A.X+Plan.Canvas.TextWidth(S);
          TP.B.Y:=TP.A.Y+GlobalUserTXTHeight;
					CTextA:=TTextListPoint(CurrentTextPList[SelTextNr]).A;
          CTextB:=TTextListPoint(CurrentTextPList[SelTextNr]).B;
          CurrentTextNr:=TP.ID;
          CurrentText:=S;
        end;
      end;
      Plan.Canvas.rectangle(Round((CTextA.X+XSpace)*Zoomfactor), Round((CTextA.Y+YSpace)*Zoomfactor),
                     Round((CTextB.X+XSpace)*Zoomfactor), Round((CTextB.Y+YSpace)*Zoomfactor));

      Plan.Canvas.Pen.Mode:=pmCopy;
    end;
    exit; // and out
  end;

  if FlexEditing then begin
    if MoveFlexPoint then begin
      DrawDragablePoints(CurrentFlexPoly, SelFlexPoint);
      if (SelFlexPoint>=0) and (SelTablePoint<CurrentFlexPoly.count) then begin
        TDP.X:=X/Zoomfactor-XSpace;
        TDP.Y:=Y/Zoomfactor-YSpace;
        if Assigned(CurrentFlexInst) then begin
          CursorAngle:=UserRotation;
          if CurrentFlexInst.CacheElement.Info.TheType=FlexElement then begin
					// Gravity for Flexpoints;
            if (SelFlexPoint=0) or (SelFlexPoint=CurrentFlexPoly.count-1) then begin
              if (SelFlexPoint=0) then CursorAngle:=CurrentFlexInst.FlexAddition.A1+pi
                                  else CursorAngle:=CurrentFlexInst.FlexAddition.A2;
              if not ((ssAlt in Shift) or (ssCtrl in Shift) or (ssShift in Shift)) then
                if not UseGravity(CurrentAllFreeConList, TDP, CursorAngle) then begin
                  if (SelFlexPoint=0) then begin
                    CurrentFlexInst.FlexAddition.A1:=FixedAngle(UserRotation);
                    CursorAngle:=CurrentFlexInst.FlexAddition.A1+pi
                  end else begin
                    CurrentFlexInst.FlexAddition.A2:=FixedAngle(UserRotation);
                    CursorAngle:=CurrentFlexInst.FlexAddition.A2;
                  end;
                end;
              if (SelFlexPoint=0) then begin
                CurrentFlexInst.FlexAddition.A1:=FixedAngle(CursorAngle+pi);
              end else begin
								CurrentFlexInst.FlexAddition.A2:=FixedAngle(CursorAngle);
              end;
            end;

            if (SelFlexPoint=1) then CursorAngle:=CurrentFlexInst.FlexAddition.A1+pi;
            if (SelFlexPoint=CurrentFlexPoly.count-2) then CursorAngle:=CurrentFlexInst.FlexAddition.A2;

            SinCos(CursorAngle+pi, Si, Co);

            if (SelFlexPoint=1) then begin
              dist:=CalcDist(TPointObject(CurrentFlexPoly[0]).P, TDP);
              TDP.X:=TPointObject(CurrentFlexPoly[0]).P.X+Co*dist;
              TDP.Y:=TPointObject(CurrentFlexPoly[0]).P.Y+Si*dist;
            end;

            if (SelFlexPoint=CurrentFlexPoly.count-2) then begin
              dist:=CalcDist(TPointObject(CurrentFlexPoly[CurrentFlexPoly.count-1]).P, TDP);
              TDP.X:=TPointObject(CurrentFlexPoly[CurrentFlexPoly.count-1]).P.X+Co*dist;
              TDP.Y:=TPointObject(CurrentFlexPoly[CurrentFlexPoly.count-1]).P.Y+Si*dist;
            end;

            if (SelFlexPoint=0) then begin
              dist:=CalcDist(TPointObject(CurrentFlexPoly[0]).P, TPointObject(CurrentFlexPoly[1]).P);
							NoanP.X:=TDP.X+Co*dist;
              NoanP.Y:=TDP.Y+Si*dist;
              TPointObject(CurrentFlexPoly[1]).P:=NoanP;
            end;

            if SelFlexPoint=CurrentFlexPoly.count-1 then begin
              dist:=CalcDist(TPointObject(CurrentFlexPoly[CurrentFlexPoly.count-1]).P, TPointObject(CurrentFlexPoly[CurrentFlexPoly.count-2]).P);
              NoanP.X:=TDP.X+Co*dist;
              NoanP.Y:=TDP.Y+Si*dist;
              TPointObject(CurrentFlexPoly[CurrentFlexPoly.count-2]).P:=NoanP;
            end;
            TPointObject(CurrentFlexPoly[SelFlexPoint]).P:={MyPlan.PointToGridPoint(}TDP{)};
          end else begin
            if not ((ssAlt in Shift) or (ssCtrl in Shift) or (ssShift in Shift)) then
            UseGravity(CurrentAllFreeConList, TDP, Dummy);
            if (SelFlexPoint=0) then begin
              CursorAngle:=CurrentFlexInst.FlexAddition.A1;
							SinCos(CursorAngle+pi, Si, Co);
              dist:=CalcDist(TPointObject(CurrentFlexPoly[1]).P, TDP);
              if dist<CurrentLFlexMin then dist:=CurrentLFlexMin;
              if dist>CurrentLFlexMax then dist:=CurrentLFlexMax;
              TDP.X:=TPointObject(CurrentFlexPoly[1]).P.X+Co*dist;
              TDP.Y:=TPointObject(CurrentFlexPoly[1]).P.Y+Si*dist;
            end else begin
              CursorAngle:=CurrentFlexInst.FlexAddition.A1;
              SinCos(CursorAngle, Si, Co);
              dist:=CalcDist(TPointObject(CurrentFlexPoly[0]).P, TDP);
              if dist<CurrentLFlexMin then dist:=CurrentLFlexMin;
              if dist>CurrentLFlexMax then dist:=CurrentLFlexMax;
              TDP.X:=TPointObject(CurrentFlexPoly[0]).P.X+Co*dist;
              TDP.Y:=TPointObject(CurrentFlexPoly[0]).P.Y+Si*dist;
            end;
            TPointObject(CurrentFlexPoly[SelFlexPoint]).P:=TDP;
          end;
          Plan.Canvas.Pen.Mode:=pmNotXOR;
          t:=MyPlan.DrawInfo.OverruleColor;
          MyPlan.DrawInfo.OverruleColor:=FALSE;
          MyPlan.UpdateSingle(CurrentFlexINr, Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor, FALSE, TRUE);
          CurrentFlexInst.FlexAddition.Calculate;
          if Assigned(ParentElements.Status) then ParentElements.Status.Invalidate;
					MyPlan.UpdateSingle(CurrentFlexINr, Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor, FALSE, TRUE);
          MyPlan.DrawInfo.OverruleColor:=t;
          Plan.Canvas.Pen.Mode:=pmCopy;
//          Plan.Invalidate;
        end;
      end;
      DrawDragablePoints(CurrentFlexPoly, SelFlexPoint);
    end;
    exit;
  end;

  if TableEditing then begin
    if MovTablePoint then begin
      DrawDragablePoints(MyPlan.TablePolygon, SelTablePoint);
      CleverDrawTable;
      if (SelTablePoint>=0) and (SelTablePoint<MyPlan.TablePolygon.count) then begin
        TDP.X:=X/Zoomfactor-XSpace;
				TDP.Y:=Y/Zoomfactor-YSpace;
        TPointObject(MyPlan.TablePolygon[SelTablePoint]).P:=MyPlan.PointToGridPoint(TDP);
      end;
      dist:=CalcDist(TPointObject(MyPlan.TablePolygon[SelTablePoint]).P, TPointObject(MyPlan.TablePolygon[(SelTablePoint+1) MOD MyPlan.TablePolygon.count]).P);
      Str(dist:0:2, S);
      CleverDrawTable;
      DrawDragablePoints(MyPlan.TablePolygon, SelTablePoint);
    end;
    exit; // and out
  end;

  if MousePositioning then begin
     TOldA:=CursorAngle;
     TOldP:=CursorPos;
     CursorPos.X:=X/Zoomfactor-XSpace;
     CursorPos.Y:=Y/Zoomfactor-YSpace;
     CursorAngle:=FixedAngle(-pi+UserRotation);
     if not ((ssAlt in Shift) or (ssCtrl in Shift) or (ssShift in Shift)) then
        UseGravity(CurrentAllFreeConList, CursorPos, CursorAngle);
     // avoid flickering
     if (TOldP.X<>CursorPos.X) or (TOldP.Y<>CursorPos.Y) or (TOldA<>CursorAngle) then NextOldPlace;
  end;

	if PlacingElements then begin
    exit;
  end;

end;

procedure TPlanWindow.PlanMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer);
 var Nr      : integer;
    OldMode  : TPenMode;
    OldStyle : TPenStyle;
    TempInst : TInstance;
//    TempI    : integer;
//    TempC    : TConnector;
    tUL, tDR : TDoublePoint;
    TempPoint:TPoint;
begin

  if (Button=MBLeft) and RectSelecting then begin
    with Plan.Canvas do begin
      Brush.Style:=bsClear;
      OldMode:=Pen.Mode;
      OldStyle:=Pen.Style;
      Pen.Style:=psDot;
      Pen.Mode:=pmNotXOR;
      rectangle(FirstPoint.X, FirstPoint.Y, SecondPoint.X, SecondPoint.Y);
      Pen.Mode:=OldMode;
      Pen.Style:=OldStyle;
    end;
    if Zooming then begin
      GetCurrentRect(tUL, tDR);
      ZoomRect(tUL, tDR);
    end;
    Zooming:=FALSE;
    RectSelecting:=FALSE;
    MovingPossible:=FALSE;
    exit;
  end;

  if TextEditing then begin
		if (Button=MBRight) then begin
      TempPoint.X:=X-10-Planscroll.HorzScrollBar.Position; TempPoint.Y:=Y-Planscroll.VertScrollBar.Position;
      TempPoint:=Planscroll.ClientToScreen(TempPoint);
      TextPopup.PopUp(TempPoint.X, TempPoint.Y);
    end else begin
      Plan.Invalidate;
    end;
    MoveTextPoint:=FALSE;
    exit;
  end;

  if FlexEditing then begin
    if Button=MBRight then begin
      TempPoint.X:=X-10-Planscroll.HorzScrollBar.Position; TempPoint.Y:=Y-Planscroll.VertScrollBar.Position;
      TempPoint:=Planscroll.ClientToScreen(TempPoint);
      if Assigned(CurrentFlexInst) and (CurrentFlexInst.CacheElement.Info.TheType=FlexElement) then
      FlexPopup.PopUp(TempPoint.X, TempPoint.Y);
		end;
    MoveFlexPoint:=FALSE;
    exit;
  end;
  if TableEditing then begin
    if Button=MBRight then begin
      TempPoint.X:=X-10-Planscroll.HorzScrollBar.Position; TempPoint.Y:=Y-Planscroll.VertScrollBar.Position;
      TempPoint:=Planscroll.ClientToScreen(TempPoint);
      TableEditPopup.PopUp(TempPoint.X, TempPoint.Y);
    end;
    Plan.Invalidate;
    MovTablePoint:=FALSE;
    exit; // and out
  end;

  if PlacingElements then begin
    if Button= MBLeft then begin
      ConfirmCurrentPlace;
    end;
    exit;
  end;
  if Button=MBLeft then begin
    if not RectSelecting then begin
			if MyPlan.Hit(X, Y, XSpace, YSpace, Zoomfactor, Zoomfactor, Nr) then begin
        TempInst:=TInstance(MyPlan.InstanceElements.Items[Nr]);
        CurrentColor:=TempInst.Color;
        CurrentLayer:=TempInst.Layer;
        if Assigned(ParentElements.Status) then ParentElements.Status.Invalidate;
        if Assigned(ParentElements.Preview) then ParentElements.Preview.Invalidate;
{        Write('ID:', TempInst.ID, ' connects to [');
        for TempI:=0 to TempInst.ConnectorCount-1 do begin
          if TempInst.GetConnector(TempI, TempC) then begin
            Write(TempC.Nr);
            if TempI<TempInst.ConnectorCount-1 then Write(', ');
          end;
        end; WriteLN(']');}

        if (ssCtrl in Shift) then MyPlan.Invert(Nr) else MyPlan.select(Nr);
        MyPlan.UpdateSingle(Nr, Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor, FALSE, FALSE)
      end;
		end;

    Zooming:=FALSE;
    RectSelecting:=FALSE;
    MovingPossible:=FALSE;
  end;

  if ((ssAlt in Shift) or (ssCtrl in Shift) or (ssShift in Shift)) then exit;
  // if the right Button is not used in another way then let'S PopUp
  if (Button=MBRight)  and not RectSelecting then begin
    TempPoint.X:=X-10-Planscroll.HorzScrollBar.Position; TempPoint.Y:=Y-Planscroll.VertScrollBar.Position;
//    if TempPoint.Y>Planscroll.Height-80 then TempPoint.Y:=Planscroll.Height-80;
    TempPoint:=Planscroll.ClientToScreen(TempPoint);
    PopupEditMenu(TempPoint.X, TempPoint.Y);
  end;

end;

procedure TPlanWindow.DrawStatus(C:TCanvas; R:TRect);
var Typ, CR, f, Fu, US:string;
    Le, Ra, an: Double;
    M   :TModule;
    Nr  :integer;
begin
  C.Pen.Color:=clBtnFace;
  C.rectangle(R.Left, R.Top, R.right, R.bottom);
  C.Pen.Color:=clWindowText;
  C.Font.Name:='Arial';

  case CurrentTyp of
    Kurve            : begin f:='[PEK]'; end;
    gerade           : begin f:='[PEG]'; end;
    Weiche           : begin f:='[PEW]'; end;
    Kreuzung         : begin f:='[PEKR]'; end;
    Kreuzungsweiche  : begin f:='[PEKRW]'; end;
    SpezialElement   : begin f:='[PES]'; end;
    Uebergangsstueck : begin f:='[PET]'; end;
    FlexElement      : begin f:='[PEF]'; end;
    LengthFlex       : begin f:='[PELF]'; end;
  end;
	with ParentElements do begin
    if Assigned(Translator) then begin
      Typ:=Translator.GetStr(Typ);
      f:=Translator.GetStr(f);
    end;
  end;
  CR:='';
  Fu:='';

  if GlobalModules.GetModule(CurrentModule, M) and M.GetElement(CurrentElement, CurrentPointer) then begin
    try if Assigned(CurrentPointer) then begin
      CR:=CurrentPointer.Info.Remark;
      if GlobalTransRemark then begin
//        Write('Suche :','['+CurrentModule+']'+CurrentElement);
        if GlobalModules.RemarkList.Find('['+CurrentModule+']'+CurrentElement,Nr) then begin
//          WriteLN('yipiaie schweinebacke');
          if GlobalModules.RemarkList.Objects[Nr]<>NIL then begin
            CR:=TMyString(GlobalModules.RemarkList.Objects[Nr]).X;
//            Write(' Gefunden:',CR);
          end;
        end;
//       WriteLN;
      end;
			Le:=CurrentPointer.Info.TheLength;
      Ra:=CurrentPointer.Info.TheRadius;
      an:=CurrentPointer.Info.TheAngle;
      Fu:=Format(f, [Le, Ra, an]);
    end except end;
  end;
  C.TextOut(3, 4, CurrentElement + ' (' + CurrentModule + ') '+CR);
  C.TextOut(3,18, Fu);

  if not FlexEditing then begin
    Str(FixedAngle(-UserRotation)*180/pi:0:2, US);
    C.TextOut(3,32, TransStr('[UserAngle]')+' : '+US);
  end;  

  C.TextOut(250, 32, TransStr('[CurrentLayer]')+' : '+IntToStr(CurrentLayer));
  if FlexEditing and Assigned(CurrentFlexInst) then begin
    Str(CurrentFlexInst.FlexAddition.GetLength:0:2, Fu);
		C.TextOut(470, 32, TransStr('[CurrentFlexLength]')+' : '+Fu);
  end;
end;

procedure TPlanWindow.ShowPreview(X:TCanvas; l, t, w, h:integer; CM, CE:string; HandStand:boolean);
var Element: TElement;
    PA, PB : TDoublePoint;
    Fx, Fy : Double;
    M      : TModule;

  function Factor: Double;
  var xs,ys:Double;
      Reserve:Double;
  begin
    xs:=1; ys:=1;
    Element.GetRectAround0(PA, PB);
    Reserve:=MyPlan.DrawInfo.Spurweite;
    if (MyPlan.DrawInfo.DoubleDraw and CDrawBettung >0) then Reserve:=MyPlan.DrawInfo.ElWidth;
    if (ABS(PB.X-PA.X)>0) then xs:=(w-5)/(ABS(PB.X-PA.X)+Reserve);
    if (ABS(PB.Y-PA.Y)>0) then ys:=(h-5)/(ABS(PB.Y-PA.Y)+Reserve);
    if xs<ys then Result:=xs else Result:=ys;
  end;

begin
  if not Assigned(X) then exit;
  if GlobalModules.GetModule(CM, M) and M.GetElement(CE, Element) then begin
    Fx:=Factor;
    MyPlan.DrawInfo.Spurweite:=M.Info.Spurweite;
    MyPlan.DrawInfo.ElWidth:=M.Info.ElWidth;
    if not HandStand then Fy:=Fx else Fy:=-Fx;
    Element.Draw(X,
            l/Fx-PA.X+((w-4-(PB.X-PA.X)*Fx)/2)/Fx,
            t/Fy-PA.Y+((h-4-(PB.Y-PA.Y)*Fy)/2)/Fy,
            0, Fx, Fy, @MyPlan.DrawInfo);
    CurrentPointer:=Element;
  end;
end;

procedure TPlanWindow.UpdatePreview;
begin
	ParentElements.Preview.Canvas.Pen.Color:=CurrentColor;
  ShowPreview(ParentElements.Preview.Canvas, 2, 2, ParentElements.Preview.Width, ParentElements.Preview.Height, CurrentModule, CurrentElement, FALSE);
end;

procedure TPlanWindow.NextElement;
var Es : TStringList;
    i  : integer;
begin
  Es:=TStringList.Create;
  Es.Sorted:=TRUE;
  Es.Duplicates:=dupIgnore;
  GlobalModules.GetAllOfAType(ModulesInUse, CurrentTyp, Es);
  if CurrentTyp=FlexElement then GlobalModules.GetAllOfAType(ModulesInUse, LengthFlex,  Es);

  INC(LastOfTyp[CurrentTyp]);
  if LastOfTyp[CurrentTyp]>=Es.count then LastOfTyp[CurrentTyp]:=0;
  if Es.count>0 then begin
    CurrentElement:=Es.Strings[LastOfTyp[CurrentTyp]];
    CurrentModule:=TMyString(Es.Objects[LastOfTyp[CurrentTyp]]).X;
  end;
  for i:=Es.count-1 downto 0 do TObject(Es.Objects[i]).Free;
  Es.Free;
  if Assigned(ParentElements.Status) then ParentElements.Status.Invalidate;
	if Assigned(ParentElements.Preview) then ParentElements.Preview.Invalidate;

  // to allow changing the current Element while inserting
  if PlacingElements then begin
    DrawListElements(CurrentInstList);
    CurrentElementToCurrentList;
    DrawListElements(CurrentInstList);
  end;
end;

procedure TPlanWindow.LastElement;
var Es : TStringList;
    i  : integer;
begin
  Es:=TStringList.Create;
  Es.Sorted:=TRUE;
  Es.Duplicates:=dupIgnore;
	GlobalModules.GetAllOfAType(ModulesInUse, CurrentTyp, Es);
  if CurrentTyp=FlexElement then GlobalModules.GetAllOfAType(ModulesInUse, LengthFlex,  Es);
  Dec(LastOfTyp[CurrentTyp]);
  if LastOfTyp[CurrentTyp]<0 then LastOfTyp[CurrentTyp]:=Es.count-1;
  if Es.count>0 then begin
    CurrentElement:=Es.Strings[LastOfTyp[CurrentTyp]];
    CurrentModule:=TMyString(Es.Objects[LastOfTyp[CurrentTyp]]).X;
  end;
  for i:=Es.count-1 downto 0 do TObject(Es.Objects[i]).Free;
  Es.Free;
  if Assigned(ParentElements.Status) then ParentElements.Status.Invalidate;
  if Assigned(ParentElements.Preview) then ParentElements.Preview.Invalidate;

  // to allow changing the current Element while inserting
  if PlacingElements then begin
    DrawListElements(CurrentInstList);
    CurrentElementToCurrentList;
    DrawListElements(CurrentInstList);
  end;
end;

procedure TPlanWindow.SetActualTyp(X:TImportSchienenTyp);
var Es : TStringList;
		i  : integer;
begin
  CurrentTyp:=X;
  Es:=TStringList.Create;
  Es.Sorted:=TRUE;
  Es.Duplicates:=dupIgnore;
  GlobalModules.GetAllOfAType(ModulesInUse, CurrentTyp, Es);
  if CurrentTyp=FlexElement then GlobalModules.GetAllOfAType(ModulesInUse, LengthFlex,  Es);
  if LastOfTyp[CurrentTyp]>Es.count-1 then LastOfTyp[CurrentTyp]:=0;
  if LastOfTyp[CurrentTyp]<0 then LastOfTyp[CurrentTyp]:=Es.count-1;
  if Es.count>0 then begin
    CurrentElement:=Es.Strings[LastOfTyp[CurrentTyp]];
    CurrentModule:=TMyString(Es.Objects[LastOfTyp[CurrentTyp]]).X;
  end else begin
    CurrentElement:='';
    CurrentModule:='';
  end;
	for i:=Es.count-1 downto 0 do TObject(Es.Objects[i]).Free;
  Es.Free;
  if Assigned(ParentElements.Status) then ParentElements.Status.Invalidate;
  if Assigned(ParentElements.Preview) then ParentElements.Preview.Invalidate;

  // to allow changing the current Element while inserting
  if PlacingElements then begin
    DrawListElements(CurrentInstList);
    CurrentElementToCurrentList;
    DrawListElements(CurrentInstList);
  end;
end;

function TPlanWindow.IsLegalElement(CM, CE:string):boolean;
var M : TModule;
    Element:TElement;
begin
  Result:= (GlobalModules.GetModule(CM, M) and M.GetElement(CE, Element));
end;

procedure TPlanWindow.ModuleSelection;
var i  : integer;
begin
	ModuleSelectDLG.SrcList.Items.Assign(GlobalModules.AvailableModules);
  ModuleSelectDLG.DstList.Items.Assign(ModulesInUse);
  if ModuleSelectDLG.ShowModal=mrOk then begin
    ModulesInUse.Assign(ModuleSelectDLG.DstList.Items);
    // Load all the Selected Modules for further uses
    for i:=0 to ModulesInUse.count-1 do GlobalModules.LoadModule(ModulesInUse[i]);
    // Check whether the current Element is vaild
    if not IsLegalElement(CurrentModule, CurrentElement) then begin
      NextElement;
    end;
    // Maybe we need updating the inventory
    if PlanTab.ActivePage=InventorySheet then UpdateInventorySheet;
  end;
end;


procedure TPlanWindow.FreeTPointList(var X:TList);
var i:integer;
begin
  if Assigned(X) then begin
    for i:=0 to X.count-1 do
      if Assigned(X.Items[i]) then TPointObject(X.Items[i]).Free;
    X.Free;
  end;
  X:=NIL;
end;


procedure TPlanWindow.FreeConnectorList(var X:TList);
var i:integer;
begin
  if Assigned(X) then begin
    for i:=0 to X.count-1 do
      if Assigned(X.Items[i]) then TConnectorListPoint(X.Items[i]).Free;
    X.Free;
  end;
  X:=NIL;
end;

procedure TPlanWindow.FreeTextPointList;
var i:integer;
begin
  if Assigned(CurrentTextPList) then begin
    for i:=0 to CurrentTextPList.count-1 do
      if Assigned(CurrentTextPList.Items[i]) then TTextListPoint(CurrentTextPList.Items[i]).Free;
    CurrentTextPList.Free;
  end;
  CurrentTextPList:=NIL;
end;


procedure TPlanWindow.CurrentElementToCurrentList;
var NewInstance:TInstance;
    i:integer;
begin
  if not IsLegalElement(CurrentModule, CurrentElement) then exit;
  NewInstance:=TInstance.Create;
	NewInstance.Status:=NewInstance.Status and (not CShowFullNames) or CShowRailNames;
  NewInstance.AssignToElement(CurrentModule, CurrentElement);
  NewInstance.BreakApart;   // Clear all connectors (set them to -1)
  NewInstance.Color:=CurrentColor;
  NewInstance.Layer:=CurrentLayer;
  NewInstance.ResetNamePosition;

  FreeConnectorList(CurrentFolge);
  FreeConnectorList(CurrentOldFolge);

  if Assigned(CurrentInstList) then begin
    for i:=0 to CurrentInstList.count-1 do
      if Assigned(CurrentInstList.Items[i]) then TInstance(CurrentInstList.Items[i]).Free;
    CurrentInstList.Free;
  end;

  CurrentInstList:=TList.Create;
  CurrentInstList.Add(NewInstance);
  // and thats all for this List

  // Find all the Free connectors (all are Free) or at least should be Free
  MyPlan.CreateCnctList(CurrentInstList, CurrentFolge);

	MyPlan.GetSelectedFreeCnctList(CurrentOldFolge);

  MousePositioning:=CurrentOldFolge.count=0;

  FreeConnectorList(CurrentAllFreeConList);
  MyPlan.GetAllFreeCnctList(CurrentAllFreeConList);


  if CurrentOldPlace>=CurrentOldFolge.count then CurrentOldPlace:=0;
  if CurrentNewPlace>=CurrentFolge.count then CurrentNewPlace:=0;

  if CurrentOldFolge.count>0 then begin
    CurrentAddPos:=TConnectorListPoint(CurrentOldFolge.Items[CurrentOldPlace]).P;
    CurrentAddAngle:=FixedAngle(TConnectorListPoint(CurrentOldFolge.Items[CurrentOldPlace]).A+pi);
  end else begin
    CurrentAddPos:=CursorPos;
    CurrentAddAngle:=CursorAngle;
	end;

	MyPlan.SetInstancesPosTo(CurrentInstList, CurrentFolge, TConnectorListPoint(CurrentFolge.Items[CurrentNewPlace]).P,
													 TConnectorListPoint(CurrentFolge.Items[CurrentNewPlace]).A,
													 CurrentAddPos, CurrentAddAngle);
end;

procedure TPlanWindow.FollowingElement;
var Dummy : TElement;
		M     : TModule;
begin
	if PlacingElements then exit;

	if not GlobalModules.GetModule(CurrentModule, M) then exit;
	if not M.GetElement(CurrentElement, Dummy) then exit;

	StopFX; // let's stop the animation

//  CurrentNewPlace:=0; // CurrentFolge is undefined here !!!!
	CurrentElementToCurrentList;
	DrawListElements(CurrentInstList);
	PlacingElements:=TRUE;
end;


procedure TPlanWindow.TrashSelection;
var i        : integer;
		Inst     : TInstance;
		SelNr    : integer;
		t        : TColor;
		Redraw   : boolean;
begin
	if TextEditing then begin DeleteuserText; exit; end;
	if PlacingElements then begin AbortPlace; exit; end;
	if FlexEditing then begin  exit; end;
	if TableEditing then begin
		DeleteTablePoint;
		exit;
	end;
	Redraw:=FALSE;
	for i:=MyPlan.Selected.Size-1 downto 0 do if MyPlan.Selected[i] then begin
		if MyPlan.GetElement(i, Inst) then  begin
			t:=Inst.Color;// we dont want to lose the original Color in special Fx
			Inst.Color:=Planscroll.Color;
			Redraw:=Redraw or Inst.CacheElement.HasPolygon;
			MyPlan.UpdateSingle(i, Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor, FALSE, TRUE);
			// if Overview is desired...
			if GlobalOverview and Assigned(ParentElements.Overview) then begin
				 Inst.Color:=ParentElements.Overview.Color;
				 MyPlan.UpdateSingle(i, ParentElements.Overview.Canvas, OverviewXS, OverviewYS, OverviewF, OverviewF, TRUE, TRUE);
			end;
			Inst.Color:=t;
		end;
	end;

	// SelNr is the newly Selected Element, if any. Show the Element as marked.
	SelNr:=MyPlan.DeleteSelected;
	if SelNr>-1 then MyPlan.UpdateSingle(SelNr, Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor, FALSE, FALSE);
	if GlobalOverview then OverviewSilentUpdate;
	if GlobalPlanShowNames or Redraw then Plan.Invalidate;
end;

procedure TPlanWindow.CopySelection;
begin
  if PlacingElements or TableEditing or TextEditing or FlexEditing then exit;
  MyPlan.CopySelected;
  MyPlan.SelectedToMeta;
end;

procedure TPlanWindow.CutSelection;
begin
  if PlacingElements or TableEditing or TextEditing or FlexEditing then exit;
  CopySelection;
  TrashSelection;
end;

procedure TPlanWindow.PasteClipboard;
var    tUL, TLR:TDoublePoint;
begin
  if PlacingElements or TableEditing or TextEditing or FlexEditing then exit;
  StopFX;

  FreeConnectorList(CurrentFolge);
  FreeConnectorList(CurrentOldFolge);

  // Get the stored Instances form the stream to a List
  MyPlan.GetInstanceList(CurrentInstList);
  // to prevent hangups
  if CurrentInstList.count<=0 then begin
    CurrentInstList.Free; CurrentInstList:=NIL; exit;
  end;

	// Sort them in a List
  MyPlan.CreateCnctList(CurrentInstList, CurrentFolge);
  MyPlan.GetSelectedFreeCnctList(CurrentOldFolge);

  CurrentOldPlace:=0;
  if CurrentOldFolge.count>0 then begin
    CurrentAddPos:=TConnectorListPoint(CurrentOldFolge.Items[CurrentOldPlace]).P;
    CurrentAddAngle:=FixedAngle(TConnectorListPoint(CurrentOldFolge.Items[CurrentOldPlace]).A+pi);
    MousePositioning:=FALSE;
  end else begin
    MousePositioning:=TRUE;
		CurrentAddPos:=CursorPos;
    CurrentAddAngle:=0;
  end;
  FreeConnectorList(CurrentAllFreeConList);
  MyPlan.GetAllFreeCnctList(CurrentAllFreeConList);

  if CurrentFolge.count > 0 then begin
    MyPlan.SetInstancesPosTo(CurrentInstList, CurrentFolge, TConnectorListPoint(CurrentFolge.Items[0]).P,
                                       TConnectorListPoint(CurrentFolge.Items[0]).A,
                                       CurrentAddPos, CurrentAddAngle);
    DrawListElements(CurrentInstList);
    PlacingElements:=TRUE;
    if CurrentNewPlace>=CurrentFolge.count then CurrentNewPlace:=0;
//    CurrentNewPlace:=0;
  end else begin
    MyPlan.CalcRectAroundInstList(CurrentInstList, tUL, TLR);
    CurrentCM.X:=tUL.X+0.5*(TLR.X-tUL.X);
    CurrentCM.Y:=tUL.Y+0.5*(TLR.Y-tUL.Y);
    MyPlan.SetInstancesPosTo(CurrentInstList, CurrentFolge, CurrentCM, 0,
                                       CurrentAddPos, CurrentAddAngle);
    DrawListElements(CurrentInstList);
    MousePositioning:=TRUE;                                   
    PlacingElements:=TRUE;
  end;

end;

function TPlanWindow.UseGravity(GravityPointList:TList; var P:TDoublePoint; var A:Double):boolean;
var i:integer;
    TA:Double;
    TP:TDoublePoint;
    MD, t:Double;
    First:boolean;
begin
  First:=TRUE;
  Result:=FALSE;
  MD:=9999999;
  TA:=0;
  for i:=0 to GravityPointList.count-1 do begin
    if First then begin
			 MD:=CalcDist(TConnectorListPoint(GravityPointList[i]).P, P);
       TP:=TConnectorListPoint(GravityPointList[i]).P;
       TA:=TConnectorListPoint(GravityPointList[i]).A;
       First:=FALSE;
    end else begin
      t:=CalcDist(TConnectorListPoint(GravityPointList[i]).P, P);
      if t<MD then begin
        MD:=t;
        TP:=TConnectorListPoint(GravityPointList[i]).P;
        TA:=TConnectorListPoint(GravityPointList[i]).A;
      end;
    end;
  end;
  if MD<=GlobalGravityRange  then begin
    Result:=TRUE;
    P:=TP;
    A:=FixedAngle(TA+pi);
  end;
end;

procedure TPlanWindow.NextNewPlace;
var    tUL, TLR:TDoublePoint;
begin
  if not Assigned(CurrentInstList) then exit;
  DrawListElements(CurrentInstList);
  INC(CurrentNewPlace); if CurrentNewPlace>=CurrentFolge.count then CurrentNewPlace:=0;
  if CurrentFolge.count > 0 then begin
    MyPlan.SetInstancesPosTo(CurrentInstList, CurrentFolge, TConnectorListPoint(CurrentFolge.Items[CurrentNewPlace]).P,
                                       TConnectorListPoint(CurrentFolge.Items[CurrentNewPlace]).A,
                                       CurrentAddPos, CurrentAddAngle);
  end else begin
    MyPlan.CalcRectAroundInstList(CurrentInstList, tUL, TLR);
    CurrentCM.X:=tUL.X+0.5*(TLR.X-tUL.X);
    CurrentCM.Y:=tUL.Y+0.5*(TLR.Y-tUL.Y);
    MyPlan.SetInstancesPosTo(CurrentInstList, CurrentFolge, CurrentCM, 0,
                                       CurrentAddPos, CurrentAddAngle);
  end;
  DrawListElements(CurrentInstList);
  PlacingElements:=TRUE;
end;

procedure TPlanWindow.NextOldPlace;
var    tUL, TLR:TDoublePoint;
begin
  if not PlacingElements then exit;
  DrawListElements(CurrentInstList);
  if Assigned(CurrentOldFolge) then begin
    INC(CurrentOldPlace); if CurrentOldPlace>=CurrentOldFolge.count then CurrentOldPlace:=0;
    if CurrentOldFolge.count>0 then begin
      CurrentAddPos:=TConnectorListPoint(CurrentOldFolge.Items[CurrentOldPlace]).P;
      CurrentAddAngle:=FixedAngle(TConnectorListPoint(CurrentOldFolge.Items[CurrentOldPlace]).A+pi);
    end else begin
      CurrentAddPos:=CursorPos;
      CurrentAddAngle:=CursorAngle;
    end;
  end else begin
    CurrentAddPos:=CursorPos;
    CurrentAddAngle:=CursorAngle;
  end;
  if CurrentFolge.count > 0 then begin
    MyPlan.SetInstancesPosTo(CurrentInstList, CurrentFolge, TConnectorListPoint(CurrentFolge.Items[CurrentNewPlace]).P,
                                       TConnectorListPoint(CurrentFolge.Items[CurrentNewPlace]).A,
                                       CurrentAddPos, CurrentAddAngle);
  end else begin
     MyPlan.CalcRectAroundInstList(CurrentInstList, tUL, TLR);
     CurrentCM.X:=tUL.X+0.5*(TLR.X-tUL.X);
     CurrentCM.Y:=tUL.Y+0.5*(TLR.Y-tUL.Y);
     MyPlan.SetInstancesPosTo(CurrentInstList, CurrentFolge, CurrentCM, 0,
                                       CurrentAddPos, CurrentAddAngle);
  end;
  DrawListElements(CurrentInstList);
  PlacingElements:=TRUE;
end;

procedure TPlanWindow.AbortPlace;
var i:integer;
begin
  if not PlacingElements then exit; // should never happen ... anyway
  DrawListElements(CurrentInstList);
  if Assigned(CurrentInstList) then begin
		for i:=0 to CurrentInstList.count-1 do
      if Assigned(CurrentInstList.Items[i]) then TInstance(CurrentInstList.Items[i]).Free;
    CurrentInstList.Free;
  end;
  CurrentInstList:=NIL;
  CurrentFolge.Free; CurrentFolge:=NIL;
  CurrentOldFolge.Free; CurrentOldFolge:=NIL;
  PlacingElements:=FALSE;
  Plan.Invalidate;
end;

procedure TPlanWindow.ConfirmCurrentPlace;
var ResultList:TList;
    i : integer;
    j : integer;
begin
  MyPlan.ClearSelection;

  ResultList:=TList.Create;
  // ..., TRUE means select the inserted elements
  MyPlan.AddInstancesList(CurrentInstList, TRUE, ResultList);
  if Assigned(RailyFX) then begin
    for i:=0 to ResultList.count-1 do begin
      for j:=0 to CurrentAllFreeConList.count-1 do
         if ((TPointObject(ResultList[i]).P.X)=(TConnectorListPoint(CurrentAllFreeConList[j]).P.X)) and
          ((TPointObject(ResultList[i]).P.Y)=(TConnectorListPoint(CurrentAllFreeConList[j]).P.Y)) then begin
           RailyFX.AddFX(TLinkedTogetherFX.Create(TPointObject(ResultList[i]).P, 50, 20, 2, clGreen));
           TPointObject(CurrentAllFreeConList[j]).Free;
           CurrentAllFreeConList.Delete(j); CurrentAllFreeConList.Pack;
           Break;
         end;
    end;
  end;
  FreeTPointList(ResultList);

  CurrentFolge.Free; CurrentFolge:=NIL;
  CurrentOldFolge.Free; CurrentOldFolge:=NIL;
// to allow continuing with drag-drop placing ...
  if MousePositioning then MyPlan.ClearSelection;
  PlacingElements:=FALSE;
	MousePositioning:=FALSE;
  Plan.Invalidate;
  if GlobalOverview then if Assigned(ParentElements.Overview) then ParentElements.Overview.Invalidate;
end;

procedure TPlanWindow.OverviewSilentUpdate;
begin
  if Assigned(ParentElements.Overview) then
  MyPlan.Draw(ParentElements.Overview.Canvas, OverviewXS, OverviewYS, OverviewF, OverviewF, TRUE, TRUE, -1)
end;

procedure TPlanWindow.SilentUpdate;
begin
  CleverDrawTable;
  MyPlan.Draw(Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor, FALSE, FALSE, -1);
end;

procedure TPlanWindow.DrawListElements(X:TList);
var i:integer;
    Inst:TInstance;
    OldMode:TPenMode;
begin
  if not Assigned(X) then exit;
  OldMode:=Plan.Canvas.Pen.Mode;
  Plan.Canvas.Pen.Mode:=pmNotXOR;
  MyPlan.DrawInfo.ShowRailNames:=FALSE;
  for i:=0 to X.count-1 do begin
    Inst:=TInstance(X.Items[i]);
    if Assigned(Inst) then begin
      Inst.Draw(Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor, FALSE, @MyPlan.DrawInfo);
    end;
  end;
  MyPlan.DrawInfo.ShowRailNames:=GlobalPlanShowNames;
  Plan.Canvas.Pen.Mode:=OldMode;
end;

procedure TPlanWindow.StopFX;
begin
  if Assigned(RailyFX) then RailyFX.ClearFX(Zoomfactor, Zoomfactor, XSpace, YSpace);
end;

procedure TPlanWindow.FXTick;
begin
  if Assigned(RailyFX) then
    if RailyFX.Tick(Zoomfactor, Zoomfactor, XSpace, YSpace) then SilentUpdate;
end;

procedure TPlanWindow.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if PlanTab.ActivePage=VisualSheet then begin
    if (Key=VK_Add) or (Key=81 {VK_Q}) then begin NextElement;Key:=0;end;
    if (Key=VK_Subtract) or (Key=87 {VK_w})  then begin LastElement;Key:=0;end;

    // Editing
    if Key=VK_Delete then begin TrashSelection;Key:=0;end;
    if (Key=88{VK_X}) and (ssCtrl in Shift) then begin CutSelection;Key:=0;end;
    if (Key=67{VK_C}) and (ssCtrl in Shift) then begin CopySelection;  Key:=0;end;
    if (Key=86{VK_V}) and (ssCtrl in Shift) then begin PasteClipboard;  Key:=0;end;
    if (Key=85{VK_U}) and Assigned(ParentElements.Overview) then ParentElements.Overview.Invalidate;
    if (Key=80{VK_P}) or (Key=93) then begin
      Key:=0;
      if TableEditing then TableEditPopup.PopUp(100, 100) else
      if TextEditing then TextPopup.PopUp(100, 100) else
      if FlexEditing then FlexPopup.PopUp(100, 100) else 
      PopupEditMenu(100, 100);
    end;

    if (Key=65{VK_A}) and (ssCtrl in Shift) then begin MyPlan.SelectAll; ShowAll end;
    if (Key=65{VK_A}) and not (ssCtrl in Shift) then begin
      if not PlacingElements then FollowingElement else NextOldPlace;
      Key:=0;
    end;

    if (Key=83{VK_S}) and not (ssCtrl in Shift) then if PlacingElements then begin NextNewPlace;Key:=0;end;

    if Key=VK_Return then begin
      if PlacingElements then ConfirmCurrentPlace;
      Key:=0;
    end;

    if (Key=VK_Escape) then begin
      if PlacingElements then AbortPlace;
      Key:=0;
    end;

    if (Key=ORD('K')) or (Key=ORD('l')) then begin
      if (Key=ORD('K')) then UserRotation:=UserRotation+GlobalDeltaAngle/180*pi else UserRotation:=UserRotation-GlobalDeltaAngle/180*pi;
      UserRotation:=FixedAngle(UserRotation);
      CursorAngle:=FixedAngle(UserRotation+pi);
      if MousePositioning then NextOldPlace;
      if Assigned(ParentElements.Status) then ParentElements.Status.Invalidate;
//      Plan.Invalidate;
    end;
  end;
end;

procedure TPlanWindow.PlanDragOver(Sender, Source: TObject; X, Y: integer;
  State: TDragState; var Accept: boolean);
var C       : TDoublePoint;
    OldMode : TPenMode;
begin
  C.X:=X/Zoomfactor-XSpace;
  C.Y:=Y/Zoomfactor-YSpace;
  if Assigned(CurrentPointer) then begin
    OldMode:=Plan.Canvas.Pen.Mode;
    Plan.Canvas.Pen.Mode:=pmNotXOR;
    CurrentPointer.Draw(Plan.Canvas, XSpace+LastDragPos.X, YSpace+LastDragPos.Y, 0, Zoomfactor, Zoomfactor, @MyPlan.DrawInfo);
    CurrentPointer.Draw(Plan.Canvas, XSpace+C.X, YSpace+C.Y, 0, Zoomfactor, Zoomfactor, @MyPlan.DrawInfo);
    Plan.Canvas.Pen.Mode:=OldMode;
  end;
  LastDragPos:=C;
end;

procedure TPlanWindow.FormDestroy(Sender: TObject);
begin
  MyPlan.Free;
  if Assigned(RailyFX) then RailyFX.Free;
  CurrentTextPList.Free;
  ModulesInUse.Free;
end;

procedure TPlanWindow.PasteClick(Sender: TObject);
begin
  PasteClipboard;
end;

procedure TPlanWindow.Copy1Click(Sender: TObject);
begin
  CopySelection;
end;

procedure TPlanWindow.Cut1Click(Sender: TObject);
begin
  CutSelection;
end;

procedure TPlanWindow.Delete1Click(Sender: TObject);
begin
  TrashSelection;
end;

procedure TPlanWindow.BuildStandardTable;
begin
  MyPlan.BuildStandardTable;
  ShowAll;
end;

procedure TPlanWindow.ClearTable;
begin
  MyPlan.ClearTablePolygon;
  Plan.Invalidate;
end;

procedure TPlanWindow.DrawDragablePoints(points:TList; Selected:integer);
var i        : integer;
    OldStyle : TBrushStyle;
    OldMode  : TPenMode;
    TX, TY   : integer;
    PRS      : integer;
		OldWidth : integer;
begin
  if not Assigned(points) then exit;
  OldMode:=Plan.Canvas.Pen.Mode;
  Plan.Canvas.Pen.Mode:=pmNotXOR;
  OldStyle:=Plan.Canvas.Brush.Style;
  Plan.Canvas.Brush.Color:=clBlack;
  Plan.Canvas.Brush.Style:=bsClear;
  OldWidth:=Plan.Canvas.Pen.Width;
  for i:=0 to points.count-1 do begin
    if i=Selected then Plan.Canvas.Pen.Color:=clRed else Plan.Canvas.Pen.Color:=clBlack;
    TX:=Round((TPointObject(points[i]).P.X+XSpace)*Zoomfactor);
    TY:=Round((TPointObject(points[i]).P.Y+YSpace)*Zoomfactor);
    PRS:=PointRectSize;
    if FlexEditing and ((i=1) or (i=points.count-2)) then Plan.Canvas.Pen.Width:=1 else begin
      Plan.Canvas.Pen.Width:=6;
      PRS:=PointRectSize-3;
    end;
    Plan.Canvas.rectangle(TX-PRS, TY-PRS, TX+PRS, TY+PRS);
  end;
  Plan.Canvas.Brush.Style:=OldStyle;
  Plan.Canvas.Pen.Mode:=OldMode;
  Plan.Canvas.Pen.Width:=OldWidth;
end;

function TPlanWindow.CheckDragablePoints(X, Y:integer; points:TList; var Nr:integer):boolean;
var i        : integer;
    TX, TY   : integer;
begin
  Result:=FALSE;
  if not Assigned(points) then exit;
  Nr:=-1;
  for i:=0 to points.count-1 do begin
    TX:=Round((TPointObject(points[i]).P.X+XSpace)*Zoomfactor);
    TY:=Round((TPointObject(points[i]).P.Y+YSpace)*Zoomfactor);
    if (X>TX-PointRectSize) and (X<TX+PointRectSize) and
       (Y>TY-PointRectSize) and (Y<TY+PointRectSize) then begin
       Nr:=i;
       Result:=TRUE;
       exit;
		end;
  end;
end;

function TPlanWindow.CheckTextPoints(X, Y:integer; var Nr:integer):boolean;
var i        : integer;
    TX, TY   : Double;
begin
  Result:=FALSE;
  if not Assigned(CurrentTextPList) then exit;
  Nr:=-1;
  for i:=0 to CurrentTextPList.count-1 do begin
    TX:=X/Zoomfactor-XSpace;
    TY:=Y/Zoomfactor-YSpace;
    if (TX>TTextListPoint(CurrentTextPList[i]).A.X) and (TY>TTextListPoint(CurrentTextPList[i]).A.Y) and
       (TX<TTextListPoint(CurrentTextPList[i]).B.X) and (TY<TTextListPoint(CurrentTextPList[i]).B.Y) then begin
       TextDX:=TX-TTextListPoint(CurrentTextPList[i]).A.X;
       TextDY:=TY-TTextListPoint(CurrentTextPList[i]).A.Y;
       Nr:=i;
       Result:=TRUE;
       exit;
    end;
  end;
end;

procedure TPlanWindow.EditTable(Really:boolean);
begin
  if (TableEditing XOR Really) then begin
    if Really then begin
      MyPlan.IsSaved:=FALSE;
      EditFlex(FALSE);
      EditText(FALSE);
      if MyPlan.TablePolygon.count<3 then BuildStandardTable;
      MyPlan.DrawInfo.OverruleColor:=TRUE;
      MyPlan.DrawInfo.TextColorOverrule:=TRUE;
      MyPlan.DrawInfo.Blacked:=FALSE;
      MovTablePoint:=FALSE;
      if Assigned(ParentElements_ChooseBTN) then ParentElements_ChooseMode(1);

//      if Assigned(ParentElements.SpecialMode) then ParentElements.SpecialMode(TRUE);
		end else begin
      if Assigned(ParentElements_SpecialMode) then ParentElements_SpecialMode(FALSE);
      MyPlan.DrawInfo.OverruleColor:=FALSE;
      MyPlan.DrawInfo.TextColorOverrule:=FALSE;
    end;
    DrawDragablePoints(MyPlan.TablePolygon,SelTablePoint);
    TableEditing := Really;
    Plan.Invalidate;
  end;
end;

procedure TPlanWindow.RescanAllTexts;
var i:integer;
    TP:TTextListPoint;
    S:string;
    TInst:TInstance;
begin
  FreeTextPointList;
  CurrentTextPList:=TList.Create;
  if GlobalPlanShowNames then begin
    for i:=0 to MyPlan.InstanceElements.count-1 do begin
      if Assigned(MyPlan.InstanceElements[i]) then begin
        TInst:=TInstance(MyPlan.InstanceElements[i]);
        if (TInst.Layer>=0) and (TInst.Layer<MyPlan.Layers.Size) and (not MyPlan.Layers[TInst.Layer]) then Continue;
        if (TInst.Status and CShowRailNames) =0 then Continue;
        TP:=TTextListPoint.Create;
        TP.RailText:=TRUE;
        TP.ID:=TInst.ID;
        TP.A:=TInst.TextPos;
        Plan.Canvas.Font.Height:=GlobalRailNrHeight;
        if ((TInst.Status and CShowFullNames) >0) or (Pos(' ', TInst.CacheElement.Info.Name)=0) then
            S:=TInst.CacheElement.Info.Name
         else
            S:=Copy(TInst.CacheElement.Info.Name, 1, Pos(' ', TInst.CacheElement.Info.Name));

        TP.B.X:=TP.A.X+Plan.Canvas.TextWidth(S);
        TP.B.Y:=TP.A.Y+GlobalRailNrHeight;
        CurrentTextPList.Add(TP);
      end;
    end;
	end;
  if GlobalPlanUserTXT then begin
    for i:=0 to MyPlan.UserTexts.count-1 do begin
      TP:=TTextListPoint.Create;
      TP.RailText:=FALSE;
      TP.ID:=i;
      TP.A:=TUserTextEntry(MyPlan.UserTexts[i]).P;
      Plan.Canvas.Font.Height:=GlobalUserTXTHeight;
      S:=TUserTextEntry(MyPlan.UserTexts[i]).S;
      TP.B.X:=TP.A.X+Plan.Canvas.TextWidth(S);
      TP.B.Y:=TP.A.Y+GlobalUserTXTHeight;
      CurrentTextPList.Add(TP);
    end;
  end;
end;

procedure TPlanWindow.EditText(Really:boolean);
begin
  if (TextEditing XOR Really) then begin
    if Really then begin
       RescanAllTexts;

       EditFlex(FALSE);
       EditTable(FALSE);
       MoveTextPoint:=FALSE;
       MyPlan.DrawInfo.OverruleColor:=TRUE;
       MyPlan.DrawInfo.TextColorOverrule:=FALSE;
       MyPlan.DrawInfo.Blacked:=FALSE;
       if Assigned(ParentElements_ChooseBTN) then ParentElements_ChooseMode(3);
       MyPlan.IsSaved:=FALSE;
//       if Assigned(ParentElements.SpecialMode) then ParentElements.SpecialMode(TRUE);
    end else begin
      if Assigned(ParentElements_SpecialMode) then ParentElements_SpecialMode(FALSE);
      MyPlan.DrawInfo.OverruleColor:=FALSE;
    end;
    TextEditing := Really;
    Plan.Invalidate;
  end;
end;

procedure TPlanWindow.EditFlex(Really:boolean);
var i, j  : integer;
    TInst : TInstance;
    Inst2 : TInstance;
    XA    : TPrepAddInstance;
    XD    : TPrepDelInstance;
    TC    : TConnector;
    TNR   : integer;
    CnctObj : TConnectorListPoint;
begin
  if (FlexEditing XOR Really) then begin
    if Really then begin
      EditTable(FALSE);
      EditText(FALSE);
//      if Assigned(ParentElements.SpecialMode) then ParentElements.SpecialMode(TRUE);
      if Assigned(ParentElements_ChooseBTN) then ParentElements_ChooseMode(2);
      for i:=0 to MyPlan.Selected.Size-1 do begin
        if MyPlan.Selected[i] then begin
          if MyPlan.GetElement(i, TInst) then begin
            if TInst.IsFlex then begin
              MoveFlexPoint:=FALSE;
              MyPlan.IsSaved:=FALSE;
// Undo part
              MyPlan.UndoHelper.Open;
              XA:=TPrepAddInstance.Create;
              MyPlan.UndoHelper.AddState(XA);
              TInst.ToStream(XA.Backup);
              XD:=TPrepDelInstance.Create;
              XD.DeathCandidate:=TInst.ID;
              MyPlan.UndoHelper.AddState(XD);
              MyPlan.UndoHelper.Close;
// end of Undo part

              CurrentFlexInst:=TInst;
              CurrentFlexINr:=i;
              CurrentFlexPoly:=TInst.FlexAddition.points;
              CurrentLFlexMin:=TInst.CacheElement.Info.TheRadius;
              CurrentLFlexMax:=TInst.CacheElement.Info.TheAngle;
              FreeConnectorList(CurrentAllFreeConList);
              MyPlan.GetAllFreeCnctList(CurrentAllFreeConList);
							j:=0;
              while j<CurrentAllFreeConList.count do begin
               if Assigned(CurrentAllFreeConList[j]) then
                 if TConnectorListPoint(CurrentAllFreeConList[j]).ID=TInst.ID then begin
                   TConnectorListPoint(CurrentAllFreeConList[j]).Free;
                   CurrentAllFreeConList.Delete(j);
                   CurrentAllFreeConList.Pack;
                 end else INC(j);
              end;
// Add the current connectors to the connector List
              TInst.GetConnector(0, TC);
              if TC.Nr<>-1 then if MyPlan.FindElementWithID(TC.Nr, Inst2, TNR) then begin
                for j:=0 to Inst2.ConnectorCount-1 do begin
                  if Inst2.GetConnector(j, TC) and (TC.Nr = TInst.ID) then begin
                    CnctObj:=TConnectorListPoint.Create;
                    CnctObj.Cnct:=j;
                    CnctObj.ID:=Inst2.ID;
                    Inst2.GetConnectorPos(j, CnctObj.P, CnctObj.A);
                    CurrentAllFreeConList.Add(CnctObj);
                    Break;
                  end;
                end;
              end;
              TInst.GetConnector(1, TC);
              if TC.Nr<>-1 then if MyPlan.FindElementWithID(TC.Nr, Inst2, TNR) then begin
                for j:=0 to Inst2.ConnectorCount-1 do begin
                  if Inst2.GetConnector(j, TC) and (TC.Nr = TInst.ID) then begin
                    CnctObj:=TConnectorListPoint.Create;
                    CnctObj.Cnct:=j;
                    CnctObj.ID:=Inst2.ID;
                    Inst2.GetConnectorPos(j, CnctObj.P, CnctObj.A);
                    CurrentAllFreeConList.Add(CnctObj);
                    Break;
                  end;
                end;
              end;
              Break;
            end;
          end;
        end;
			end;
      MyPlan.DrawInfo.OverruleColor:=TRUE;
      MyPlan.DrawInfo.TextColorOverrule:=TRUE;
      MyPlan.DrawInfo.Blacked:=FALSE;
      FlexEditing := TRUE;
      DrawDragablePoints(CurrentFlexPoly,SelFlexPoint);
      Plan.Invalidate;
    end else begin
      MyPlan.DrawInfo.OverruleColor:=FALSE;
      MyPlan.DrawInfo.TextColorOverrule:=FALSE;
      FlexEditing := FALSE;
      if Assigned(ParentElements_SpecialMode) then ParentElements_SpecialMode(FALSE);
      Plan.Invalidate;
      // we need to correct some connections
      if Assigned(CurrentFlexInst) and (CurrentFlexInst.IsFlex) then begin
        CurrentFlexInst.Checkin; // Get the new rectangle around
        // remove the Element from the Plan, not undoable and dont Free the Instance
        MyPlan.DeleteElement(CurrentFlexINr, FALSE, FALSE);
        // now just Add it again. again not undoable
        // Selected, not undoable, no new ID
        MyPlan.AddInstance(CurrentFlexInst, TRUE, FALSE, FALSE, NIL);
        if GlobalOverview then if Assigned(ParentElements.Overview) then ParentElements.Overview.Invalidate;
      end;
      CurrentFlexInst:=NIL;
      CurrentFlexPoly:=NIL;
      CurrentFlexINr:=-1;
    end;
  end;
  if Assigned(ParentElements.Status) then ParentElements.Status.Invalidate;
end;

procedure TPlanWindow.DeletePolyPoint(points:TList; Nr:integer);
begin
  if not Assigned(points) then exit;
  if (Nr>=0) and (Nr<points.count) then begin
    TPointObject(points[Nr]).Free;
    points.Delete(Nr);
    points.Pack;
  end;
end;

procedure TPlanWindow.DeleteTablePoint;
begin
   DrawDragablePoints(MyPlan.TablePolygon, SelTablePoint);
   CleverDrawTable;
   DeletePolyPoint(MyPlan.TablePolygon, SelTablePoint);
   CleverDrawTable;
   DrawDragablePoints(MyPlan.TablePolygon, SelTablePoint);
   Plan.Invalidate;
end;

procedure TPlanWindow.InsertTablePoint;
var X, Y:Double;
begin
  if not TableEditing then exit;
  if (SelTablePoint>=0) and (SelTablePoint<MyPlan.TablePolygon.count) then begin
    X:=0.5*(TPointObject(MyPlan.TablePolygon[(SelTablePoint+1) MOD MyPlan.TablePolygon.count]).P.X+TPointObject(MyPlan.TablePolygon[SelTablePoint]).P.X);
    Y:=0.5*(TPointObject(MyPlan.TablePolygon[(SelTablePoint+1) MOD MyPlan.TablePolygon.count]).P.Y+TPointObject(MyPlan.TablePolygon[SelTablePoint]).P.Y);
    DrawDragablePoints(MyPlan.TablePolygon,SelTablePoint);
    CleverDrawTable;
    MyPlan.TablePolygon.Insert((SelTablePoint+1) MOD MyPlan.TablePolygon.count, TPointObject.Create(X, Y));
    CleverDrawTable;
    DrawDragablePoints(MyPlan.TablePolygon, SelTablePoint);
  end;
end;

procedure TPlanWindow.CleverDrawTable;
var OldMode  : TPenMode;
begin
  OldMode:=Plan.Canvas.Pen.Mode;
  if TableEditing then Plan.Canvas.Pen.Mode:=pmNotXOR;
  if not TableEditing then SelTablePoint:=-1;
  if MovTablePoint then MyPlan.DrawTable(Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor, SelTablePoint, FALSE)
                   else MyPlan.DrawTable(Plan.Canvas, XSpace, YSpace, Zoomfactor, Zoomfactor, SelTablePoint, GlobalTableSizeNrs);
  Plan.Canvas.Pen.Mode:=OldMode;
end;

procedure TPlanWindow.ResetModulesInUse;
var i        : integer;
    TempInst : TInstance;
begin
  ModulesInUse.Clear; // no Modules are currently in Use
  with MyPlan do for i:=0 to InstanceElements.count-1 do
    if GetElement(i, TempInst) and Assigned(TempInst) then
      ModulesInUse.Add(StrPas(TempInst.ModuleName));
end;

procedure TPlanWindow.InventoryGridSelectCell(Sender: TObject; Col,
  Row: longint; var CanSelect: boolean);
begin
  CanSelect:=Col=EditableCol;
end;

procedure TPlanWindow.InventoryGridDrawCell(Sender: TObject; Col,
  Row: longint; Rect: TRect; State: TGridDrawState);
var S      : string;
    CM, CE : string;
    B      : TColor;
    T1, T2 : integer;
begin
  with TStringGrid(Sender).Canvas do begin
    B:=clWindow;
    if (Row=0) then B:=clBtnFace;
    Brush.Color:=B;
    Pen.Color:=B;
    rectangle(Rect.Left, Rect.Top, Rect.right, Rect.bottom);

    if (Col=PreviewCol) and (Row>0) then begin
      CM:=TStringGrid(Sender).Cells[0, Row];
      CE:=TStringGrid(Sender).Cells[1, Row];
      Pen.Color:=clBlack;
      ShowPreview(TStringGrid(Sender).Canvas,  Rect.Left+1, Rect.Top+1, Rect.right-Rect.Left-2, Rect.bottom-Rect.Top-2, CM, CE, FALSE);
      exit;
    end;

    Font.Name:='Arial';
    if (Col=ResultCol) and (Row>0) then begin
      try T1:=StrToInt(Trim(TStringGrid(Sender).Cells[EditableCol, Row])); except T1:=0; end;
      try T2:=StrToInt(Trim(TStringGrid(Sender).Cells[UsedCol, Row])); except T2:=0; end;
      S:=IntToStr(T1-T2);
		end else S:=Trim(TStringGrid(Sender).Cells[Col, Row]);
    Font.Color:=clWindowText;
    if (Col=ResultCol) and (Length(S)>0) and (S[1]='-') then Font.Color:=clRed;
    TextRect(Rect, Rect.Left+(Rect.right-Rect.Left-TextWidth(S)) DIV 2,
                   Rect.Top+(Rect.bottom-Rect.Top-TextHeight(S)) DIV 2, S);
   end;
end;

procedure TPlanWindow.InventoryGridGetEditMask(Sender: TObject; ACol,
  ARow: longint; var Value: string);
begin
  if ACol = EditableCol then Value :=  '999999';
end;

procedure TPlanWindow.InventoryGridSetEditText(Sender: TObject; ACol,
  ARow: longint; const Value: string);
var Nr:integer;
begin
  //Initiate Redraw
  TStringGrid(Sender).Cells[ResultCol, ARow]:='?';
  try Nr:=StrToInt(Trim(Value)) except Nr:=0; end;
  MyPlan.inventory.Has(TStringGrid(Sender).Cells[ModNameCol, ARow], TStringGrid(Sender).Cells[ElNameCol, ARow], Nr);
end;

procedure TPlanWindow.InventoryGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_Return then if TStringGrid(Sender).Row<TStringGrid(Sender).RowCount-1 then TStringGrid(Sender).Row:=TStringGrid(Sender).Row+1;
end;

procedure TPlanWindow.INVShowAllCBXClick(Sender: TObject);
begin
  UpdateInventorySheet;
end;

procedure TPlanWindow.PlanGetBounds(var UL, DR: TDoublePoint);
begin
  UL:=MyPlan.UL;
  DR:=MyPlan.LR;
end;

procedure TPlanWindow.PlanDruckerAusgabe(X:TCanvas; xs, ys, xf, yf:Double; BW:boolean);

  procedure PrintGrid;
  var TL, DR:TDoublePoint;
      xi, yi  : Double;
      Delta : Double;
  begin
    Delta:=GlobalPlanGridSize;
    TL:=MyPlan.UL; DR:=MyPlan.LR;
    TL.Y:=(Trunc(TL.Y/Delta)-1)*Delta;
    TL.X:=(Trunc(TL.X/Delta)-1)*Delta;
    yi:=TL.Y;
    while yi<DR.Y do begin
      xi:=TL.X;
      while xi<DR.X do begin
        xi:=xi+Delta;
        X.MoveTo(Round((xi+xs)*xf-5), Round((yi+ys)*yf));
        X.LineTo(Round((xi+xs)*xf+5), Round((yi+ys)*yf));
        X.MoveTo(Round((xi+xs)*xf), Round((yi+ys)*yf)-5);
        X.LineTo(Round((xi+xs)*xf), Round((yi+ys)*yf)+5);
      end;
      yi:=yi+Delta;
    end;
  end;

var TDI:TDrawInfo;
begin
  X.Pen.Mode:=pmCopy;
  TDI:=MyPlan.DrawInfo;
  if BW then begin
    MyPlan.DrawInfo.OverruleColor:=TRUE;
    MyPlan.DrawInfo.Blacked:=TRUE;
  end;
  X.Font.Height:=Round(ABS(GlobalRailNrHeight*yf));
  X.Font.Name:='Arial';
  MyPlan.Draw(X, xs, ys, xf, yf, FALSE, TRUE, -1);
  
  MyPlan.DrawInfo:=TDI;
  if GlobalPlanPrintTable then MyPlan.DrawTable(X, xs, ys, xf, yf, -1, GlobalTableSizeNrs);
	if GlobalPlanPrintGrid then PrintGrid;
  if GlobalPlanUserTXT then MyPlan.DrawUserText(X, xs, ys, xf, yf);
end;

procedure TPlanWindow.SelectionGetBounds(var UL, DR: TDoublePoint);
begin
  MyPlan.CalcRectAroundSelection;
  UL:=MyPlan.SUL;
  DR:=MyPlan.SLR;
end;

procedure TPlanWindow.PrintSelection(X:TCanvas; xs, ys, xf, yf:Double; BW:boolean);

  procedure PrintGrid;
  var TL, DR:TDoublePoint;
      xi, yi  : Double;
      Delta : Double;
  begin
    Delta:=GlobalPlanGridSize;
    TL:=MyPlan.UL; DR:=MyPlan.LR;
    TL.Y:=(Trunc(TL.Y/Delta)-1)*Delta;
    TL.X:=(Trunc(TL.X/Delta)-1)*Delta;
    yi:=TL.Y;
    while yi<DR.Y do begin
      xi:=TL.X;
      while xi<DR.X do begin
        xi:=xi+Delta;
        X.MoveTo(Round((xi+xs)*xf-5), Round((yi+ys)*yf));
        X.LineTo(Round((xi+xs)*xf+5), Round((yi+ys)*yf));
        X.MoveTo(Round((xi+xs)*xf), Round((yi+ys)*yf)-5);
        X.LineTo(Round((xi+xs)*xf), Round((yi+ys)*yf)+5);
      end;
      yi:=yi+Delta;
    end;
  end;

var i:integer;
    Inst:TInstance;
    DI:TDrawInfo;
begin
	X.Pen.Mode:=pmCopy;
  X.Font.Height:=Round(ABS(GlobalRailNrHeight*yf));
  X.Font.Name:='Arial';

  for i:=0 to MyPlan.InstanceElements.count-1 do begin
    if MyPlan.Selected[i] then begin
      Inst:=TInstance(MyPlan.InstanceElements.Items[i]);
      DI:=MyPlan.DrawInfo;
      if BW then begin
        DI.OverruleColor:=TRUE;
        DI.Blacked:=TRUE;
      end;
      if Assigned(Inst) then Inst.Draw(X, xs, ys, xf, yf, FALSE, @DI);
    end;
  end;
  if GlobalPlanPrintTable then MyPlan.DrawTable(X, xs, ys, xf, yf, -1, GlobalTableSizeNrs);
  if GlobalPlanPrintGrid then PrintGrid;
end;

procedure TPlanWindow.PrintSelectionDialog;
var Preview:TPreviewForm;
begin
  Preview:=TPreviewForm.Create(Self);
  Preview.AusgabeProc:=PrintSelection;
  Preview.GetBoundsProc:=SelectionGetBounds;
  Preview.Info.Name:=ExtractFileName(CurrentFileName)+' ('+TransStr('[selection]')+')';
  Preview.Info.Author:=MyPlan.Info.Author;
  Preview.Title:='RAILY - '+ExtractFileName(CurrentFileName)+' ('+TransStr('[selection]')+')';
  Preview.PrepShowAll;
  Preview.ShowModal;
  Preview.Destroy;
end;

procedure TPlanWindow.PrintDialog;
var Preview:TPreviewForm;
begin
  Preview:=TPreviewForm.Create(Self);
  Preview.AusgabeProc:=PlanDruckerAusgabe;
  Preview.GetBoundsProc:=PlanGetBounds;
  Preview.Info.Name:=ExtractFileName(CurrentFileName);
	Preview.Info.Author:=MyPlan.Info.Author;
  Preview.Title:='RAILY - '+ExtractFileName(CurrentFileName);
  Preview.PrepShowAll;
  Preview.ShowModal;
  Preview.Destroy;
end;


procedure TPlanWindow.InventoryPageCount(DW, DH:integer; var PC:integer);
var i:integer;
    Pos:integer;
    TopSpace:integer;
    BottomSpace:integer;
begin
  TopSpace:=GlobalInvTM*10;
  BottomSpace:=GlobalInvBM*10;
  PC:=1;
  Pos:=TopSpace+2*GlobalInvHeight;
  for i:=0 to MyPlan.inventory.List.count-1 do begin
    if Pos+GlobalInvHeight>=DH-BottomSpace-GlobalInvHeight then begin
      // only do this if there is realy another page
      if i<MyPlan.inventory.List.count-1 then begin
        Pos:=TopSpace; INC(PC);
        // need to Lines for header
        INC(Pos, GlobalInvHeight);
        INC(Pos, GlobalInvHeight);
      end;
    end;
    INC(Pos, GlobalInvHeight);
  end;
end;

procedure TPlanWindow.InventoryPagePrint(X:TCanvas; DW, DH, PG:integer);
const DefWidth:array[0..5] of integer=(175, 105, 60, 60, 60, 60);
var LPos, i, Pos, PC, S : integer;
    f                   : Double;
    TIE                 : TInventoryListEntry;
    ColWidths           : array[0..5] of integer;
    St                  : string;
    TopSpace            : integer;
		LeftSpace           : integer;
    BottomSpace         : integer;
    RightSpace          : integer;
begin
  TopSpace:=GlobalInvTM*10;
  LeftSpace:=GlobalInvLM*10;
  BottomSpace:=GlobalInvBM*10;
  RightSpace:=GlobalInvRM*10;
  // Calc the ColWidth
  f:=1;S:=0;
  for i:=0 to 5 do ColWidths[i]:=DefWidth[i];
  if not GlobalInvPictures then ColWidths[2]:=0;

  for i:=0 to 5 do S:=S+ColWidths[i];
  if (S>0) and (S<DW-LeftSpace-RightSpace) then f:=(DW-LeftSpace-RightSpace-30)/S;
//  WriteLN('f is ', f);
  for i:=0 to 5 do ColWidths[i]:=Round(ColWidths[i]*f);

  X.Font.Height:=GlobalInvFontHeight;
  X.Font.Name:='Arial';
  PC:=0;
  Pos:=TopSpace;
  LPos:=LeftSpace;
  X.Font.Style:=[fsBold];
  if Assigned(ParentElements.Translator) then begin
    // First 3 Left
    for i:=0 to 2 do begin
      if (i=2) and not GlobalInvPictures then Break;
      X.TextOut(LPos, -Round(Pos), ParentElements.Translator.GetStr('[PECol'+IntToStr(i)+']'));
      INC(LPos,ColWidths[i]);
    end;
    // second 3 center
    for i:=3 to 5 do begin
      St:=ParentElements.Translator.GetStr('[PECol'+IntToStr(i)+']');
      X.TextOut(LPos+(ColWidths[i]-X.TextWidth(St)) DIV 2, -Round(Pos), St);
      INC(LPos,ColWidths[i]);
    end;
  end;
  INC(Pos, GlobalInvHeight);
  X.MoveTo(LeftSpace, -Pos);  X.LineTo(DW-RightSpace, -Pos);
	INC(Pos, GlobalInvHeight);

  X.Font.Style:=[];

  for i:=0 to MyPlan.inventory.List.count-1 do begin
    if Pos+GlobalInvHeight>=DH-BottomSpace-GlobalInvHeight then begin
      if i<MyPlan.inventory.List.count-1 then begin
        Pos:=TopSpace; INC(PC);
        // need to Lines for header
        INC(Pos, GlobalInvHeight);
        INC(Pos, GlobalInvHeight);
      end;
    end;
    if PC=PG then begin
      TIE:=MyPlan.inventory.List[i];
      if Assigned(TIE) then begin
        LPos:=LeftSpace;

        X.TextOut(LPos, -Round(Pos), TIE.module);
        INC(LPos,ColWidths[0]);

        X.TextOut(LPos, -Round(Pos), TIE.Element);
        INC(LPos,ColWidths[1]);

        if GlobalInvPictures then begin
          ShowPreview(X, LPos+1, -Round(Pos+GlobalInvHeight*0.9), Round(ColWidths[2]*0.9), Round(GlobalInvHeight*0.9), TIE.module, TIE.Element, TRUE);
          INC(LPos,ColWidths[2]);
        end;

        St:=IntToStr(TIE.Has);
        X.TextOut(LPos+(ColWidths[3]-X.TextWidth(St)) DIV 2, -Round(Pos), St);
        INC(LPos,ColWidths[3]);

        St:=IntToStr(TIE.count);
        X.TextOut(LPos+(ColWidths[4]-X.TextWidth(St)) DIV 2, -Round(Pos), St);
        INC(LPos,ColWidths[4]);

        if TIE.Has-TIE.count<0 then X.Font.Style:=[fsBold];
        St:=IntToStr(TIE.Has-TIE.count);
        X.TextOut(LPos+(ColWidths[5]-X.TextWidth(St)) DIV 2, -Round(Pos), St);
				// only Status change if Really neccessary
        if TIE.Has-TIE.count<0 then X.Font.Style:=[];
      end;
    end;
    INC(Pos, GlobalInvHeight);
  end;
  X.MoveTo(LeftSpace, -(DH-BottomSpace));  X.LineTo(DW-RightSpace, -(DH-BottomSpace));
end;

procedure TPlanWindow.PrintBTNClick(Sender: TObject);
var Preview:TPreviewForm;
begin
// Print inventory
  Preview:=TPreviewForm.Create(Self);
  Preview.Pageprinter:=TRUE;
  Preview.Info.Name:=ExtractFileName(CurrentFileName)+' ('+TransStr('[inventory]')+')';
  Preview.Info.Author:=MyPlan.Info.Author;
  Preview.Title:='RAILY - '+ExtractFileName(CurrentFileName)+' ('+TransStr('[inventory]')+')';
  Preview.GetPageCount:=InventoryPageCount;
  Preview.OutPagePrinter:=InventoryPagePrint;
  Preview.CheckRange;
  Preview.ShowModal;
  Preview.Destroy;
end;

procedure TPlanWindow.ExportBTNClick(Sender: TObject);
var f       : TextFile;
    i, t    : integer;
    S       : string;
const xs    : array [0..4] of integer=(26, 21, 11, 11, 11);
begin
  if ExportInvDLG.Execute then begin
    try
      AssignFile(f, ExportInvDLG.Filename);
      Rewrite(f);

      if GlobalInvHeader then begin
        t:=0; S:='';
        for i:=0 to 1 do begin
          S:=S+ParentElements.Translator.GetStr('[PECol'+IntToStr(i)+']');
					t:=t+xs[i]; while Length(S)< t do S:=S+' ';
        end;
        for i:=2 to 4 do begin
          S:=S+ParentElements.Translator.GetStr('[PECol'+IntToStr(i+1)+']');
          t:=t+xs[i]; while Length(S)< t do S:=S+' ';
        end;
        WriteLN(f, S);
        S:=''; for i:=0 to 79 do S:=S+'=';
        WriteLN(f, S);
        WriteLN(f);
      end;

      for i:=0 to MyPlan.inventory.List.count-1 do begin
        {if TInventoryListEntry(MyPlan.inventory.List[i]).Has>0 then begin}
          S:=TInventoryListEntry(MyPlan.inventory.List[i]).module;
          while Length(S)< xs[0] do S:=S+' ';
          S:=S+TInventoryListEntry(MyPlan.inventory.List[i]).Element;
          while Length(S)< xs[0]+xs[1]  do S:=S+' ';
          S:=S+IntToStr(TInventoryListEntry(MyPlan.inventory.List[i]).Has);
          while Length(S)< xs[0]+xs[1]+xs[2] do S:=S+' ';
          S:=S+IntToStr(TInventoryListEntry(MyPlan.inventory.List[i]).count);
          while Length(S)< xs[0]+xs[1]+xs[2]+xs[3] do S:=S+' ';
          S:=S+IntToStr(TInventoryListEntry(MyPlan.inventory.List[i]).Has-TInventoryListEntry(MyPlan.inventory.List[i]).count);
          WriteLN(f, S);
      end;
      if GlobalInvHeader then begin
        WriteLN(f);
        S:=''; for i:=0 to 79 do S:=S+'=';
        WriteLN(f, S);
      end;
      CloseFile(f);
    except Inform(TransStr('[Export failed]')) end;
  end;

end;

procedure TPlanWindow.OpenInvBTNClick(Sender: TObject);
var f       : TextFile;
    M, E, S : string;
    C       : integer;
begin
  if LoadInvDLG.Execute then begin
    MyPlan.inventory.Reset;
    try
      AssignFile(f, LoadInvDLG.Filename);
      Reset(f);
      ReadLn(f, S);
      if Trim(UpperCase(S))<>Trim(UpperCase(InventoryIDString)) then begin
        Inform(TransStr('[Illegal inventory file]'));
        exit;
      end;
      while not EOF(f) do begin
        ReadLn(f, M);
        ReadLn(f, E);
        ReadLn(f, S);
        try C:=StrToInt(S) except C:=0; end;
        MyPlan.inventory.Has(M, E, C);
      end;
      CloseFile(f);
    except end;
  end;
  UpdateInventorySheet;
end;

procedure TPlanWindow.SaveInvBTNClick(Sender: TObject);
var f       : TextFile;
    i       : integer;
begin
  if SaveInvDLG.Execute then begin
    try
      AssignFile(f, SaveInvDLG.Filename);
      Rewrite(f);
      WriteLN(f, InventoryIDString);
      for i:=0 to MyPlan.inventory.List.count-1 do begin
        if TInventoryListEntry(MyPlan.inventory.List[i]).Has>0 then begin
          WriteLN(f, TInventoryListEntry(MyPlan.inventory.List[i]).module);
          WriteLN(f, TInventoryListEntry(MyPlan.inventory.List[i]).Element);
          WriteLN(f, IntToStr(TInventoryListEntry(MyPlan.inventory.List[i]).Has));
        end;
      end;
			CloseFile(f);
    except end;
  end;
end;

procedure TPlanWindow.Undo;
begin
  if PlacingElements then begin AbortPlace; exit; end;
  StopFX;
  MyPlan.Undo;
  Plan.Invalidate;
  if Assigned(ParentElements.Overview) then ParentElements.Overview.Invalidate;
end;

procedure TPlanWindow.Flex1Click(Sender: TObject);
var i:integer;
    TInst:TInstance;
    XA:TPrepAddInstance;
    XD:TPrepDelInstance;
begin
  StopFX;
  for i:=0 to MyPlan.Selected.Size-1 do begin
    if MyPlan.Selected[i] then begin
      if MyPlan.GetElement(i, TInst) then begin
// Undo part
        MyPlan.UndoHelper.Open;
        XA:=TPrepAddInstance.Create;
        MyPlan.UndoHelper.AddState(XA);
        TInst.ToStream(XA.Backup);
        XD:=TPrepDelInstance.Create;
        XD.DeathCandidate:=TInst.ID;
        MyPlan.UndoHelper.AddState(XD);
        MyPlan.UndoHelper.Close;
// end of Undo part
        TInst.MakeFlex;
        EditFlex(TRUE);
        if Assigned(ParentElements_ChooseBTN) then ParentElements_ChooseMode(2);
      end;
      exit;
    end;
	end;
end;

procedure TPlanWindow.Retranslate;
begin
  if Assigned(ParentElements.Translator) then ParentElements.Translator.TranslateMDI(Self);
  if Assigned(ParentElements.Status) then ParentElements.Status.Invalidate
end;

procedure TPlanWindow.ColorDialog;
var i:integer;
    XC:TPrepColorUndo;
begin
  for i:=0 to MyPlan.InstanceElements.count-1 do
    if MyPlan.Selected[i] and Assigned(MyPlan.InstanceElements[i]) then
       ColorDialog1.Color:=TInstance(MyPlan.InstanceElements[i]).Color;
  if ColorDialog1.Execute and (ColorDialog1.Color<>clRed) then begin
    MyPlan.IsSaved:=FALSE;
    MyPlan.UndoHelper.Open;
    CurrentColor:=ColorDialog1.Color;
    if Assigned(ParentElements.Preview) then ParentElements.Preview.Invalidate;
    for i:=0 to MyPlan.InstanceElements.count-1 do
      if MyPlan.Selected[i] and Assigned(MyPlan.InstanceElements[i]) then begin
// Undo part
        XC:=TPrepColorUndo.Create;
        XC.Candidate:=TInstance(MyPlan.InstanceElements[i]).ID;
        XC.Color:=TInstance(MyPlan.InstanceElements[i]).Color;
        MyPlan.UndoHelper.AddState(XC);
// end of Undo part
         TInstance(MyPlan.InstanceElements[i]).Color:=ColorDialog1.Color;
      end;
    Plan.Invalidate;
    MyPlan.UndoHelper.Close;
  end;
end;

procedure TPlanWindow.Color1Click(Sender: TObject);
begin
  ColorDialog;
end;

procedure TPlanWindow.AuthorEditChange(Sender: TObject);
begin
  StrPCopy(MyPlan.Info.Author, AuthorEdit.Text);
end;

procedure TPlanWindow.RemarkMemoChange(Sender: TObject);
begin
  RemarkMemo.GetTextBuf(MyPlan.Info.Remark, 127);
end;

procedure TPlanWindow.ExportLines(N:string);
var X:TLineExport;
    i:integer;
    TempCursor:TCursor;
   // added by Barnoid
    t : TUserTextEntry;
    P1, P2: TPointObject;
    // that'S it
begin

  TempCursor:=Screen.Cursor;
  Screen.Cursor:=crHourglass;
  GlobalProgressBar.Visible:=TRUE;

  if UpperCase(ExtractFileExt(N))='.DXF' then begin
    X:=TDXF.Create;
  end else begin
    X:=THPGL.Create;
  end;
  X.CreateFile(N);
  MyPlan.CalcRectAround;
  X.SetRectAround(MyPlan.UL.X, MyPlan.UL.Y, MyPlan.LR.X, MyPlan.LR.Y);
  for i:=0 to MyPlan.InstanceElements.count-1 do begin
    GlobalProgressBar.Position:=Round(100*i/MyPlan.InstanceElements.count);
    if Assigned(MyPlan.InstanceElements[i]) then begin
      TInstance(MyPlan.InstanceElements[i]).ExportLines(X, 0, 0, 1, 1, FALSE, @MyPlan.DrawInfo);
		end
  end;
  // added by Barnoid
	// habe meinen Stil extra dem Deinen angepasst !!! (z.B. 'BEGIN' (ach wie hsslich) anstatt 'begin')
	// 2002 --> habe meinen Stil jetzt deinem angepasst ;-)
	X.SetPen(1);
	if GlobalPlanUserTXT then begin
		for i:=0 to MyPlan.UserTexts.count-1 do begin
			// 's hat sicher nicht so viele UserTexts, daher ist'd nicht schlimm, wenn der Progressbar schlft
			if Assigned(MyPlan.UserTexts[i]) then begin
				t := TUserTextEntry(MyPlan.UserTexts[i]);
				X.TextOut(t.P.X, t.P.Y, 0, 0, t.S, GlobalUserTXTHeight DIV 2); // Textgrsse DIV 2 wird am besten
			end;
		end;
	end;

	for i:=0 to MyPlan.TablePolygon.count-1 do begin
		P1 := TPointObject(MyPlan.TablePolygon[i]);
		P2 := TPointObject(MyPlan.TablePolygon[(i+1) MOD MyPlan.TablePolygon.count]);
		if Assigned(P1) and Assigned(P2) then begin
			X.MoveTo(P1.P.X, P1.P.Y);
			X.LineTo(P2.P.X, P2.P.Y);
		end;
	end;
	// that's it

	X.CloseFile;
	X.Free;

	Screen.Cursor:=TempCursor;
	GlobalProgressBar.Visible:=FALSE;
	GlobalProgressBar.Position:=0;

end;

procedure TPlanWindow.Insertpoint1Click(Sender: TObject);
begin
	InsertTablePoint;
end;

procedure TPlanWindow.Deletepoint1Click(Sender: TObject);
begin
  DeleteTablePoint;
end;

procedure TPlanWindow.ClearTable1Click(Sender: TObject);
begin
  ClearTable;
end;

procedure TPlanWindow.Standardtable1Click(Sender: TObject);
begin
  BuildStandardTable;
  ShowAll;
end;

procedure TPlanWindow.OptionsChanged;
var i:integer;
begin
  for i:=0 to MyPlan.InstanceElements.count-1 do begin
    if Assigned(MyPlan.InstanceElements[i])
       and TInstance(MyPlan.InstanceElements[i]).IsFlex then
         TInstance(MyPlan.InstanceElements[i]).FlexAddition.Calculate;
  end;
  if Assigned(ParentElements.Preview) then ParentElements.Preview.Invalidate;
  if TextEditing then RescanAllTexts;
  Plan.Invalidate;
end;

procedure TPlanWindow.Addpoint1Click(Sender: TObject);
begin
  if FlexEditing and Assigned(CurrentFlexInst) and (CurrentFlexInst.CacheElement.Info.TheType=FlexElement) then begin
    CurrentFlexInst.FlexAddition.AddPoint(SelFlexPoint);
    CurrentFlexInst.FlexAddition.Calculate;
    Plan.Invalidate;
  end;
end;

procedure TPlanWindow.DeleteFlexPointClick(Sender: TObject);
begin
  if FlexEditing and Assigned(CurrentFlexInst) and (CurrentFlexInst.CacheElement.Info.TheType=FlexElement) then begin
		CurrentFlexInst.FlexAddition.DeletePoint(SelFlexPoint);
    CurrentFlexInst.FlexAddition.Calculate;
    Plan.Invalidate;
  end;
end;


function TPlanWindow.SavePlan:boolean;
begin
  if (CurrentFileName='') or (IsReadOnly(CurrentFileName)) then begin
    SavePlanDLG.Options:=SavePlanDLG.Options+[ofOverwritePrompt];
    SavePlanDLG.InitialDir:=GlobalWorkPath;
    if SavePlanDLG.Execute then begin
      Result:=Save(SavePlanDLG.Filename);
    end else Result:=FALSE;
  end else begin
    Result:=Save(CurrentFileName);
  end;
end;

procedure TPlanWindow.SaveAs;
begin
  SavePlanDLG.Options:=SavePlanDLG.Options+[ofOverwritePrompt];
  SavePlanDLG.Filename:=CurrentFileName;
  SavePlanDLG.InitialDir:=GlobalWorkPath;
  if SavePlanDLG.Execute then begin
    Save(SavePlanDLG.Filename);
  end;
end;

procedure TPlanWindow.FormDeactivate(Sender: TObject);
begin
  if Assigned(ParentElements_InfoFloaterVisible) then ParentElements_InfoFloaterVisible(FALSE);
end;

procedure TPlanWindow.ResetTextPositions;
var i:integer;
begin
  MyPlan.IsSaved:=FALSE;
  for i:=0 to MyPlan.InstanceElements.count-1 do
		if Assigned(MyPlan.InstanceElements[i]) then TInstance(MyPlan.InstanceElements[i]).ResetNamePosition;
end;


procedure TPlanWindow.Showfullname1Click(Sender: TObject);
var i:integer;
begin
  for i:=0 to MyPlan.InstanceElements.count-1 do
		if Assigned(MyPlan.InstanceElements[i]) and MyPlan.Selected[i] then
      TInstance(MyPlan.InstanceElements[i]).Status:=(TInstance(MyPlan.InstanceElements[i]).Status or CShowFullNames or CShowRailNames);
  Plan.Invalidate;
end;

procedure TPlanWindow.Showshortname1Click(Sender: TObject);
var i:integer;
begin
  for i:=0 to MyPlan.InstanceElements.count-1 do
    if Assigned(MyPlan.InstanceElements[i]) and MyPlan.Selected[i] then
      TInstance(MyPlan.InstanceElements[i]).Status:=(TInstance(MyPlan.InstanceElements[i]).Status and (not CShowFullNames) or CShowRailNames);
  Plan.Invalidate;
end;

procedure TPlanWindow.Noname1Click(Sender: TObject);
var i:integer;
begin
  for i:=0 to MyPlan.InstanceElements.count-1 do
    if Assigned(MyPlan.InstanceElements[i]) and MyPlan.Selected[i] then
      TInstance(MyPlan.InstanceElements[i]).Status:=(TInstance(MyPlan.InstanceElements[i]).Status and (not CShowFullNames) and (not CShowRailNames));
  Plan.Invalidate;
end;

procedure TPlanWindow.Resetposition1Click(Sender: TObject);
var i:integer;
begin
  MyPlan.IsSaved:=FALSE;
  for i:=0 to MyPlan.InstanceElements.count-1 do
    if Assigned(MyPlan.InstanceElements[i]) and MyPlan.Selected[i]  then
      TInstance(MyPlan.InstanceElements[i]).ResetNamePosition;
  Plan.Invalidate;
end;

procedure TPlanWindow.NewAngle;
begin
  QueryDouble.QLabel.Caption:=TransStr('[Enter new angle]');
  QueryDouble.Caption:=TransStr('[change angle]');
  QueryDouble.Value:=(-UserRotation/pi)*180;
  if QueryDouble.ShowModal=mrOk then begin
    UserRotation:=(-QueryDouble.Value/180)*pi;
		CursorAngle:=FixedAngle(UserRotation);
    if MousePositioning then NextOldPlace;
    if Assigned(ParentElements.Status) then ParentElements.Status.Invalidate;
    Plan.Invalidate;
  end;
end;

procedure TPlanWindow.SelectLayers;
var S, TS: string;
    i, l : integer;
    Nr   : integer;
begin
  S:=TransStr('[Layer]');
  LayerSelectionDLG.SrcList.Clear;
  LayerSelectionDLG.DstList.Clear;
  for i:=0 to MyPlan.Layers.Size-1 do begin
    if MyPlan.Layers[i] then LayerSelectionDLG.SrcList.Items.Add(S+' '+IntToStr(i))
                        else LayerSelectionDLG.DstList.Items.Add(S+' '+IntToStr(i));
  end;
  if LayerSelectionDLG.ShowModal = mrOk then begin
    l:=Length(S);
    MyPlan.ShowAllLayers;
    for i:=0 to LayerSelectionDLG.DstList.Items.count-1 do begin
      TS:=LayerSelectionDLG.DstList.Items[i];
      Delete(TS, 1, l);
      Nr:=StrToInt(Trim(TS));
      if (Nr>=0) and (Nr<MyPlan.Layers.Size) then MyPlan.Layers[Nr]:=FALSE;
    end;
    Plan.Invalidate;
  end;
end;


procedure TPlanWindow.Layer1Click(Sender: TObject);
var i:integer;
begin
  LayerDialog.LayerEdit.Value:=CurrentLayer;
  if LayerDialog.ShowModal=mrOk then begin
    MyPlan.IsSaved:=FALSE;
    CurrentLayer:=LayerDialog.LayerEdit.Value;
		for i:=0 to MyPlan.InstanceElements.count-1 do
      if Assigned(MyPlan.InstanceElements[i]) and MyPlan.Selected[i]  then
        TInstance(MyPlan.InstanceElements[i]).Layer:=CurrentLayer;
    MyPlan.ClearSelection;
    Plan.Invalidate;
  end;
end;

procedure TPlanWindow.NewUserText;
var t:TUserTextEntry;
begin
  if TextEditing then begin
    NewTextDLG.TextEdit.Text:=CurrentText;
    NewTextDLG.TextEdit.SelStart:=0;
    NewTextDLG.TextEdit.SelLength:=Length(CurrentText);
    if NewTextDLG.ShowModal = mrOk then begin
      t:=TUserTextEntry.Create;
      t.S:=NewTextDLG.TextEdit.Text;
      t.P:=CursorPos;
      MyPlan.UserTexts.Add(t);
      RescanAllTexts;
      Plan.Invalidate;
    end;
  end;
end;

procedure TPlanWindow.EditUserText;
begin
  if CurrentTextNr>=0 then begin
    if TextEditing then begin
      NewTextDLG.TextEdit.Text:=CurrentText;
      NewTextDLG.TextEdit.SelStart:=Length(CurrentText);
			NewTextDLG.TextEdit.SelLength:=0;
      if NewTextDLG.ShowModal = mrOk then begin
        TUserTextEntry(MyPlan.UserTexts[CurrentTextNr]).S:=NewTextDLG.TextEdit.Text;
        RescanAllTexts;
        Plan.Invalidate;
      end;
    end;
  end;
end;

procedure TPlanWindow.DeleteuserText;
begin
  if CurrentTextNr>=0 then begin
    try try
      TUserTextEntry(MyPlan.UserTexts[CurrentTextNr]).Free;
      MyPlan.UserTexts.Delete(CurrentTextNr);
      MyPlan.UserTexts.Pack;
    finally
      CurrentTextNr:=-1;
      SelTextNr:=-1;
      CTextA.X:=0; CTextA.Y:=0;
      CTextB.X:=0; CTextB.Y:=0;
      RescanAllTexts;
      Plan.Invalidate;
    end;
    except
    end;
  end;
end;

procedure TPlanWindow.NewText1Click(Sender: TObject);
begin
  NewUserText;
end;

procedure TPlanWindow.DeleteText1Click(Sender: TObject);
begin
  DeleteuserText;
end;

procedure TPlanWindow.EditText1Click(Sender: TObject);
begin
  EditUserText;
end;

procedure TPlanWindow.AllToMeta;
begin
  MyPlan.AllToMeta;
end;

function TPlanWindow.AskIfModDifferenceOk(S1, S2:string; P:TDoublePoint):boolean;
begin
  StopFX;
  RailyFX.AddFX(TLinkedTogetherFX.Create(P, 50, 100, 1, clRed));
  RailyFX.AddFX(TLinkedTogetherFX.Create(P, 40, 100, 1, clPurple));
  RailyFX.AddFX(TLinkedTogetherFX.Create(P, 30, 100, 1, clFuchsia));
  RailyFX.AddFX(TLinkedTogetherFX.Create(P, 20, 100, 2, clYellow));
  Result:=Confirm(TransStr('[Incompatible Modules]')+' ('+S1+'  -  '+S2+').  '+TransStr('[Link anyway]'));
  StopFX;
end;

function TPlanWindow.AskIfSystemDifferenceOk(S1, S2:string; P:TDoublePoint):boolean;
begin
  StopFX;
  RailyFX.AddFX(TLinkedTogetherFX.Create(P, 50, 100, 1, clRed));
  RailyFX.AddFX(TLinkedTogetherFX.Create(P, 40, 100, 1, clPurple));
  RailyFX.AddFX(TLinkedTogetherFX.Create(P, 30, 100, 1, clFuchsia));
  RailyFX.AddFX(TLinkedTogetherFX.Create(P, 20, 100, 2, clYellow));
  Result:=Confirm(TransStr('[Incompatible Systems]')+' ('+S1+'  -  '+S2+').  '+TransStr('[Link anyway]'));
  StopFX;
end;

procedure TPlanWindow.AuthorEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   MyPlan.IsSaved:=FALSE;
   IsNotSavedLBL.Visible:=TRUE;
end;


end.
